SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL';

DROP VIEW IF EXISTS `nfaqp_v` ;
DROP VIEW IF EXISTS `qp_v` ;
DROP VIEW IF EXISTS `si_qp_descr_v` ;
DROP VIEW IF EXISTS `si_qp_values_v` ;
DROP VIEW IF EXISTS `source_qp_domain_v` ;
DROP TABLE IF EXISTS `MappedComponentsAndStructures` ;
DROP TABLE IF EXISTS `MappedMessageTypes` ;
DROP TABLE IF EXISTS `ComponentsAndStructuresMappings` ;
DROP TABLE IF EXISTS `MessageTypesMappings` ;
DROP TABLE IF EXISTS `RepresentativeComponentsAndStructures` ;
DROP TABLE IF EXISTS `RepresentativeMessageTypes` ;
DROP TABLE IF EXISTS `RepresentativeMessages` ;
DROP TABLE IF EXISTS `RepresentativeOperations` ;
DROP TABLE IF EXISTS `QPPropertiesNames` ;
DROP TABLE IF EXISTS `QPRankings` ;
DROP TABLE IF EXISTS `NFAbstractionsRanges` ;
DROP TABLE IF EXISTS `NFANonFuncDescriptions` ;
DROP TABLE IF EXISTS `MappedMessages` ;
DROP TABLE IF EXISTS `MessagesMappings` ;
DROP TABLE IF EXISTS `MappedOperations` ;
DROP TABLE IF EXISTS `OperationsMappings` ;
DROP TABLE IF EXISTS `MappedInterfaces` ;
DROP TABLE IF EXISTS `RepresentativeInterfaces` ;
DROP TABLE IF EXISTS `Hier_Edges` ;
DROP TABLE IF EXISTS `InterfacesMappings` ;
DROP TABLE IF EXISTS `RepresentedInstances` ;
DROP TABLE IF EXISTS `RepresentedInterfaces` ;
DROP TABLE IF EXISTS `Abstractions` ;
DROP TABLE IF EXISTS `Hierarchies` ;
DROP TABLE IF EXISTS `ComponentsAndStructures` ;
DROP TABLE IF EXISTS `MessageTypes` ;
DROP TABLE IF EXISTS `Messages` ;
DROP TABLE IF EXISTS `Operations` ;
DROP TABLE IF EXISTS `PropertiesValues` ;
DROP TABLE IF EXISTS `NonFuncDescriptions` ;
DROP TABLE IF EXISTS `QualityProperties` ;
DROP TABLE IF EXISTS `ServiceInstances` ;
DROP TABLE IF EXISTS `ServiceInterfaces` ;
DROP TABLE IF EXISTS `ServiceTypes` ;
DROP TABLE IF EXISTS `DocOfFuncProperties` ;
DROP TABLE IF EXISTS `ServiceSources` ;
DROP TABLE IF EXISTS `ServiceCollections` ;


CREATE  TABLE IF NOT EXISTS `ServiceCollections` (
  `C_ID` INT NOT NULL,
  PRIMARY KEY (`C_ID`) )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `ServiceSources` (
  `SS_ID` INT NOT NULL AUTO_INCREMENT,
  `SS_REF2SOURCE_ID` VARCHAR(350) NOT NULL ,
  `SS_PARSED_FD` INT NULL ,
  `SS_PARSEABLE_FD` INT NULL ,
  `SS_SC_ID` INT NOT NULL ,
  PRIMARY KEY (`SS_ID`) ,
  CONSTRAINT `SSSC_ID`
    FOREIGN KEY (`SS_SC_ID`)
    REFERENCES `ServiceCollections` (`C_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
   )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `DocOfFuncProperties` (
  `DOCFUNCPROPS_ID` INT NOT NULL AUTO_INCREMENT,
  `DOCFUNCPROPS_REF2DOCOFFUNCPROPS_ID` VARCHAR(250) NOT NULL ,
  `DOCFUNCPROPS_HAS_XML_SCHEMAS` BOOLEAN ,
  `DOCFUNCPROPS_SS_ID` INT NOT NULL ,
  PRIMARY KEY (`DOCFUNCPROPS_ID`) ,
  CONSTRAINT `DOCFUNCPROPSSS_ID`
    FOREIGN KEY (`DOCFUNCPROPS_SS_ID`)
    REFERENCES `ServiceSources` (`SS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
   )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `ServiceTypes` (
  `ST_ID` INT NOT NULL AUTO_INCREMENT,
  `ST_NAME` VARCHAR(45) NOT NULL ,
  `ST_PROFILE` VARCHAR(150) NULL ,
  `ST_STYLE` VARCHAR(45) NULL ,
  `ST_SPEC` VARCHAR(150) NULL ,
  `ST_DOCFUNCPROPS_ID` INT NOT NULL ,
  PRIMARY KEY (`ST_ID`),
  CONSTRAINT `STDOCFUNCPROPS_ID`
    FOREIGN KEY (`ST_DOCFUNCPROPS_ID`)
    REFERENCES `DocOfFuncProperties` (`DOCFUNCPROPS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
   )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `ServiceInterfaces` (
  `SI_ID` INT NOT NULL AUTO_INCREMENT,
  `SI_NAME` VARCHAR(45) NOT NULL ,
  `SI_PROFILE` VARCHAR(45) NULL ,
  `SI_BEHAV` VARCHAR(500) NULL ,
  `SI_CONSTR` VARCHAR(45) NULL ,
  `SI_ST_ID` INT NOT NULL ,
  PRIMARY KEY (`SI_ID`) ,
  CONSTRAINT `SIST_ID`
    FOREIGN KEY (`SI_ST_ID`)
    REFERENCES `ServiceTypes` (`ST_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `ServiceInstances` (
  `SIS_ID` INT NOT NULL AUTO_INCREMENT,
  `SIS_NAME` VARCHAR(45) NOT NULL ,
  `SIS_PROTO` VARCHAR(45) NULL ,
  `SIS_URI` VARCHAR(150) NULL ,
  `SIS_IMP_DET` VARCHAR(150) NULL ,
  `SIS_REQS` VARCHAR(150) NULL ,
  `SIS_SI_ID` INT NOT NULL ,
  PRIMARY KEY (`SIS_ID`) ,
  CONSTRAINT `SISSI_ID` 
    FOREIGN KEY (`SIS_SI_ID`)
    REFERENCES `ServiceInterfaces` (`SI_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `QualityProperties` (
  `QP_ID` INT NOT NULL AUTO_INCREMENT,
  `QP_SOURCE_NAME`	VARCHAR(250) ,
  `QP_SIS_ID` INT NOT NULL ,
  PRIMARY KEY (`QP_ID`) ,
  CONSTRAINT `QPSIS_ID` 
    FOREIGN KEY (`QP_SIS_ID`)
    REFERENCES `ServiceInstances` (`SIS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `QPPropertiesNames` (
  `QPP_ID` INT NOT NULL AUTO_INCREMENT,
  `QPP_PROPERTY_NAME` VARCHAR(45) NULL ,
  `QPP_QP_ID` INT NOT NULL ,
  PRIMARY KEY (`QPP_ID`) ,
  CONSTRAINT `QPPQP_ID` 
    FOREIGN KEY (`QPP_QP_ID`)
    REFERENCES `QualityProperties` (`QP_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `QPRankings` (
  `QPD_ID` INT NOT NULL AUTO_INCREMENT,
  `QPD_RANKING` VARCHAR(45) NULL ,
  `QPD_QPP_ID` INT NOT NULL ,
  PRIMARY KEY (`QPD_ID`) , 
  CONSTRAINT `QPDQPP_ID` 
    FOREIGN KEY (`QPD_QPP_ID`)
    REFERENCES `QPPropertiesNames` (`QPP_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `NonFuncDescriptions` (
  `NF_ID` INT NOT NULL AUTO_INCREMENT,
  `NF_REF2SOURCE_ID` VARCHAR(150) NOT NULL ,
  `NF_REF2DOCOFFUNCPROPS` VARCHAR(350) , 
  `NF_STYPE_NAME` VARCHAR(45) , 
  `NF_SINSTANCE_NAME` VARCHAR(45) ,
  `NF_SIS_ID` INT NOT NULL ,
  PRIMARY KEY (`NF_ID`) ,
  CONSTRAINT `NFSIS_ID`
    FOREIGN KEY (`NF_SIS_ID`)
    REFERENCES `ServiceInstances` (`SIS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `PropertiesValues` (
  `PV_ID` INT NOT NULL AUTO_INCREMENT,
  `PV_PROPERTY_NAME` VARCHAR(45) NOT NULL ,
  `PV_VALUE` DOUBLE NULL , 
  `PV_NF_ID` INT NOT NULL ,
  PRIMARY KEY (`PV_ID`) ,
  CONSTRAINT `PVNF_ID`
    FOREIGN KEY (`PV_NF_ID`)
    REFERENCES `NonFuncDescriptions` (`NF_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE 
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `Operations` (
  `OP_ID` INT NOT NULL AUTO_INCREMENT,
  `OP_NAME` VARCHAR(45) NOT NULL ,
  `OP_PROFILE` VARCHAR(150) NULL ,
  `OP_PRE` VARCHAR(150) NULL ,
  `OP_POST` VARCHAR(150) NULL ,
  `OP_SI_ID` INT NOT NULL ,
  PRIMARY KEY (`OP_ID`) ,
  CONSTRAINT `OPSI_ID`
    FOREIGN KEY (`OP_SI_ID`)
    REFERENCES `ServiceInterfaces` (`SI_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `Messages` (
  `MS_ID` INT NOT NULL AUTO_INCREMENT,
  `MS_NAME` VARCHAR(45) NOT NULL ,
  `MS_HAS_MESS_TYPES` BOOLEAN ,
  `MS_TYPE` VARCHAR(45) NULL ,
  `MS_OP_ID` INT NOT NULL ,
  PRIMARY KEY (`MS_ID`) ,
  CONSTRAINT `MSOP_ID`
    FOREIGN KEY (`MS_OP_ID`)
    REFERENCES `Operations` (`OP_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MessageTypes` (
  `MT_ID` INT NOT NULL AUTO_INCREMENT,
  `MT_NAME` VARCHAR(45) NOT NULL ,
  `MT_PREFIX_TYPE` VARCHAR(45) ,
  `MT_TYPEKIND` VARCHAR(10) NULL ,
  `MT_TYPE` VARCHAR(30) NULL ,
  `MT_MS_ID` INT NOT NULL ,
  PRIMARY KEY (`MT_ID`) ,
  CONSTRAINT `MTMS_ID`
    FOREIGN KEY (`MT_MS_ID`)
    REFERENCES `Messages` (`MS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `ComponentsAndStructures` (
  `COM_ID` INT NOT NULL AUTO_INCREMENT,
  `COM_NAME` VARCHAR(50) NULL ,
  `COM_TYPE` VARCHAR(50) NULL ,
  `COM_TYPEKIND` VARCHAR(50) NULL ,
  `COM_ISGLOBAL` BOOLEAN NULL ,
  `COM_TAG_ATTRIBUTES` VARCHAR (500) NULL ,
  `COM_SCHEMA_PATH` VARCHAR (500) NULL ,
  `COM_CLASS_PATH` VARCHAR (500) NULL ,
  `COM_MODEL` VARCHAR (50) NULL ,
  `COM_IS_COMPONENT` BOOLEAN NULL ,
  `COM_MT_ID` INT NOT NULL ,
  PRIMARY KEY (`COM_ID`) ,
  CONSTRAINT `COMMT_ID`
    FOREIGN KEY (`COM_MT_ID`)
    REFERENCES `MessageTypes` (`MT_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `Hierarchies`(
  `H_ID` INT NOT NULL AUTO_INCREMENT,
  `H_C_ID` INT NULL ,
  `H_MODE` INT NULL,
  `H_DIST_CALC_ALGO` VARCHAR(45) NULL,
  PRIMARY KEY (`H_ID`) ,
  CONSTRAINT `HC_ID`
    FOREIGN KEY (`H_C_ID`)
    REFERENCES `ServiceCollections` (`C_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;

CREATE  TABLE IF NOT EXISTS `Abstractions` (
  `A_ID` INT NOT NULL AUTO_INCREMENT,
  `A_FA_ID` INT NULL ,
  `A_NFA_ID` INT NULL ,
  `A_TYPE` VARCHAR (45) NULL,
  `A_H_ID` INT NOT NULL,
  PRIMARY KEY (`A_ID`) , 
  CONSTRAINT `AH_ID`
    FOREIGN KEY (`A_H_ID`)
    REFERENCES `Hierarchies` (`H_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `Hier_Edges` (
  `AD_ID` INT NOT NULL AUTO_INCREMENT,
  `AD_ANC_ID` INT NOT NULL ,
  `AD_DES_ID` INT NOT NULL ,
  PRIMARY KEY (`AD_ID`) ,
  CONSTRAINT `ADANC_ID`
    FOREIGN KEY (`AD_ANC_ID`)
    REFERENCES `Abstractions` (`A_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `ADDES_ID`
    FOREIGN KEY (`AD_DES_ID`)
    REFERENCES `Abstractions` (`A_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


 CREATE  TABLE IF NOT EXISTS `RepresentedInterfaces` (
  `RI_ID` INT NOT NULL ,
  `RI_FA_ID` INT NULL ,
  PRIMARY KEY (`RI_ID`,`RI_FA_ID`) ,
  CONSTRAINT `RIFA_ID`
    FOREIGN KEY (`RI_FA_ID`)
    REFERENCES `Abstractions` (`A_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `RISI_ID`
    FOREIGN KEY (`RI_ID`)
    REFERENCES `ServiceInterfaces` (`SI_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;
 
 
CREATE  TABLE IF NOT EXISTS `RepresentedInstances` (
  `RIS_ID` INT NOT NULL ,
  `RIS_NFA_ID` INT NULL ,
  PRIMARY KEY (`RIS_ID`,`RIS_NFA_ID`) ,
  CONSTRAINT `RISNFA_ID`
    FOREIGN KEY (`RIS_NFA_ID`)
    REFERENCES `Abstractions` (`A_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `RISSIS_ID`
    FOREIGN KEY (`RIS_ID`)
    REFERENCES `ServiceInstances` (`SIS_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `RepresentativeInterfaces` (
  `RSI_ID` INT NOT NULL AUTO_INCREMENT,
  `RSI_NAME` VARCHAR(45) NOT NULL ,
  `RSI_PROFILE` VARCHAR(45) NULL ,
  `RSI_BEHAV` VARCHAR(45) NULL ,
  `RSI_CONSTR` VARCHAR(45) NULL ,
  `RSI_A_ID` INT NOT NULL ,
  PRIMARY KEY (`RSI_ID`) ,
  CONSTRAINT `IRSIA_ID`
    FOREIGN KEY (`RSI_A_ID`)
    REFERENCES `Abstractions` (`A_ID`)
    ON DELETE CASCADE
    ON UPDATE CASCADE
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `RepresentativeOperations` (
  `ROP_ID` INT NOT NULL AUTO_INCREMENT,
  `ROP_NAME` VARCHAR(45) NOT NULL ,
  `ROP_PROFILE` VARCHAR(150) NULL ,
  `ROP_PRE` VARCHAR(150) NULL ,
  `ROP_POST` VARCHAR(150) NULL ,
  `ROP_RSI_ID` INT NOT NULL ,
  PRIMARY KEY (`ROP_ID`) ,
  CONSTRAINT `ROPRSI_ID`
    FOREIGN KEY (`ROP_RSI_ID`)
    REFERENCES `RepresentativeInterfaces` (`RSI_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `RepresentativeMessages` (
  `RMS_ID` INT NOT NULL AUTO_INCREMENT,
  `RMS_NAME` VARCHAR(45) NOT NULL ,
  `RMS_HAS_MESS_TYPES` BOOLEAN ,
  `RMS_TYPE` VARCHAR(45) NULL ,
  `RMS_ROP_ID` INT NOT NULL ,
  PRIMARY KEY (`RMS_ID`) ,
  CONSTRAINT `RMSROP_ID`
    FOREIGN KEY (`RMS_ROP_ID`)
    REFERENCES `RepresentativeOperations` (`ROP_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `RepresentativeMessageTypes` (
  `RMT_ID` INT NOT NULL AUTO_INCREMENT,
  `RMT_NAME` VARCHAR(45) NOT NULL ,
  `RMT_PREFIX_TYPE` VARCHAR(45) ,
  `RMT_TYPEKIND` VARCHAR(30) NULL ,
  `RMT_TYPE` VARCHAR(30) NULL ,
  `RMT_RMS_ID` INT NOT NULL ,
  PRIMARY KEY (`RMT_ID`) ,
  CONSTRAINT `RMTRMS_ID`
    FOREIGN KEY (`RMT_RMS_ID`)
    REFERENCES `RepresentativeMessages` (`RMS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `RepresentativeComponentsAndStructures` (
  `RCOM_ID` INT NOT NULL AUTO_INCREMENT,
  `RCOM_NAME` VARCHAR(50) NULL ,
  `RCOM_TYPE` VARCHAR(50) NULL ,
  `RCOM_TYPEKIND` VARCHAR(50) NULL ,
  `RCOM_ISGLOBAL` BOOLEAN NULL ,
  `RCOM_TAG_ATTRIBUTES` VARCHAR (500) NULL ,
  `RCOM_SCHEMA_PATH` VARCHAR (500) NULL ,
  `RCOM_CLASS_PATH` VARCHAR (500) NULL ,
  `RCOM_MODEL` VARCHAR (50) NULL , 
  `RCOM_IS_COMPONENT` BOOLEAN NULL ,
  `RCOM_MT_ID` INT NOT NULL ,
  PRIMARY KEY (`RCOM_ID`) ,
  CONSTRAINT `RCOMMT_ID`
    FOREIGN KEY (`RCOM_MT_ID`)
    REFERENCES `RepresentativeMessageTypes` (`RMT_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `InterfacesMappings` (
  `IM_ID` INT NOT NULL AUTO_INCREMENT,
  `IM_DISTANCE` DOUBLE NULL ,
  `IM_FA_ID` INT NOT NULL , 
  PRIMARY KEY (`IM_ID`) ,
  CONSTRAINT `IMFA_ID`
    FOREIGN KEY (`IM_FA_ID`)
    REFERENCES `Abstractions` (`A_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MappedInterfaces` (
  `MI_ID` INT NOT NULL AUTO_INCREMENT,
  `MI_SI_ID` INT NULL ,
  `MI_RI_ID` INT NULL ,
  `MI_IM_ID` INT NOT NULL , 
  `MI_RSI_ID` INT NOT NULL , 
  PRIMARY KEY (`MI_ID`) ,
  CONSTRAINT `MISI_ID`
    FOREIGN KEY (`MI_SI_ID`)
    REFERENCES `ServiceInterfaces` (`SI_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MIRI_ID`
    FOREIGN KEY (`MI_RI_ID`)
    REFERENCES `RepresentativeInterfaces` (`RSI_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MIIM_ID`
    FOREIGN KEY (`MI_IM_ID`)
    REFERENCES `InterfacesMappings` (`IM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MIRSI_ID`
    FOREIGN KEY (`MI_RSI_ID`)
    REFERENCES `RepresentativeInterfaces` (`RSI_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `OperationsMappings` (
  `OM_ID` INT NOT NULL AUTO_INCREMENT,
  `OM_DISTANCE` DOUBLE NULL ,
  `OM_IM_ID` INT NOT NULL , 
  PRIMARY KEY (`OM_ID`) ,
  CONSTRAINT `OMIM_ID`
    FOREIGN KEY (`OM_IM_ID`)
    REFERENCES `InterfacesMappings` (`IM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MappedOperations` (
  `MO_ID` INT NOT NULL AUTO_INCREMENT,
  `MO_OP_ID` INT NULL ,
  `MO_ROP_ID` INT NULL ,
  `MO_OM_ID` INT NOT NULL , 
  `MO_RO_ID` INT NOT NULL ,
  PRIMARY KEY (`MO_ID`) ,
  CONSTRAINT `MOOP_ID`
    FOREIGN KEY (`MO_OP_ID`)
    REFERENCES `Operations` (`OP_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE , 
  CONSTRAINT `MOROP_ID`
    FOREIGN KEY (`MO_ROP_ID`)
    REFERENCES `RepresentativeOperations` (`ROP_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MOOM_ID`
    FOREIGN KEY (`MO_OM_ID`)
    REFERENCES `OperationsMappings` (`OM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MORO_ID`
    FOREIGN KEY (`MO_RO_ID`)
    REFERENCES `RepresentativeOperations` (`ROP_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MessagesMappings` (
  `MM_ID` INT NOT NULL AUTO_INCREMENT,
  `MM_DISTANCE` DOUBLE NULL ,
  `MM_TYPE` VARCHAR(5) NULL , 
  `MM_OM_ID` INT NOT NULL , 
  PRIMARY KEY (`MM_ID`) ,
  CONSTRAINT `MMOM_ID`
    FOREIGN KEY (`MM_OM_ID`)
    REFERENCES `OperationsMappings` (`OM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MappedMessages` (
  `MM_ID` INT NOT NULL AUTO_INCREMENT,
  `MM_MS_ID` INT NULL ,
  `MM_RM_ID` INT NULL ,
  `MM_MM_ID` INT NOT NULL , 
  `MM_RMS_ID` INT NOT NULL , 
  PRIMARY KEY (`MM_ID`) ,
  CONSTRAINT `MMMS_ID`
    FOREIGN KEY (`MM_MS_ID`)
    REFERENCES `Messages` (`MS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MMRM_ID`
    FOREIGN KEY (`MM_RM_ID`)
    REFERENCES `RepresentativeMessages` (`RMS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MMMM_ID`
    FOREIGN KEY (`MM_MM_ID`)
    REFERENCES `MessagesMappings` (`MM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MMRMS_ID`
    FOREIGN KEY (`MM_RMS_ID`)
    REFERENCES `RepresentativeMessages` (`RMS_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `NFANonFuncDescriptions` (
  `NFD_ID` INT NOT NULL AUTO_INCREMENT,
  `NFD_PROPERTY` VARCHAR(45) NOT NULL ,
  `NFD_VALUE` VARCHAR(45) NULL , 
  `NFD_NFA_ID` INT NOT NULL ,
  PRIMARY KEY (`NFD_ID`) ,
  CONSTRAINT `NFDNFA_ID`
    FOREIGN KEY (`NFD_NFA_ID`)
    REFERENCES `Abstractions` (`A_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `NFAbstractionsRanges` (
  `NFR_ID` INT NOT NULL AUTO_INCREMENT,
  `NFR_PROPERTY` VARCHAR(150) NOT NULL ,
  `NFR_VALUE_FROM` DOUBLE NULL , 
  `NFR_VALUE_TO` DOUBLE NULL ,
  `NFR_NFA_ID` INT NOT NULL ,
  PRIMARY KEY (`NFR_ID`) ,
  CONSTRAINT `NFRNFA_ID`
    FOREIGN KEY (`NFR_NFA_ID`)
    REFERENCES `Abstractions` (`A_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE  
  )
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MessageTypesMappings` (
  `MTM_ID` INT NOT NULL AUTO_INCREMENT,
  `MTM_DISTANCE` DOUBLE NULL ,
  `MTM_MM_ID` INT NOT NULL , 
  PRIMARY KEY (`MTM_ID`) ,
  CONSTRAINT `MTMMM_ID`
    FOREIGN KEY (`MTM_MM_ID`)
    REFERENCES `MessagesMappings` (`MM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `ComponentsAndStructuresMappings` (
  `CM_ID` INT NOT NULL AUTO_INCREMENT,
  `CM_DISTANCE` DOUBLE NULL ,
  `CM_MTM_ID` INT NULL , 
  `CM_CM_ID` INT NULL , 
  PRIMARY KEY (`CM_ID`) ,
  CONSTRAINT `CMMTM_ID`
    FOREIGN KEY (`CM_MTM_ID`)
    REFERENCES `MessageTypesMappings` (`MTM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE , 
  CONSTRAINT `CMCM_ID`
    FOREIGN KEY (`CM_CM_ID`)
    REFERENCES `ComponentsAndStructuresMappings` (`CM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MappedComponentsAndStructures` (
  `MC_ID` INT NOT NULL AUTO_INCREMENT,
  `MC_COM_ID` INT NULL ,
  `MC_RC_ID` INT NULL ,
  `MC_CM_ID` INT NOT NULL , 
  `MC_RCOM_ID` INT NOT NULL , 
  PRIMARY KEY (`MC_ID`) ,
  CONSTRAINT `MCCOM_ID`
    FOREIGN KEY (`MC_COM_ID`)
    REFERENCES `ComponentsAndStructures` (`COM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MCRC_ID`
    FOREIGN KEY (`MC_RC_ID`)
    REFERENCES `RepresentativeComponentsAndStructures` (`RCOM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MCCM_ID`
    FOREIGN KEY (`MC_CM_ID`)
    REFERENCES `ComponentsAndStructuresMappings` (`CM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MCRCOM_ID`
    FOREIGN KEY (`MC_RCOM_ID`)
    REFERENCES `RepresentativeComponentsAndStructures` (`RCOM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


CREATE  TABLE IF NOT EXISTS `MappedMessageTypes` (
  `MMT_ID` INT NOT NULL AUTO_INCREMENT,
  `MMT_MT_ID` INT NULL ,
  `MMT_RMST_ID` INT NULL ,
  `MMT_MTM_ID` INT NOT NULL , 
  `MMT_RMT_ID` INT NOT NULL , 
  PRIMARY KEY (`MMT_ID`) ,
  CONSTRAINT `MMTMT_ID`
    FOREIGN KEY (`MMT_MT_ID`)
    REFERENCES `MessageTypes` (`MT_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MMTRRMT_ID`
    FOREIGN KEY (`MMT_RMST_ID`)
    REFERENCES `RepresentativeMessageTypes` (`RMT_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MMTMTM_ID`
    FOREIGN KEY (`MMT_MTM_ID`)
    REFERENCES `MessageTypesMappings` (`MTM_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE ,
  CONSTRAINT `MMTRMT_ID`
    FOREIGN KEY (`MMT_RMT_ID`)
    REFERENCES `RepresentativeMessageTypes` (`RMT_ID` )
    ON DELETE CASCADE
    ON UPDATE CASCADE
	)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;


CREATE VIEW nfaqp_v AS (SELECT nfr_nfa_id as nfa_id, nfd_property as qp_name, nfd_value as qp_value, nfr_value_from as value_from, nfr_value_to as value_to
FROM nfabstractionsranges, nfanonfuncdescriptions
WHERE nfr_id = nfd_id);

CREATE VIEW qp_v as SELECT QPP_ID AS QP_ID, QPP_PROPERTY_NAME AS QP_NAME
FROM QPPropertiesNames;

CREATE VIEW si_qp_descr_v as SELECT qpp_property_name as qp_name, qp_source_name as recommender, qpd_ranking as ranking, qp_sis_id as sis_id
FROM qualityproperties, qprankings, qppropertiesnames
WHERE qp_id = qpp_qp_id and qpp_id = qpd_qpp_id;

CREATE VIEW si_qp_values_v as (SELECT nf_sis_id, pv_property_name as qp_name, pv_value as val, nf_ref2source_id as recommender
FROM nonfuncdescriptions, propertiesvalues
WHERE nf_id = pv_nf_id);

CREATE VIEW source_qp_domain_v as (SELECT nf_ref2source_id as recommender, pv_property_name as qp_name, min(pv_value) as value_from, max(pv_value) as value_to
FROM nonfuncdescriptions, propertiesvalues
WHERE nf_id = pv_nf_id 
GROUP BY nf_ref2source_id, pv_property_name);

