package org.ow2.choreos.abstractionBase;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;

import javax.swing.tree.DefaultMutableTreeNode;

import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.InterfacesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.nonFunctionalOrganization.propertyAndJointBasedGroups.JointGroup;
import org.ow2.choreos.serviceRegistration.ServiceRegistration;


public class FunctionalAbstractionWithNestedNFAbstractions extends FunctionalAbstraction{//This class is exclusively for the mode = 1!


	//Variables.
	private Hashtable<Integer, NonFunctionalAbstraction> nonFunctionalAbstractions;


	//Constructor.
	FunctionalAbstractionWithNestedNFAbstractions( String namesDistanceCalculatorAlgorithm, Integer functionalAbstractionID, List<FunctionalAbstraction> descenadants, InterfacesMapping interfacesMapping ){

		super( namesDistanceCalculatorAlgorithm, functionalAbstractionID, descenadants, interfacesMapping );
	}


	//Getters.
	NonFunctionalAbstraction lookUp( Integer nonFunctionalAbstractionID ){

		if( nonFunctionalAbstractions == null || nonFunctionalAbstractionID == null ) return null;

		return nonFunctionalAbstractions.get( nonFunctionalAbstractionID );
	}


	//Adding a non-functional abstraction.
	NonFunctionalAbstraction addAbstraction( Integer nonFunctionalAbstractionID, Integer ancestorID, JointGroup jointGroup ){

		NonFunctionalAbstraction nonFunctionalAbstractionAncestor = null;

		if( nonFunctionalAbstractions == null )
			nonFunctionalAbstractions = new Hashtable<Integer, NonFunctionalAbstraction>();

		else
			nonFunctionalAbstractionAncestor = lookUp( ancestorID );

		NonFunctionalAbstraction addedNonFunctionalAbstraction = new NonFunctionalAbstraction( nonFunctionalAbstractionID, jointGroup, nonFunctionalAbstractionAncestor );

		if( nonFunctionalAbstractionAncestor != null ) nonFunctionalAbstractionAncestor.addDescendant( addedNonFunctionalAbstraction );

		nonFunctionalAbstractions.put( nonFunctionalAbstractionID, addedNonFunctionalAbstraction );

		return addedNonFunctionalAbstraction;
	}


	//Visualization.
	DefaultMutableTreeNode visualize( Integer numOfRepresentedInterfaces ){//This function is to visualize only one functional abstraction with nested non-functional.

		Integer label = functionalAbstractionID - numOfRepresentedInterfaces + 1;

		DefaultMutableTreeNode child1 = new DefaultMutableTreeNode("Functional abstraction (" + label + ")");

		child1 = serviceInterface.visualize( child1 );

		if( interfacesMapping != null ){

			DefaultMutableTreeNode child11 = new DefaultMutableTreeNode("Mappings");
			child1.add( child11 );

			child11 = interfacesMapping.visualize( child11 );
		}

		for( int k = 0; descendants != null && k < descendants.size(); ++k )

			child1.add( descendants.get( k ).visualize( numOfRepresentedInterfaces ) );

		DefaultMutableTreeNode child11 = new DefaultMutableTreeNode("Represented service interfaces");
		child1.add( child11 );

		for( int k = 0; representedInterfaces != null && k < representedInterfaces.size(); ++k ){

			label = k + 1;

			child11 = representedInterfaces.get( k ).visualize( label, child11 );
		}

    	return child1;
	}

	DefaultMutableTreeNode visualize( ServiceRegistration serviceRegistration, Integer collectionID, Integer numOfRepresentedInterfaces, DefaultMutableTreeNode node ){//The variable 'numOfRepresentedInterfaces' holds the number of the represented interfaces in the whole hierarchy.

		Integer label = functionalAbstractionID - numOfRepresentedInterfaces + 1;

		DefaultMutableTreeNode child1 = new DefaultMutableTreeNode("Functional abstraction (" + label + ")");
		node.add(child1);

		for( int i = 0; descendants != null && i < descendants.size(); ++i )

			child1 = ( (FunctionalAbstractionWithNestedNFAbstractions) descendants.get(i) ).visualize( serviceRegistration, collectionID, numOfRepresentedInterfaces, child1 );

		if( nonFunctionalAbstractions != null){

			DefaultMutableTreeNode child2 = new DefaultMutableTreeNode("Nested non-functional hierarchy");

			for( Enumeration<Integer> e = nonFunctionalAbstractions.keys(); e.hasMoreElements(); ){

				Integer k = e.nextElement();

				if( nonFunctionalAbstractions.get( k ).ancestor == null )

					child2 = nonFunctionalAbstractions.get( k ).visualize( serviceRegistration, collectionID, child2);
			}

			child1.add(child2);
        }

    	return node;
	}
}
