package org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.serviceRepresentation.functional.schema;

import java.util.Map;

import org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.names.NamesDistanceCalculator;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.schema.ComponentsAndStructuresMapping;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.XMLBuiltInTypes;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


public class BuiltInComponentsDistanceCalculator  {


	public static ComponentsAndStructuresMapping calculate( String namesDistanceCalculator, Component c1, Component c2 ){

		return calculateLocally( namesDistanceCalculator, c1, c2, null, null ); 
	}

	public static ComponentsAndStructuresMapping calculate( String namesDistanceCalculator, Component c1, Component c2, Map<String, Object> indexOfTransformedObjectsPath1, Map<String, Object> indexOfTransformedObjectsPath2 ){

		return calculateLocally( namesDistanceCalculator, c1, c2, indexOfTransformedObjectsPath1, indexOfTransformedObjectsPath2 );
	}

	private static ComponentsAndStructuresMapping calculateLocally( String namesDistanceCalculator, Component c1, Component c2, Map<String, Object> indexOfTransformedObjectsPath1, Map<String, Object> indexOfTransformedObjectsPath2 ){

		double ND = XMLBuiltInTypes.getDistance( c1.getReferencedComponent().getType(), c2.getReferencedComponent().getType() ); PrintMessages.print( PrintMessages.mappingPrint, "Components/Structures distance: ND(" +  c1.getReferencedComponent().getType() + ", " +  c2.getReferencedComponent().getType() + ") = " + ND );


		double distance;

		if( ND == 1.0 ) distance = 1.0;

		else{

			double NED = NamesDistanceCalculator.calculate( namesDistanceCalculator, c1.getName(), c2.getName() ); PrintMessages.print( PrintMessages.mappingPrint, "Components/Structures distance: NED(" + c1.getName() + ", " + c2.getName() + ") = " + NED );

			distance = ( NED + ND ) / 2; PrintMessages.print( PrintMessages.mappingPrint, "Components/Structures distance: d(" + c1.getTag() + ", " + c2.getTag() + ") = " + distance );
		}


		if( distance == 1.0 ) return null;

		else{

			Object originalComponent1 = getOriginalObject( c1, indexOfTransformedObjectsPath1 );

			Object originalComponent2 = getOriginalObject( c2, indexOfTransformedObjectsPath2 );

			ComponentsAndStructuresMapping componentsAndStructuresMapping = new ComponentsAndStructuresMapping();

			componentsAndStructuresMapping.add( originalComponent1 );
			componentsAndStructuresMapping.add( originalComponent2 );
			componentsAndStructuresMapping.set( distance );

			return componentsAndStructuresMapping;
		}
	}

	private static Object getOriginalObject( Object comparedObject, Map<String, Object> indexOfTransformedObjectsPath ){

		Object originalObject = null;


		if( comparedObject != null ){

			String classPath = XMLSchemaRepresentationController.getSchemaPath( comparedObject );

			if( classPath != null ) originalObject = indexOfTransformedObjectsPath.get( classPath );
		}


		return originalObject;
	}
}
