package org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.interfaceMappingsToJTrees;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import org.ow2.choreos.serviceRepresentation.functional.Message;
import org.ow2.choreos.serviceRepresentation.functional.MessageType;
import org.ow2.choreos.serviceRepresentation.functional.Operation;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;

public class JTreeProducerImplV1 implements JTreeProducer {

	public JTree produceJTree(Object in) {
		if(in instanceof ServiceInterface)
			return new javax.swing.JTree(new javax.swing.tree.DefaultTreeModel(CreateNode((ServiceInterface)in)));
		else return new javax.swing.JTree(new javax.swing.tree.DefaultTreeModel(new DefaultMutableTreeNode("Undefined")));
	}
	
	private DefaultMutableTreeNode CreateNode(ServiceInterface serviceInterface){
		DefaultMutableTreeNode node = new DefaultMutableTreeNode(serviceInterface.getTag());
		if (serviceInterface.getOperations() != null) {
			for (Operation o:serviceInterface.getOperations()) {
				node.add(CreateNode(o));
			}
		}
		return node;
	}
	
	private DefaultMutableTreeNode CreateNode(Operation operation){
		DefaultMutableTreeNode node = new DefaultMutableTreeNode(operation.getTag());
		
		node.add(CreateNode(operation.getInMessage(),"Input"));
		node.add(CreateNode(operation.getOutMessage(),"Output"));
		return node;
	}
	
	private DefaultMutableTreeNode CreateNode(Message message, String text){
		DefaultMutableTreeNode node;
		if(message != null){
			node = new DefaultMutableTreeNode(text + " " + message.getTag());

			if( message.getMessageTypes() != null ){
				for(MessageType msgType:message.getMessageTypes()) 
					node.add(CreateNode(msgType));
			}
		}
		else node = new DefaultMutableTreeNode("Undefined " + text);
		
		return node;
	}
	
	private DefaultMutableTreeNode CreateNode(MessageType msgType){
		DefaultMutableTreeNode node = new DefaultMutableTreeNode(msgType.getTag());
		if (!msgType.getReferencedComponent().isBuiltInType()) {
			node.add(msgType.getReferencedComponent().visualize());
		}
		return node;
	}

}
