package org.ow2.choreos.abstractionDrivenServiceOrganization.nonFunctionalOrganization.propertyAndJointBasedGroups;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Map;

import javax.swing.JOptionPane;

import org.ow2.choreos.dataStructures.interval.Interval;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInstance;


/**
 * 
 * @author dathanas
 *
 */
public class JointGroup {

	//Variables.
	private Hashtable<String, String> qualifiers;//The qualifiers are indexed by the property names!
	@SuppressWarnings("unchecked")
	private Map<String, Interval> mappingsToRanges;//The ranges are indexed by the property names!

	private Map<Integer, ServiceInstance> representedServiceInstances;//It will never be NULL.

	private boolean empty = false;//If it is empty, the 'mappingsToRanges' attribute is null! It is the only attribute!

	//Constructor.
	public JointGroup( ){
		//JOptionPane.showMessageDialog(null, "New Joint group object!");
	}

	//Setters.
	public void addQualifier( String property, String qualifier ){

		if( qualifiers == null ) qualifiers = new Hashtable<String, String>();

		qualifiers.put( property, qualifier);
	}

	@SuppressWarnings("unchecked")
	public void addMappingsToRanges( String property, Interval range ){

		if( range == null ){//Then the property group is empty!

			empty = true;

			return;
		}

		if( mappingsToRanges == null ) mappingsToRanges = new Hashtable<String, Interval>();

		mappingsToRanges.put( property, range);
	}

	public void addRepresentedServiceInstances( String newProperty, Map<Integer, ServiceInstance> newRepresentedServiceInstances ){

		if( representedServiceInstances == null ){

			representedServiceInstances = new Hashtable<Integer, ServiceInstance>();

			for( Enumeration<Integer> e = ( (Hashtable<Integer,ServiceInstance>) newRepresentedServiceInstances).keys(); e.hasMoreElements(); )

				representedServiceInstances.put( representedServiceInstances.size(), newRepresentedServiceInstances.get( e.nextElement() ));
		}

		else{

			Map<Integer, ServiceInstance> finalRepresentedServiceInstances = new Hashtable<Integer, ServiceInstance>();

			for( Enumeration<Integer> e = ( (Hashtable<Integer,ServiceInstance>) representedServiceInstances).keys(); e.hasMoreElements(); ){

				Integer i =  e.nextElement();

				if( representedServiceInstances.get(i) != null && ( (Hashtable<Integer,ServiceInstance>) newRepresentedServiceInstances).contains( representedServiceInstances.get(i) ) )

					finalRepresentedServiceInstances.put( finalRepresentedServiceInstances.size(), representedServiceInstances.get(i));
			}

			representedServiceInstances = finalRepresentedServiceInstances;
		}
	}


	//Getters.
	public Hashtable<String, String> getQualifiers(){

		return qualifiers;
	}

	@SuppressWarnings("unchecked")
	public Map<String, Interval> getMappingsToRanges(){

		return mappingsToRanges;
	}

	public Map<Integer, ServiceInstance> getRepresentedServiceInstances(){

		return representedServiceInstances;
	}

	public boolean isEmpty(){

		return empty;
	}

	@SuppressWarnings("unchecked")
	void print(){

		if( mappingsToRanges != null )

			for( Enumeration<String> e = ( (Hashtable<String, Interval>) mappingsToRanges).keys(); e.hasMoreElements(); ){

				String i = e.nextElement();

				JOptionPane.showMessageDialog(null, "Joint group --> Property: " + i + " - qualifier: " + qualifiers.get(i) + " range= (" + mappingsToRanges.get(i).getStart() + ", " + mappingsToRanges.get(i).getEnd() + ").");
			}

		for( int i = 0; representedServiceInstances != null && i < representedServiceInstances.size(); ++i ) JOptionPane.showMessageDialog(null, "Joint group --> service instance: " + representedServiceInstances.get(i).getName());
	}
}
