package org.ow2.choreos.abstractionDrivenServiceOrganization.nonFunctionalOrganization.propertyAndJointBasedGroups;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.interval.Interval;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInstance;


/**
 * 
 * @author dathanas
 *
 */
public class PropertyBasedGroup {//This class concerns only one property and only one qualifier!


	//Variables.
	private String property;
	private String qualifier;
	@SuppressWarnings("unchecked")
	private Interval range;
	private Map<Integer, ServiceInstance> representedServiceInstances;

	private boolean empty = false;//If it is empty, the 'range' attribute is null! It is the only attribute!


	//Constructor.
	@SuppressWarnings("unchecked")
	PropertyBasedGroup( List<Double> values, String property, Map<Integer, ServiceInstance> representedServiceInstances ){//This constructor is used only for the first non-functional abstraction!

		this.property = property;
		this.qualifier = "All values of";

		Double maxValue = Collections.max( values );
		Double minValue = Collections.min( values );
		this.range = new Interval( minValue, maxValue );

		this.representedServiceInstances = representedServiceInstances;

		/*JOptionPane.showMessageDialog(null, "New Property-based group object!");
		JOptionPane.showMessageDialog(null, "Property-based group --> Property: " + property + " range= (" + minValue + ", " + maxValue + ") - num services= " + representedServiceInstances.size());
		for( int i = 0; i < representedServiceInstances.size(); ++i) JOptionPane.showMessageDialog(null, "Property-based group --> Property: " + property + " range= (" + minValue + ", " + maxValue + ") - service instance= " + representedServiceInstances.get(i).getName());*/ 
	}

	PropertyBasedGroup( String property ){//This constructor is used for empty group for the initial abstraction!

		this.property = property;
		this.qualifier = "All values of";
		this.representedServiceInstances = new Hashtable<Integer, ServiceInstance>();
		this.empty = true;

		//JOptionPane.showMessageDialog(null, "New Property-based group object!");
		//JOptionPane.showMessageDialog(null, "Property-based group --> Property: " + property + " - Empty!");
	}

	PropertyBasedGroup( String property, String qualifier ){//This constructor is used for empty group for the other abstractions!

		this.property = property;
		this.qualifier = qualifier;
		this.representedServiceInstances = new Hashtable<Integer, ServiceInstance>();
		this.empty = true;

		//JOptionPane.showMessageDialog(null, "New Property-based group object!");
		//JOptionPane.showMessageDialog(null, "Property-based group --> Property: " + property + " - qualifier = " + qualifier + " - is Empty!");
	}

	@SuppressWarnings("unchecked")
	PropertyBasedGroup( ArrayList<Double> values, String property, String qualifier, Hashtable<Integer, ServiceInstance> representedServiceInstances ){

		this.property = property;
		this.qualifier = qualifier;

		Double maxValue = Collections.max( values );
		Double minValue = Collections.min( values );
		this.range = new Interval( minValue, maxValue );

		this.representedServiceInstances = representedServiceInstances;

		//JOptionPane.showMessageDialog(null, "New Property-based group object!");
		//JOptionPane.showMessageDialog(null, "Property-based group --> Property: " + property + " - qualifier: " + qualifier + " range= (" + minValue + ", " + maxValue + ") - num services= " + representedServiceInstances.size());
		//for( int i = 0; i < representedServiceInstances.size(); ++i) JOptionPane.showMessageDialog(null, "Property-based group --> Property: " + property + " range= (" + minValue + ", " + maxValue + ") - service instance= " + representedServiceInstances.get(i).getName());
	}


	//Setters.
	void freeObjects(){
		property = null;
		qualifier = null;
		range = null;
		representedServiceInstances = null;
	}


	//Getters.
	String getProperty(){

		return property;
	}

	String getQualifier(){

		return qualifier;
	}

	@SuppressWarnings("unchecked")
	Interval getRange(){

		return range;
	}

	Map<Integer, ServiceInstance> getRepresentedServiceInstances(){

		return representedServiceInstances;
	}

	boolean isEmpty(){

		return empty;
	}
}
