package org.ow2.choreos.abstractionGenerator;

import java.util.Hashtable;

import org.ow2.choreos.serviceRepresentation.functional.MessageType;


@SuppressWarnings("serial")
public class Binding 
{
	private static Hashtable<String,String> xmlToJava=new Hashtable<String, String>() {{
		put("string","String");
		put("integer","BigInteger");
		put("decimal","BigDecimal");
		put("QName","QName");
		put("anySimpleType","String");
		put("dateTime","Date");
		put("base64Binary","byte[]");
		put("hexBinary","byte[]");
		put("unsignedInt","long");
		put("unsignedShort","int");
		put("unsignedByte","short");
		}
	};
	
	
	@SuppressWarnings("unused")
	private static Hashtable<String, String> reflection =new Hashtable<String,String>()
			{{
				put("Integer","int");
				put("Float","float");
				put("Long","long");
				put("Short","short");
				put("Double","double");
				put("Boolean","boolean");
				put("Byte","byte");
			}};
	
	//Binding from xml to Java
	public static String bindingFromXmlToJava(MessageType messageType)
	{
		String bind=getBinding(messageType.getReferencedComponent().getType());
		if (bind == null) return messageType.getReferencedComponent().getType();
		else return bind;
	}
	
	
	private static String getBinding(String type)
	{
		return xmlToJava!=null && type!=null ? xmlToJava.get(type): null;
	}
	
	
	
}
