 package org.ow2.choreos.abstractionGenerator;

import java.lang.reflect.Field;
import java.lang.reflect.ParameterizedType;
import java.util.ArrayList;
import java.util.List;

import org.ow2.choreos.dataStructures.list.listManipulation.ListTransformations;


public class InputOutputDataTranslator 
{
	private ArrayList<ArrayList<List<Object>>>T;
	private ArrayList<List<Object>> L;
	public ArrayList<ArrayList<List<Object>>>Tables;
	public ArrayList<ArrayList<String[]>> Header;
	public InputOutputDataTranslator()
	{
		T= new ArrayList<ArrayList<List<Object>>>();
		Tables= new ArrayList<ArrayList<List<Object>>>();
		Header =new ArrayList<ArrayList<String[]>>();
	}
	
	
	@SuppressWarnings("unchecked")
	private int createHeader(Object source,ArrayList<String>path,int mode,int position, String inputOrOutput)
	{
		if ( source != null)
		{
			Class<?> cls =source.getClass();
			
			
			
			Field [] fld=cls.getDeclaredFields();
			if(Header.size()==0) 
				for(int i=0;i<fld.length;i++)
					Header.add(new ArrayList<String []>());
			
			for(int i=0;i<fld.length;i++)
			{	
				fld[i].setAccessible(true);
				//Get the interfaces that class implements!!
				Class [] implementedInterfaces=fld[i].getType().getInterfaces(); 
				
				if(implementedInterfaces.length==0)//if class doesn't implement any interface
				{
					implementedInterfaces= new Class[1];
					implementedInterfaces[0]=null;
				}
				
				
				if(isBasicType(fld[i])==true)	
				{	if(path.size()!=0)
					{
					if (fld[i].getName().startsWith("_"))
						path.add(fld[i].getName().replace("_", "")+","+fld[i].getType().getSimpleName());
					else
						path.add(fld[i].getName()+","+fld[i].getType().getSimpleName());
					
					}
					else
					{
						if (fld[i].getName().startsWith("_"))
						{
							path.add(cls.getSimpleName());
							path.add(fld[i].getName().replace("_", "")+","+fld[i].getType().getSimpleName());
						}
						else
							path.add(fld[i].getName()+","+fld[i].getType().getSimpleName());
					}
					String[] pathArray=ListTransformations.convert2Array(path);
					
					
					
					//printPath(pathArray);	

					Header.get(position).add(pathArray);
					path.remove(path.size()-1);
				}
				else if(implementedInterfaces[0] == java.util.List.class || implementedInterfaces[0] == java.util.Collection.class)//if field is List
				{	
					Class<?> listClass=getListClass(fld[i]);
					
					if(listClass.getGenericSuperclass()==java.lang.Number.class || listClass == java.lang.Boolean.class 
							|| listClass ==java.lang.Character.class || listClass.isInstance("java.util.String"))
					{	
						
						path.add(fld[i].getName()+","+listClass.getSimpleName());
						
						
						String[] pathArray=ListTransformations.convert2Array(path);
						
						Header.get(position).add(pathArray);
						path.remove(path.size()-1);
					}
					else
					{
						try {
							ArrayList<Object> temp =(ArrayList<Object>) fld[i].get(source); ///get
							
							path=new ArrayList<String>();
							path.add(StringManager.firstCharacterToLowerCase(listClass.getSimpleName()));
							if (temp != null)
								createHeader(temp.get(0),path, 1,position,inputOrOutput);
						} catch (IllegalArgumentException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (IllegalAccessException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					System.out.println("List Recursion for object ended");
					}
				}
				else ///if field is Complex type!!
				{
					System.out.println("Recursion Started!!");
					try {
						//if(path.size() !=0)
						ArrayList<String>pathComplex=new ArrayList<String>();	
						pathComplex.add(StringManager.firstCharacterToLowerCase( fld[i].getType().getSimpleName() ));
						
						createHeader(fld[i].get(source),pathComplex, 1,position,inputOrOutput);
						//path.remove(path.size()-1);
					} catch (IllegalArgumentException e) {
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						e.printStackTrace();
					}
					System.out.println("Recursion Ended!!");
				}
				
				
				if(mode==0)
					position=position+1;
			
			}
		}
		return position;
	}
	
	
	
	
	@SuppressWarnings("unused")
	private void printPath(String[] pathArray) {

		for(int i=0;i<pathArray.length;i++)
			System.out.print(pathArray[i]);
		System.out.println("!!!!!!");
	}


	/**
		This function creates the lists of the object that accepts as entry into	
	**/
	
	@SuppressWarnings("unchecked")
	private ArrayList<ArrayList<Object>> createListsForEachPart(Object sourceObject,int position,int arraylist_position,int mode ) throws Exception
	{
		Class<?> cls=sourceObject.getClass(); 
		
		Field [] fld=cls.getDeclaredFields();  
		
		if(T.size()==0) 
			for(int i=0;i<fld.length;i++)
				T.add(new ArrayList<List<Object>>());
		ArrayList<ArrayList<Object>> t = new ArrayList<ArrayList<Object>>();
		
		for(int i=0;i<fld.length;i++)
		{	fld[i].setAccessible(true);
			List <Object> tmp=new ArrayList<Object>();
			
			//Get the interfaces that class implements!!
			Class [] implInterfaces;
			implInterfaces=implementedInterfaces(fld[i]);
			
			if(isBasicType(fld[i])==true)	
			{	
				
				tmp.add(fld[i].get(sourceObject));//insert value to list
				
				if (t.size() == 0)t.add(new ArrayList<Object> () );
				for( int j=0; j< t.size(); j++)
					t.get(j).add(tmp);
			}
			else if(isList(implInterfaces)==true)//if field is List
			{	
				
				Class<?> listClass=getListClass(fld[i]);
				
				if(listClass.getGenericSuperclass()==java.lang.Number.class || listClass == java.lang.Boolean.class 
						|| listClass ==java.lang.Character.class || listClass.isInstance("java.util.String"))
				{	
					
					tmp=(ArrayList<Object>)fld[i].get(sourceObject);
					
					ArrayList<ArrayList<Object>> tmpList = new ArrayList<ArrayList<Object>>();
					for(int j=0 ; j <tmp.size();j++)
					{						
						tmpList.add(new ArrayList<Object>());
						tmpList.get(j).add(t);
						ArrayList<Object> s =new ArrayList<Object>();
						s.add(tmp.get(j));
						tmpList.get(j).add(s);
						
					}
					
					t=tmpList;
				}
				else
				{
					System.out.println("List Recursion for object started : "+position);
					
					tmp= (List<Object>)fld[i].get(sourceObject);//get input of list 
					
					if (L ==null) //secondary list only for lists with objects
						L=new ArrayList<List<Object>>();
					
					if(tmp!=null){
					for(int j=0;j<tmp.size();j++)// for each element of the list we use recursion
					{	
						L.add(new ArrayList<Object> () );
						ArrayList<ArrayList<Object>> tmpListElement = createListsForEachPart(tmp.get(j),position,arraylist_position,1);//Recursion for each element of the list
						for(int k=0 ; k < tmpListElement.size() ; k++ )
						{
							for( int l = 0; l<tmpListElement.get(k).size(); l++ )
							L.get(j).add(tmpListElement.get(k).get(l));
						}
					}
					
					ArrayList<ArrayList<Object>> tmpList = new  ArrayList<ArrayList<Object>>();
					for(int j=0; j<L.size();j++)
					{
						tmpList.add(new ArrayList<Object> () );
						tmpList.get(j).addAll(t);
						tmpList.get(j).add(L.get(j));
					}
					t=tmpList;
					}
					
					System.out.println("List Recursion for object ended");
				}
			}
			else ///if field is Complex type!!
			{
				System.out.println("Recursion Started!!");
				
				ArrayList<ArrayList<Object>> recurcionList=createListsForEachPart(fld[i].get(sourceObject),position,arraylist_position,1);
				ArrayList<ArrayList<Object>> tmpList= new ArrayList<ArrayList<Object>>();
				for ( int j=0; j < recurcionList.size(); j++)
				{
					tmpList.add(new ArrayList<Object> () );
					tmpList.get(j).addAll(t);
					tmpList.get(j).addAll(recurcionList.get(j));
				}
				
				t=tmpList;

				System.out.println("\nRecursion Ended!!");
			}
			
			
			if(mode==0)
				position=position+1;
		
		}

		return t;
	}
	
	
	@SuppressWarnings("unchecked")
	private Class [] implementedInterfaces(Field fld)
	{
		Class [] implementedInterfaces=fld.getType().getInterfaces(); 
		
		if(implementedInterfaces.length==0)//if class doesn't implement any interface
		{
			implementedInterfaces= new Class[1];
			implementedInterfaces[0]=null;
		}
		return implementedInterfaces;
	}
	
	
	private boolean isBasicType(Field fld)
	{
		if(fld.getType().isPrimitive() || fld.getType().isInstance("java.lang.String")|| fld.getType()== java.math.BigInteger.class 
				|| fld.getType()==java.math.BigDecimal.class)
		{
			return true;
		}
		return false;
		
	}
	
	
	
	@SuppressWarnings("unchecked")
	private boolean isList(Class [] implInterfaces)
	{
		if(implInterfaces[0] == java.util.List.class || implInterfaces[0] == java.util.Collection.class) return true;
		return false;
	}
	
	@SuppressWarnings("unchecked")
	private Class getListClass(Field fld)
	{
		ParameterizedType type = (ParameterizedType) fld.getGenericType();
		Class<?> listClass = (Class<?>) type.getActualTypeArguments()[0];
		return listClass;
	}
	
	
	@SuppressWarnings("unchecked")
	private void createTables(ArrayList<ArrayList<Object>> tuples)
	{
		L=null;
		
		
		int count=0;
		for( int j=0; j < tuples.get(0).size(); j++ )
		{
			ArrayList<Object> objList = (ArrayList<Object>) tuples.get(0).get(j);
			count =count +objList.size();
		}
		
		L = new ArrayList< List<Object>>();

		for( int i=0; i < count; i++ )
			L.add(new ArrayList<Object>());
		

		for(int i=0; i < tuples.size() ; i++ )
		{
			count=0;
			for( int k=0; k< tuples.get(i).size();k++)
			{
				ArrayList tmp= (ArrayList<Object>) tuples.get(i).get(k);
				
	
				for(int j=0; j < tmp.size(); j++ )
				{
					L.get(count).add(tmp.get(j));
					count++;
				}
				
				
			}
			
			
		}
		Tables.add(L);
	}
	
	
	/**
	 * finds all possible combinations of the lists given as input
	**/
	@SuppressWarnings("unused")
	private ArrayList<List<Object>> findAllPossibleCombinations(ArrayList<List<Object>> L,int position,ArrayList<List<Object>> listOfTuples)
	{	
		int counter=1;
		
		if(listOfTuples.size()==0)
		for(int i=0;i<L.size();i++)
					listOfTuples.add(new ArrayList<Object>());

		for(int i=0;i<L.get(position).size();i++)
		{
			counter = 1;
			for(int k = position+1; k < L.size(); k++)
					counter=counter*L.get(k).size();
			
			for(int j=0;j<counter;j++)
				listOfTuples.get(position).add(L.get(position).get(i));//insert values
			
			if( position+1 < L.size() )
				findAllPossibleCombinations(L,position+1,listOfTuples);	
		}
		
		return listOfTuples;	
	}
	
	public void translate(Object soureObject,String inputOrOutput)
	{
		createHeader(soureObject,new ArrayList<String>(), 0, 0,inputOrOutput);
		ArrayList<ArrayList<Object>> tuples=null;
		try {
			tuples= createListsForEachPart(soureObject,0,0,0);
		} 
		catch (Exception e){
			e.printStackTrace();
		}
		
		createTables(tuples);
		//print();
		
		
	}
	
	
	public void print()
	{
		for(int i=0; i<Tables.size();i++)
		{
			System.out.println("Table: "+i);
			for(int j=0;j<Tables.get(i).get(0).size();j++)
			{
				//System.out.println(Tables.get(i).size());
				for(int k=0;k<Tables.get(i).size();k++)
				{
					System.out.print(Tables.get(i).get(k).get(j)+"  ");
				}
				System.out.println();
			}
			System.out.println("--------------------------------");
			
		}
	}
	
	public  String array2String(String[] str) {
	    if (str == null) {
	        return null;
	    }
	    String result="";
	    for(int i=0; i<str.length;i++)
	    	result=result.concat(str[i]);
	   return result; 
	  }
	}
