package org.ow2.choreos.dataStructures.interval;

import org.ow2.choreos.gui.PrintMessages;


@SuppressWarnings("unchecked")
public class Interval<T extends Comparable>{


	//Variables.
	private T from = null;
	private T to = null;
	
	//Extra fields used for xml transformation
	private Double xFrom = null;
	private Double xTo = null;
	
	private int dbAbstractionKey;


	//Constructor.
	public Interval( T start, T end ){

		from = start;

		to = end;
	}
	
	
	//Empty constructor used for xml transformation
	public Interval(){
		
	}


	//Methods.
	public boolean contains( T value ){

		return from.compareTo( value ) <= 0 && to.compareTo( value ) >= 0;
	}

	public T getStart(){

		return from;
	}

	public T getEnd(){

		return to;
	}

	public void stdPrint(){

		PrintMessages.stdPrintLn( PrintMessages.schemaMatchingIndexing, "[" + from.toString() + ", " + to.toString() + "]" );
	}
	
	public int getDBAbstractionKey(){

		return dbAbstractionKey;
	}
	
	public void setDBAbstractionKey( int cDBKey ){

		dbAbstractionKey = cDBKey;
	}
	
	//Setters used for xml transformation
	
	public void setxFrom( Double cFrom ){
		xFrom = cFrom;
	}
	
	public void setxTo( Double cTo ){
		xTo = cTo;
	}
	
	public void setxDBAbstractionKey( int cDBAbstractionKey ){
		dbAbstractionKey = cDBAbstractionKey;
	}
	
	//Getters used for xml transformation
	
	public Double getxFrom(){
		
		if(xFrom == null){
			
			try {
				xFrom = new Double(from.toString());
			} catch (NumberFormatException e) {
				xFrom = null;
			}
		}
		
		return xFrom;
	}
	
	public Double getxTo(){
		
		if(xTo == null){
			
			try {
				xTo = new Double(to.toString());
			} catch (NumberFormatException e) {
				xTo = null;
			}
		}
		
		return xTo;
	}
	
	public int getxDBAbstractionKey(){
		return dbAbstractionKey;
	}
}