package org.ow2.choreos.dataStructures.interval;



/**
 * 
 * @author dathanas
 *
 */
public class Interval1D {


	//Variables.
    private double left, right;


    //Constructors.
    public Interval1D( double cLeft, double cRight ){

    	setEndpoints( cLeft, cRight );
    }

    public Interval1D( Interval1D interval ){

    	if( interval != null ) setEndpoints( interval.left, interval.right );

        else throw new RuntimeException( "Interval1D: Illegal (null) copy interval creation." );
    }

    private void setEndpoints( double cLeft, double cRight ){

        if( cLeft <= cRight ){

            left  = cLeft;

            right = cRight;
        }

        else throw new RuntimeException( "Interval1D: The left endpoint is higher than the right endpoint." );
    }


    //Setters.
    public void setRightEndpoint( double cRight ) {

    	setEndpoints( left, cRight );
    }


    //Getters.
    public double getLeftEndpoint() {

        return left;
    }

    public int getIntLeftEndpoint() {

        return (int) left;
    }

    public int getIntRightEndpoint() {

        return (int) right;
    }

    public double getRightEndpoint() {

        return right;
    }

    static public boolean areEqual( Interval1D interval1, Interval1D interval2 ){

    	return interval1 != null && interval2 != null && interval1.left == interval2.left && interval1.right == interval2.right;
    }

    public boolean intersects( Interval1D that ){

        if( this.right < that.left ) return false;

        if( that.right < this.left ) return false;


        return true;
    }

    public boolean contains( Interval1D interval ) {

        return interval != null && left <= interval.getLeftEndpoint() && interval.getRightEndpoint() <= right;
    }

    public static boolean contains( Interval1D interval1, Interval1D interval2 ) {//interval1 contains interval2. 

        return interval1 != null && interval2 != null && interval2.left > interval1.left && interval2.left <= interval1.right;
    }

    public boolean isPoint() {

        return left == right;
    }

    public boolean contains( Double x ) {

        return x != null && left <= x && x <= right ? true : false;
    }

    public boolean isLeft( Double x ) {

        return x != null && left <= x && right <= x ? true : false;
    }

    public boolean isRight( Double x ) {

        return x != null && left >= x && right >= x ? true : false;
    }

    public static boolean isRight( Interval1D interval1, Interval1D interval2 ) {//Is on the right of the interval1 the interval2? 
    	//System.out.println( interval2.getIntEndpoints() + " is right of the " + interval1.getIntEndpoints() + " = " + (interval1 != null && interval2 != null && interval1.right < interval2.left));
        return interval1 != null && interval2 != null && interval1.right < interval2.left;
    }

    public double length(){

        return right - left;
    }

    public String getDoubleEndpoints(){

        return "[" + left + ", " + right + "]";
    }

    public String getIntEndpoints(){

    	Object leftMessage = left == Integer.MIN_VALUE ? "-oo" : (int) left;

    	Object rightMessage = right == Integer.MAX_VALUE ? "+oo" : (int) right;


        return "[" + leftMessage + ", " + rightMessage + "]";
    }
}
