package org.ow2.choreos.dataStructures.list.listManipulation;

import java.util.ArrayList;
import java.util.List;

import org.ow2.choreos.dataStructures.array.arrayInstantiation.ArrayInstantiation;
import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.list.listInstantiation.ListInstantiation;
import org.ow2.choreos.parser.freeTextDocuments.Tokenizer;


/**
 * 
 * @author dathanas
 *
 */
public class ListTransformations {


	public static List<String> toLowerCase( List<String> list ){

		List<String> lowerCaseList = null;

		for( int i = 0; list != null && i < list.size(); ++i ){

			if( lowerCaseList == null ) lowerCaseList = new ArrayList<String>();

			lowerCaseList.add( list.get( i ).toLowerCase() );
		}

		return lowerCaseList;
	}

	public static String[] convert2Array( List<String> list ) {

		return list != null && ! list.isEmpty() ? list.toArray( new String[ list.size() ] ) : null;
	}

	public static String[] convert2OneDimensionArray( List<ArrayList<String>> list ) {

		String[] array = null;


		if( list != null && ! list.isEmpty() ){

			array = new String[ list.size() ];

			for( int i = 0; i < list.size(); ++i ) array[ i ] = list.get( i ).toString();
		}


		return array;
	}

	public static String[][] convert2TwoDimensionArray( List<ArrayList<String>> list ) {

		String[][] array = null;


		if( list != null && ! list.isEmpty() ){

			array = new String[ list.size() ][];

			for( int i = 0; i < list.size(); ++i ) array[ i ] = convert2Array( list.get( i ) );
		}


		return array;
	}

	public static String[] convert2ArrayOfSuffixes( List<String> list, String character ) {

		for( int i = 0; list != null && i < list.size(); ++i ) list.set( i , Tokenizer.getSuffix( list.get( i ), character ) );


		return list != null && ! list.isEmpty() ? list.toArray( new String[ list.size() ] ) : null;
	}

	public static Object[] convert( List<String> list ) {

		Object[] array = list != null ? ArrayInstantiation.newArray( list.size() ) : null;


		for( int i = 0; list != null && i < list.size(); ++i ) array[ i ] = list.get( i );


		return array;
	}


	@SuppressWarnings("unchecked")
	public static List<?> merge( List<?> list, Object object ) {

		return ListInsertion.add( object, (List<Object>) list );
	}

	public static List<?> merge( List<?> list1, List<?> list2 ) {

		if( list1 == null && list2 == null ) return list2;

		if( list1 == null ) return list2;

		if( list2 == null ) return list1;


		List<Object> list = ListInstantiation.newList();

		list.addAll( list1 );

		list.addAll( list2 );


		return list;
	}
}
