package org.ow2.choreos.dataStructures.map.mapInsertion;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.map.mapInstantiation.MapInstantiation;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;


/**
 * 
 * @author dathanas
 *
 */
public class MapInsertion {


	public static Map<Object, Object> put( Object key, Object value, Map<Object, Object> map, boolean overwrite ){

		if( value != null ) map = MapInstantiation.newMap( map );

		if( value != null && ( ( ! MapGetter.exists( key, map ) && key != null ) || ( MapGetter.exists( key, map ) && overwrite ) ) ) map.put( key, value );


	    return map;
	}

	static public Map<Object, Object> putAll( Map<Object, Object> addedMap, Map<Object, Object> map ){

		if( addedMap != null ){

			map = MapInstantiation.newMap( map );

			map.putAll( addedMap );
		}


	    return map;
	}

	static public Map<Object, List<Object>> putAllLists( Map<Object, List<Object>> addedMap, Map<Object, List<Object>> map ){

		if( addedMap != null ){

			map = MapInstantiation.newMapOfLists( map );

			map.putAll( addedMap );
		}


	    return map;
	}

	static public Map<Object, List<Object>> createCopyOfAllLists( Map<Object, List<Object>> map ){

		Map<Object, List<Object>> newMap = null;


		if( map != null ){

			newMap = MapInstantiation.newMapOfLists();


			Iterator<Object> mapIterator = map != null && map.keySet() != null ? map.keySet().iterator() : null;

			while( mapIterator != null && mapIterator.hasNext() ){

				Object key = mapIterator.next();


				List<Object> list = map.get( key );

				List<Object> newList = ListInsertion.addAll( list, null );


				newMap = putInMapOfList( key, newList, newMap, true );
			}
		}


	    return newMap;
	}


	public static Map<Object, Map<Object, Object>> putInMapOfMap( Object key, Map<Object, Object> value, Map<Object, Map<Object, Object>> map, boolean overwrite ){

		if( map == null && value != null ) map = MapInstantiation.newMapOfMap();


		if( value != null && ( ( ! MapGetter.existsInMapOfMap( key, map ) && key != null ) || ( MapGetter.existsInMapOfMap( key, map ) && overwrite ) ) ) map.put( key, value );


	    return map;
	}


	static public Map<Object, List<Object>> putInMapOfList( Object key, List<Object> value, Map<Object, List<Object>> map, boolean overwrite ){

		if( map == null && value != null ) map = MapInstantiation.newMapOfLists();


		if( value != null && ( ( ! MapGetter.existsInMapOfList( key, map ) && key != null ) || ( MapGetter.existsInMapOfList( key, map ) && overwrite ) ) ) map.put( key, value );


	    return map;
	}

	public static Map<Object, Object[]> putInMapOfArrays( Object key, Object[] value, Map<Object, Object[]> map, boolean overwrite ){

		if( map == null && value != null ) map = MapInstantiation.newMapOfArrays();


		if( value != null && ( ( ! MapGetter.existsInMapOfArrays( key, map ) && key != null ) || ( MapGetter.existsInMapOfArrays( key, map ) && overwrite ) ) ) map.put( key, value );


	    return map;
	}

	@SuppressWarnings("unchecked")
	public static Map<Object, Object> putInHiddenMapOfList( Object key, List<Object> values, Map<Object, Object> map, boolean overwrite ){

		if( map == null && values != null ) map = MapInstantiation.newMap();


		if( values != null ){

			if( ! MapGetter.exists( key, map ) && key != null ) map.put( key, values );

			else if( MapGetter.exists( key, map ) && overwrite ){

				List<Object> oldValues = (List<Object>) MapGetter.getValue( key, map );

				oldValues.addAll( values );

				map.put( key, oldValues );
			}
		}


	    return map;
	}

	public static Map<Object, Map<Object, List<Object>>> putInMapOfMapOfList( Object key, Map<Object, List<Object>> value, Map<Object, Map<Object, List<Object>>> map, boolean overwrite ){

		if( map == null && value != null ) map = MapInstantiation.newMapOfMapOfList();


		if( value != null && ( ( ! MapGetter.existsInMapOfMapOfList( key, map ) && key != null ) || ( MapGetter.existsInMapOfMapOfList( key, map ) && overwrite ) ) ) map.put( key, value );


	    return map;
	}

	public static Map<Object, List<Object>> putInMapOfList( Object key, Object listItem, Map<Object, List<Object>> map ){

		if( map == null ) map = MapInstantiation.newMapOfLists();


		List<Object> list = map.get( key );

		list = ListInsertion.add( listItem, list );

		map = putInMapOfList( key, list, map, true );


	    return map;
	}
}
