package org.ow2.choreos.dataStructures.map.mapManipulation;

import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.classInfo.ClassInfo;
import org.ow2.choreos.parser.freeTextDocuments.Tokenizer;


/**
 * 
 * @author dathanas
 *
 */
public class MapGetter {


	static public Map<String, String> getFilteredMapValues( String keyPrefix, String prefixEndSymbol, Map<String, String> map ){

		Map<String, String> filteredMap = null;


		if( map != null ){

			for ( Enumeration<String> e = ( (Hashtable<String, String>) map ).keys(); e.hasMoreElements(); ){

				String key = e.nextElement();

				String value = map.get( key );


				if( Tokenizer.getPrefix( key, prefixEndSymbol ) != null && Tokenizer.getPrefix( key, prefixEndSymbol ).equals( keyPrefix ) ){

					String keySuffix = Tokenizer.getSuffix( key, prefixEndSymbol );


					if( filteredMap == null ) filteredMap = new Hashtable<String, String>();

					filteredMap.put( keySuffix, value );
				}
			}
		}


		return filteredMap;
	}


	public static String getStringKeyByCandidateKeysLowerCase( Map<String, String> keys, Map<String, String> map ){

		String key = null;


		if( keys != null && map != null ){

			for ( Enumeration<String> e = ( (Hashtable<String, String>) keys ).keys(); e.hasMoreElements(); ){

				key = e.nextElement();

				if( map.get( key.toLowerCase() ) != null ) break;
			}
		}


		return key;
	}

	public static String getStringValueByCandidateKeysLowerCase( Map<String, String> keys, Map<String, String> map ){

		String value = null;


		if( keys != null && map != null ){

			for ( Enumeration<String> e = ( (Hashtable<String, String>) keys ).keys(); e.hasMoreElements(); ){

				String key = e.nextElement();

				if( ( value = map.get( key.toLowerCase() ) ) != null ) break;
			}
		}


		return value;
	}


	public static boolean existsInMapOfList( Object key, Map<Object, List<Object>> map ){

		return key != null && map != null && getValueOfMapOfList( key, map ) != null ? true : false;
	}

	public static boolean existsInMapOfArrays( Object key, Map<Object, Object[]> map ){

		return key != null && map != null && getValueOfMapOfArrays( key, map ) != null ? true : false;
	}

	public static boolean existsInMapOfMapOfList( Object key, Map<Object, Map<Object, List<Object>>> map ){

		return key != null && map != null && getValueOfMapOfMapOfList( key, map ) != null ? true : false;
	}

	static public List<Object> getValueOfMapOfList( Object key, Map<Object, List<Object>> map ){

		return map != null && key != null ? map.get( key ) : null;
	}

	public static Object[] getValueOfMapOfArrays( Object key, Map<Object, Object[]> map ){

		return map != null && key != null ? map.get( key ) : null;
	}

	public static boolean existsInMapOfMap( Object key, Map<Object, Map<Object, Object>> map ){

		return key != null && map != null && getValueOfMapOfMap( key, map ) != null ? true : false;
	}

	public static Map<Object, Object> getValueOfMapOfMap( Object key, Map<Object, Map<Object, Object>> map ){

		return map != null && key != null ? map.get( key ) : null;
	}

	public static Map<Object, List<Object>> getValueOfMapOfMapOfList( Object key, Map<Object, Map<Object, List<Object>>> map ){

		return map != null && key != null ? map.get( key ) : null;
	}


	public static boolean exists( Object key, Map<Object, Object> map ){

		return key != null && map != null && getValue( key, map ) != null ? true : false;
	}

	public static Object getValue( Object key, Map<Object, Object> map ){

		return map != null && key != null ? map.get( key ) : null;
	}

	public static double getMaxValue( Map<Object, Double> map ){

		return map != null && ! map.isEmpty() ? Collections.max( map.values() ) : -1;
	}


	public static Object getValueByStringKey( String key, Map<String, ?> map ){

		return key != null && map != null ? map.get( key ) : null;
	}

	public static boolean existsStringKey( String key, Map<String, ?> map ){

		return getValueByStringKey( key, map ) != null ? true : false;
	}

	public static Object getValueByIntegerKey( Integer key, Map<Integer, ?> map ){

		return key != null && map != null ? map.get( key ) : null;
	}

	public static boolean existsIntegerKey( Integer key, Map<Integer, ?> map ){

		return getValueByIntegerKey( key, map ) != null ? true : false;
	}


	public static boolean getBooleanValueByKey( String key, Map<String, Boolean> map ){

		return key != null && map != null && map.get( key ) != null ? map.get( key ) : false;
	}

	public static String getValueByKeyToLowerCase( String key, Map<String, String> map ){

		return key != null && map != null ? map.get( key.toLowerCase() ) : null;
	}

	public static String removeValueByKeyToLowerCase( String key, Map<String, String> map ){

		return key != null && map != null && map.get( key.toLowerCase() ) != null ? map.remove( key.toLowerCase() ) : null;
	}


	public static boolean keyToLowerCaseBelongsToMapStrings( String key, Map<String, String> map ){

		return getValueByKeyToLowerCase( key, map ) == null ? false : true;
	}

	public static boolean keyBelongsToMapStrings( String key, Map<String, String> map ){

		return getValueByStringKey( key, map ) == null ? false : true;
	}

	public static boolean objectNameBelongsToMapStrings( Object object, Map<String, String> map ){

		String objectKind = ClassInfo.getClass( object );


		return getValueByStringKey( objectKind, map ) == null ? false : true;
	}

	public static boolean belongsTo( Map<String, String> structures, Map<String, String> allStructures ){

		for ( Enumeration<String> e = ( (Hashtable<String, String>) structures).keys(); e.hasMoreElements(); ) if( MapGetter.objectNameBelongsToMapStrings( structures.get( e.nextElement() ), allStructures ) ) return true;


		return false;
	}
}
