package org.ow2.choreos.gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.InputMap;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.KeyStroke;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.ow2.choreos.basicAlgorithms.CartesianProduct;
import org.ow2.choreos.dataStructures.array.arrayInstantiation.ArrayInstantiation;
import org.ow2.choreos.dataStructures.array.arrayManipulation.ArrayTransformations;
import org.ow2.choreos.dataStructures.list.listInstantiation.ListInstantiation;
import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.list.listManipulation.ListGetters;
import org.ow2.choreos.dataStructures.map.mapInstantiation.MapInstantiation;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.gui.guiManipulation.JFrameManipulation;
import org.ow2.choreos.matchingProcess.MatcherStatistics;
import org.ow2.choreos.matchingProcess.MatchingController;
import org.ow2.choreos.measurements.memory.MemoryConsumption;
import org.ow2.choreos.measurements.number.NumberCheck;
import org.ow2.choreos.measurements.number.RoundingNumber;
import org.ow2.choreos.measurements.time.ElapsedTimeCalculator;
import org.ow2.choreos.parser.freeTextDocuments.Tokenizer;
import org.ow2.choreos.schemaRegistration.SchemaRegistrationController;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.userAuthentication.UserAuthenticationChecker;


/**
 * 
 * @author dathanas
 *
 */
public class SchemaRegistrationVisualizer extends JFrame{


	//Variables.
	private static final long serialVersionUID = -8753128584969466468L;


	private int initialFrameWidth = 1165, initialFrameHeight = 822;//TODO
	private int screenWidth = Toolkit.getDefaultToolkit().getScreenSize().width, screenHeight = Toolkit.getDefaultToolkit().getScreenSize().height;

	private JButton jButton1, jButton17, jButton18, jButton13, jButton12, jButton15, jButton10, jButton11, jButton4, jButton9, jButton2, jButton3, jButton6, jButton5, jButton8;
	private JLabel jLabel5, jLabel52, jLabel53, jLabel54, jLabel38, jLabel45, jLabel47, jLabel39, jLabel44, jLabel48, jLabel49, jLabel37, jLabel46, jLabel51, jLabel4, jLabel35, jLabel36, jLabel40, jLabel41, jLabel42, jLabel43, jLabel6, jLabel7, jLabel8, jLabel14, jLabel15, jLabel32, jLabel26, jLabel28, jLabel33, jLabel34, jLabel27, jLabel29, jLabel31, jLabel25, jLabel18, jLabel19, jLabel20, jLabel21, jLabel22, jLabel17, jLabel24, jLabel16, jLabel23, jLabel1, jLabel3, jLabel9, jLabel10, jLabel11, jLabel12, jLabel13, jLabel2, jLabel30;
	private JComboBox<?> jComboBox18, jComboBox19, jComboBox10, jComboBox15, jComboBox4, jComboBox16, jComboBox13, jComboBox14, jComboBox17, jComboBox5, jComboBox9, jComboBox21, jComboBox11, jComboBox12, jComboBox3, jComboBox6, jComboBox7, jComboBox2, jComboBox8;
	private JTextField jTextField17, jTextField11, jTextField12, jTextField13, jTextField14, jTextField15, jTextField16, jTextField1, jTextField6, jTextField7, jTextField8, jTextField9, jTextField10, jTextField3, jTextField2;
	private JPanel jPanel1, jPanel6, jPanel3, jPanel4, jPanel5;
	private JScrollPane jScrollPane1, jScrollPane2, jScrollPane3;
	private JTabbedPane jTabbedPane1, jTabbedPane2, jTabbedPane3;
	private JSeparator jSeparator5, jSeparator1, jSeparator2;
	private JCheckBox jCheckBox1, jCheckBox5, jCheckBox6, jCheckBox7, jCheckBox8;
	private JPasswordField jPasswordField1;
	private JProgressBar jProgressBar1;
	private JRadioButton jRadioButton1, jRadioButton2;


	private Object schemaRegistration;

	private UserSettings userSettings = null;

	private DocumentVisualizer documentVisualizer = null;

	private SchemaRegistrationVisualizer schemaRegistrationVisualizer = this;


	//Constructor.
	SchemaRegistrationVisualizer(){

		super( "XML Schema Matching" );


        initializeComponents();


        initializeFirstTabComponents();

        locate1stTabComponents();


        initializeSecondTabComponents();

        locate2ndTabComponents();


        initializeThirdTabComponents();

        locateThirdTabComponents();


        initializeFourthTabComponents();

        locateFourthTabComponents();


        locateComponents();


        pack();


        //resizeFrame();


        //getContentPane().setBackground( Color.blue );

        setVisible( true );
    }


    //Methods.
    private void initializeComponents(){

        jPanel1 = new JPanel(); jPanel1.setMaximumSize( new Dimension( 32767, 35767 ) );

        jPanel3 = new JPanel(); jPanel3.setMaximumSize( new Dimension( 32767, 35767 ) );

        jPanel4 = new JPanel(); jPanel4.setMaximumSize( new Dimension( 32767, 35767 ) );

        jPanel5 = new JPanel(); jPanel5.setMaximumSize( new Dimension( 32767, 35767 ) );


        jTabbedPane1 = new JTabbedPane(); jTabbedPane1.setFont( new Font( "Tahoma", 1, 12 ) );

        jTabbedPane2 = new JTabbedPane(); jTabbedPane2.setFont( new Font( "Tahoma", 1, 12 ) );

        jTabbedPane3 = new JTabbedPane(); jTabbedPane3.setFont( new Font( "Tahoma", 1, 12 ) );


        jTabbedPane1.addTab( "User Login - Authentication", jPanel3 );

        jTabbedPane1.addTab( "Configure the Schema Matching Process (1)", jPanel1 );

        jTabbedPane1.addTab( "Configure the Schema Matching Process (2)", jPanel4 );

        jTabbedPane1.addTab( "Execution of the Schema Matching Process", jPanel5 );


        setDefaultCloseOperation( javax.swing.WindowConstants.EXIT_ON_CLOSE );
    }

    private void resizeComponents() {

    	screenHeight -= screenHeight / 20;

        PrintMessages.stdPrintLn( PrintMessages.guiPrint, "initialFrameWidth X initialFrameHeight = " + initialFrameWidth + " X " + initialFrameHeight );

        PrintMessages.stdPrintLn( PrintMessages.guiPrint, "screenWidth X screenHeight = " + screenWidth + " X " + screenHeight );


        locateScaledFirstTabComponents();

        resizeFonts();

    	setSize( screenWidth, screenHeight );
    }


    //****************** First Tab ******************
    private void locate1stTabComponents(){

    	javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(jLabel23, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel6Layout.createSequentialGroup()
                                .addGap(23, 23, 23)
                                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel16)
                                    .addComponent(jLabel24))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jPasswordField1, javax.swing.GroupLayout.DEFAULT_SIZE, 183, Short.MAX_VALUE)
                                    .addComponent(jTextField3))
                                .addGap(0, 58, Short.MAX_VALUE))
                            .addGroup(jPanel6Layout.createSequentialGroup()
                                .addGap(0, 0, Short.MAX_VALUE)
                                .addComponent(jButton10)))
                        .addGap(18, 18, 18)
                        .addComponent(jButton15)
                        .addGap(29, 29, 29))))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel23)
                .addGap(18, 18, 18)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel24)
                    .addComponent(jPasswordField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 90, Short.MAX_VALUE)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton10)
                    .addComponent(jButton15))
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(335, 335, 335)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(406, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(165, 165, 165)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(291, Short.MAX_VALUE))
        );
    }

    private void locateScaledFirstTabComponents(){

    	
    }

    private void initializeFirstTabComponents(){

    	jPanel6 = (JPanel) JFrameManipulation.newObject( JPanel.class, "", JFrameManipulation.tahomaPlain13, true, false ); jPanel6.setBorder( BorderFactory.createBevelBorder( 1 ) );

    	jLabel23 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Enter your account details:", JFrameManipulation.tahomaPlain13, true, false );

    	jLabel16 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Username:", JFrameManipulation.tahomaPlain13, true, false );

    	jButton10 = (JButton) JFrameManipulation.newObject( JButton.class, "Login", JFrameManipulation.tahomaPlain13, true, true ); jButton10.addActionListener( login() );

    	getRootPane().setDefaultButton( jButton10 ); InputMap im = jButton10.getInputMap(); im.put( KeyStroke.getKeyStroke( "ENTER" ), "pressed" ); im.put( KeyStroke.getKeyStroke( "released ENTER" ), "released" );


    	jTextField3 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain13, true, true );

    	jLabel24 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Password:", JFrameManipulation.tahomaPlain13, true, false );

    	jButton15 = (JButton) JFrameManipulation.newObject( JButton.class, "Exit", JFrameManipulation.tahomaPlain13, true, true ); jButton15.addActionListener( exit() );

    	jPasswordField1 = (JPasswordField) JFrameManipulation.newObject( JPasswordField.class, "", JFrameManipulation.tahomaPlain13, true, true );
    }

    private ActionListener login(){

        return new ActionListener(){

			@SuppressWarnings("deprecation")
			public void actionPerformed( ActionEvent actionEvent ){

				//if( UserAuthenticationChecker.isAuthorizedForSchemaRegistration( jTextField3.getText(), jPasswordField1.getText() ) ) jTabbedPane1.setSelectedComponent( jPanel1 );

				jTabbedPane1.setSelectedComponent( jPanel1 );

				getRootPane().setDefaultButton( jButton11 ); InputMap im = jButton11.getInputMap(); im.put( KeyStroke.getKeyStroke( "ENTER" ), "pressed" ); im.put( KeyStroke.getKeyStroke( "released ENTER" ), "released" );
            }
        };
    }


    //****************** Second Tab ******************
    private void locate2ndTabComponents(){

    	javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton11, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(109, 390, Short.MAX_VALUE))
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(32, 32, 32)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 806, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel30))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jButton9)
                                            .addComponent(jLabel9))
                                        .addGap(0, 0, Short.MAX_VALUE))))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel1)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jButton4))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jButton8)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jButton3))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel3)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jButton6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 1021, Short.MAX_VALUE)
                        .addComponent(jButton2))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jSeparator2)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(7, 7, 7)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jButton11))
                .addGap(10, 10, 10)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(16, 16, 16)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton4))
                .addGap(17, 17, 17)
                .addComponent(jLabel30)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton9)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel9)
                        .addGap(3, 3, 3)
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel13)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 417, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton8)
                    .addComponent(jButton3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jButton6))
                .addContainerGap())
        );
    }

    private void locateScaledSecondTabComponents(){

    	
    }

    private void initializeSecondTabComponents(){

        //1st setting.
        jLabel2 = (JLabel) JFrameManipulation.newObject( JLabel.class, "1. Select one or more sources for which their documents will be automatically added in the current schema collection: ", JFrameManipulation.tahomaBold13, true, false );

        jButton11 = (JButton) JFrameManipulation.newObject( JButton.class, "Browse", JFrameManipulation.tahomaPlain12, true, true );

        JFileChooser jFileChooser = new JFileChooser();
        jFileChooser.setCurrentDirectory( new File( "src/main/resources/XMLv1/basicSchemas/compositionPattern/complexType/sequence/" ) );
        jFileChooser.setDialogTitle( "Select the folder name that corresonds to a source" );
        jFileChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        jFileChooser.setAcceptAllFileFilterUsed( false );

        jButton11.addActionListener( selectSource( jFileChooser ) );

        jLabel3 = (JLabel) JFrameManipulation.newObject( JLabel.class, "- The schemas contained in the documents of the selected sources are instantiated in the schema representation model:", JFrameManipulation.tahomaPlain12, true, false );

        jTextField2 = (JTextField) JFrameManipulation.newObject( JTextField.class, "undefined", JFrameManipulation.tahomaPlain12, true, false );

        jLabel1 = (JLabel) JFrameManipulation.newObject( JLabel.class, "- (Optional) You can select another schema representation model:", JFrameManipulation.tahomaPlain12, true, false );

        jButton4 = (JButton) JFrameManipulation.newObject( JButton.class, "Transform", JFrameManipulation.tahomaPlain12, false, false );

        jComboBox3 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "undefined", JFrameManipulation.tahomaPlain12, true, false );

        jLabel30 = (JLabel) JFrameManipulation.newObject( JLabel.class, "- (Optional) You can select a subset of the documents of the created collection, otherwise all the documents partcipate in the matching process.", JFrameManipulation.tahomaPlain12, true, true );

        jButton8 = (JButton) JFrameManipulation.newObject( JButton.class, "Visualize selected document", JFrameManipulation.tahomaPlain12, true, false );

        jButton3 = (JButton) JFrameManipulation.newObject( JButton.class, "Add selected document", JFrameManipulation.tahomaPlain12, true, false );

        jButton9 = (JButton) JFrameManipulation.newObject( JButton.class, "Expand Documents", JFrameManipulation.tahomaPlain13, false, false );

        jLabel9 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Collection parsing statistics", JFrameManipulation.tahomaBold11, false, false );

        jLabel10 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jLabel11 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jLabel12 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jLabel13 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jScrollPane1 = (JScrollPane) JFrameManipulation.newObject( JScrollPane.class, "", JFrameManipulation.tahomaPlain13, true, false );

        jSeparator2 = (JSeparator) JFrameManipulation.newObject( JSeparator.class, "", null, true, false );


        jButton6 = (JButton) JFrameManipulation.newObject( JButton.class, "Continue", JFrameManipulation.tahomaPlain13, true, false );

        jButton2 = (JButton) JFrameManipulation.newObject( JButton.class, "Exit", JFrameManipulation.tahomaPlain13, true, true ); jButton2.addActionListener( exit() );
    }

    private void resizeFonts() {//TODO

    	//jTabbedPane1.setFont( new Font( jTabbedPane1.getFont().getFontName(), jTabbedPane1.getFont().getStyle(), ValueScaling.scale( jTabbedPane1.getFont().getSize(), initialDimension, newDimension ) ) );
    }

    private ActionListener exit(){

        return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				System.exit( 0 );
            }
        };
    }

    private ActionListener selectSource( final JFileChooser jFileChooser ){

        return new ActionListener(){

            public void actionPerformed( ActionEvent actionEvent ){

            	int retval = jFileChooser.showOpenDialog( schemaRegistrationVisualizer );

            	if( retval == JFileChooser.APPROVE_OPTION ) {
		
            		File source = jFileChooser.getSelectedFile();
		
            		String ref2Source = source.getAbsolutePath();


            		schemaRegistration = SchemaRegistrationController.register( ref2Source, schemaRegistration );


            		Integer collectionID = SchemaRegistrationController.getCurrentCollectionID( schemaRegistration ); System.out.println( "Collection ID = " + collectionID );


            		setTextOf2ndTabComponents( collectionID );
            		

            		List<String> refs2DocsOfSchema = getRefs2DocsOfSchemas( collectionID );

            		if( userSettings == null ) userSettings = new UserSettings();

            		userSettings.setRefs2DocsOfSchema( refs2DocsOfSchema );


            		JFrameManipulation.enable( jButton6, true ); jButton6.addActionListener( continueConfiguration() );

            		getRootPane().setDefaultButton( jButton6 ); InputMap im = jButton6.getInputMap(); im.put( KeyStroke.getKeyStroke( "ENTER" ), "pressed" ); im.put( KeyStroke.getKeyStroke( "released ENTER" ), "released" );
            	}
        	}
    	};
    }

    private void setTextOf2ndTabComponents( Integer collectionID ){

    	DefaultMutableTreeNode root = SchemaRegistrationController.visualize( schemaRegistration, true );

    	JTree jTree = new JTree( root );

    	JFrameManipulation.setJScrollPane( jScrollPane1, jTree, root, 4 );


        int numOfParsedDocOfSchemaDocs = SchemaRegistrationController.getNumOfParsedSchemaDocs( schemaRegistration );

        double duration = SchemaRegistrationController.getDuration( schemaRegistration );

        double size = SchemaRegistrationController.getSize( schemaRegistration );

        double depth = 0.0;

    	JFrameManipulation.setLabel( jLabel10, "1. Number of schema documents: " + numOfParsedDocOfSchemaDocs );
    	JFrameManipulation.setLabel( jLabel11, "2. Avg parsing duration: " + ElapsedTimeCalculator.getTime( duration ) );
    	JFrameManipulation.setLabel( jLabel12, "3. Avg document size: " + RoundingNumber.roundHalfDown( size ) );
    	JFrameManipulation.setLabel( jLabel13, "4. Avg depth of components: " + depth );


        jTree.addTreeSelectionListener( selectDocument( numOfParsedDocOfSchemaDocs ) );

    	JFrameManipulation.enable( jButton9, true ); jButton9.addActionListener( expandDocuments( jTree, root ) );


    	String primarySchemaRepresentationModel = setSchemaRepresentationModel( collectionID );

    	setSecondarySchemaRepresentationModels( collectionID, primarySchemaRepresentationModel );


    	JFrameManipulation.makeVisible( jButton5, true, false );

    	JFrameManipulation.makeVisible( jButton9, true );

    	JFrameManipulation.makeVisible( jLabel9, true );

    	JFrameManipulation.enable( jTextField17, true );

    	JFrameManipulation.enable( jButton5, true );

    	JFrameManipulation.enable( jComboBox3, true );


		setSchemaElementKinds( numOfParsedDocOfSchemaDocs );

		setFrequencyValues( numOfParsedDocOfSchemaDocs );
    }

    private List<String> getRefs2DocsOfSchemas( Integer collectionID ){

    	return collectionID != null ? SchemaRegistrationController.getRefs2DocsOfSchemas( schemaRegistration, collectionID ) : null;
    }

    private String setSchemaRepresentationModel( Integer collectionID ){

    	String schemaRepresentationModel = collectionID != null ? SchemaRegistrationController.getSchemaRepresentationModel( schemaRegistration, collectionID ) : null;

    	if( schemaRepresentationModel == null ) JFrameManipulation.setLabel( jTextField2, "undefined" );

    	else{

    		JFrameManipulation.setLabel( jTextField2, schemaRepresentationModel );

        	JFrameManipulation.enable( jTextField2, false );
    	}


    	return schemaRepresentationModel;
    }

    private void setSecondarySchemaRepresentationModels( Integer collectionID, String primarySchemaRepresentationModel ){

    	String[] secondarySchemaRepresentationModels = null;//To retrieve them.

    	if( primarySchemaRepresentationModel != null ){

    		//To retrieve them.
    	}


    	JFrameManipulation.setLabel( jComboBox3, ArrayTransformations.concat( secondarySchemaRepresentationModels, primarySchemaRepresentationModel ) );
    }

    private void setSchemaElementKinds( int numOfParsedDocOfSchemaDocs ){

    	String[] tagNames = SchemaRepresentationController.getTagNames( jTextField2.getText() );


    	JFrameManipulation.setLabel( jComboBox2, tagNames );

    	JFrameManipulation.enable( jComboBox2, true );


    	JFrameManipulation.setLabel( jComboBox6, tagNames );

    	JFrameManipulation.enable( jComboBox6, true );
    }

    private void setFrequencyValues( int numOfSelectedRefs2SchemaDocs ){

    	String[] frequencyValues = null;

    	frequencyValues = ArrayInstantiation.newStringArray( numOfSelectedRefs2SchemaDocs - 1 );

    	for( int i = numOfSelectedRefs2SchemaDocs; frequencyValues != null && i > 1; --i ) frequencyValues[ numOfSelectedRefs2SchemaDocs - i ] = Integer.toString( i );

    	JFrameManipulation.setLabel( jComboBox21, frequencyValues, false, true );
    }


    private TreeSelectionListener selectDocument( final int numOfParsedDocOfSchemaDocs ){

        return new TreeSelectionListener(){

        	public void valueChanged( TreeSelectionEvent treeSelectionEvent ){

        		TreePath path = treeSelectionEvent.getPath();

        		if( path != null ){

        			int pathCount = path.getPathCount();

            		if( pathCount < 1 || pathCount > 5 ){

            			String selectedCollectionID = path.getPathComponent( 1 ).toString(); selectedCollectionID = Tokenizer.getSuffix( selectedCollectionID, " " );

            			Integer collectionID = SchemaRegistrationController.getCurrentCollectionID( schemaRegistration );


            			if( collectionID == null ) PrintMessages.print( "SchemaRegistrationVisualizer: The identifier of the current collection is null." );

            			else if( ! collectionID.equals( Integer.parseInt( selectedCollectionID ) ) ) PrintMessages.print( "SchemaRegistrationVisualizer: The identifiers of the current and the selected collection are not the same." );

            			else{

            				String selectedRef2Source = path.getPathComponent( 3 ).toString();

            				String selectedRef2DocOfSchema = path.getPathComponent( 5 ).toString();


            				setSelectedDocOfSchemaStatistics( selectedCollectionID, selectedRef2Source, selectedRef2DocOfSchema );


            				JFrameManipulation.enable( jButton8, true ); JFrameManipulation.removeButtonActionListeners( jButton8 ); jButton8.addActionListener( visualizeSelectedDocument( collectionID, selectedRef2Source, selectedRef2DocOfSchema ) );


            				List<String> selectedRefs2DocsOfSchema = userSettings.getRefs2DocsOfSchema();

            				if( selectedRefs2DocsOfSchema != null && selectedRefs2DocsOfSchema.size() == numOfParsedDocOfSchemaDocs ){

            					selectedRefs2DocsOfSchema = null;

            					userSettings.resetRefs2DocsOfSchema();
            				}


            				if( ! ListGetters.belongsTo( selectedRef2DocOfSchema, selectedRefs2DocsOfSchema ) ){

            					JFrameManipulation.enable( jButton3, true );

            					JFrameManipulation.removeButtonActionListeners( jButton3 );

            					jButton3.addActionListener( selectDocOfSchema( selectedRef2DocOfSchema ) );
            				}

            				else JFrameManipulation.enable( jButton3, false );
            			}
            		}

            		else{

            			JFrameManipulation.enable( jButton8, false );

            			JFrameManipulation.enable( jButton3, false );
            		}
        		}
        	}
        };
    }

    private void setSelectedDocOfSchemaStatistics( String collectionID, String ref2Source, String ref2DocOfSchema ){

    	double size = 0.0, depth = 0.0, duration = SchemaRegistrationController.getDuration( schemaRegistration, Integer.parseInt( collectionID ), ref2Source, ref2DocOfSchema );


    	jLabel9.setText( "Selected schema document statistics" );
    	jLabel10.setText( "1. Avg parsing duration: " + ElapsedTimeCalculator.getTime( duration ) );
    	jLabel11.setText( "2. Avg document size (#components): " + size );
    	jLabel12.setText( "3. Avg depth of components: " + depth );

    	JFrameManipulation.makeVisible( jLabel13, false );
    }

    private ActionListener selectDocOfSchema( final String selectedRef2DocOfSchema ){

        return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				JFrameManipulation.enable( jButton3, false );

				userSettings.addRef2DocOfSchema( selectedRef2DocOfSchema ); PrintMessages.stdPrintLn( PrintMessages.schemaRegistrationPrint, "SchemaRegistrationVisualizer: selectedRef2DocOfSchema = " + selectedRef2DocOfSchema );

				setFrequencyValues( userSettings.getRefs2DocsOfSchema().size() );

				//TODO: to set the element kinds that exist in the selected schema documents.
            }
        };
    }

    private ActionListener expandDocuments( final JTree jTree, final DefaultMutableTreeNode root ){

        return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				JFrameManipulation.enable( jButton9, false );

				JFrameManipulation.setJScrollPane( jScrollPane1, jTree, root );
            }
        };
    }

    private ActionListener visualizeSelectedDocument( final Integer collectionID, final String ref2Source, final String ref2DocOfSchemas ){

        return new ActionListener(){

            public void actionPerformed( ActionEvent actionEvent ){

            	Object docOfSchemas = SchemaRegistrationController.lookUp( schemaRegistration, collectionID, ref2Source, ref2DocOfSchemas );


            	if( ! SchemaRepresentationController.hasConstraintViolation( docOfSchemas ) ){

                    double duration = SchemaRepresentationController.getDuration( docOfSchemas );

                    int size = SchemaRepresentationController.getSize( docOfSchemas );

                    double depth = 0.0;

                    double memory = SchemaRepresentationController.getMemory( docOfSchemas );


    				if( documentVisualizer == null ) documentVisualizer = new DocumentVisualizer( ref2Source, ref2DocOfSchemas, ElapsedTimeCalculator.getTime( duration ), String.valueOf( size ), String.valueOf( depth ), MemoryConsumption.print( memory ), SchemaRepresentationController.visualize( docOfSchemas ), 4 );

    				else documentVisualizer.setTextOfComponentsForSchemaDocuments( ref2DocOfSchemas, ElapsedTimeCalculator.getTime( duration ), String.valueOf( size ), String.valueOf( depth ), MemoryConsumption.print( memory ), SchemaRepresentationController.visualize( docOfSchemas ), 4 );
    			}

    			else{

    				if( documentVisualizer == null ) documentVisualizer = new DocumentVisualizer( ref2Source, ref2DocOfSchemas, SchemaRepresentationController.getConstraintViolation( docOfSchemas ) );

    				else documentVisualizer.setTextOfComponentsForSchemaDocuments( ref2DocOfSchemas, SchemaRepresentationController.getConstraintViolation( docOfSchemas ) );
    			}
            }
        };
    }

    private ActionListener continueConfiguration(){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				List<String> refs2Docs2OfSchema = userSettings != null ? userSettings.getRefs2DocsOfSchema() : null;

				if( refs2Docs2OfSchema == null || ( refs2Docs2OfSchema != null && refs2Docs2OfSchema.size() == 1 ) ) PrintMessages.print( "You must select at least 2 schema documents." );

				else{

					userSettings.setTargetSchemaRepresentationModel( (String) jComboBox3.getSelectedItem() );


					disable1stSetting();

			    	disable2ndSetting();


			    	Integer collectionID = SchemaRegistrationController.getCurrentCollectionID( schemaRegistration );

					Object[] docsOfSchema = retrieveDocsOfSchemas( collectionID, refs2Docs2OfSchema );

					userSettings.setDocsOfSchema( docsOfSchema );


					jTabbedPane1.setSelectedComponent( jPanel4 );

					getRootPane().setDefaultButton( jButton17 ); InputMap im = jButton17.getInputMap(); im.put( KeyStroke.getKeyStroke( "ENTER" ), "pressed" ); im.put( KeyStroke.getKeyStroke( "released ENTER" ), "released" );
				}
			}
		};
    }

    private void disable1stSetting(){

    	JFrameManipulation.enable( jButton11, false );
    	
    	JFrameManipulation.enable( jComboBox3, false );

    	JFrameManipulation.enable( jButton3, false );

    	JFrameManipulation.enable( jButton4, false );

    	JFrameManipulation.enable( jButton8, false );

    	JFrameManipulation.enable( jScrollPane1, false );
    }

    private Object[] retrieveDocsOfSchemas( Integer collectionID, List<String> refs2DocsOfSchema ){

    	Object[] docsOfSchema = null;


    	for( int i = 0; refs2DocsOfSchema != null && i < refs2DocsOfSchema.size(); ++i ){

			Object docOfSchemas = SchemaRegistrationController.lookUp( schemaRegistration, collectionID, refs2DocsOfSchema.get( i ) );

			if( docOfSchemas != null ){

				if( docsOfSchema == null ) docsOfSchema = new Object[ refs2DocsOfSchema.size() ];

				docsOfSchema[ i ] = docOfSchemas;
			}
    	}

    	return docsOfSchema;
    }


	//****************** Third Tab ******************
    private void locateThirdTabComponents(){

    	javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel36)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel51)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jRadioButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jRadioButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jCheckBox1))
                    .addComponent(jSeparator5)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel40)
                                            .addGap(50, 50, 50)
                                            .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, 295, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel41)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                .addGroup(jPanel4Layout.createSequentialGroup()
                                                    .addComponent(jTextField17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addGap(18, 18, 18)
                                                    .addComponent(jLabel43)
                                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                    .addComponent(jComboBox7, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                                .addComponent(jComboBox6, javax.swing.GroupLayout.PREFERRED_SIZE, 295, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                    .addComponent(jLabel42))
                                .addGap(186, 186, 186)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jCheckBox8)
                                    .addComponent(jCheckBox7)
                                    .addComponent(jButton5)))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(4, 4, 4)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addGap(3, 3, 3)
                                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                    .addComponent(jComboBox10, javax.swing.GroupLayout.Alignment.TRAILING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                    .addComponent(jComboBox21, javax.swing.GroupLayout.Alignment.TRAILING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                    .addComponent(jComboBox9, javax.swing.GroupLayout.Alignment.TRAILING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                    .addComponent(jComboBox8, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                .addGroup(jPanel4Layout.createSequentialGroup()
                                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jLabel46)
                                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                                            .addGap(10, 10, 10)
                                                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                .addComponent(jLabel37)
                                                                .addComponent(jLabel38)
                                                                .addComponent(jLabel45)
                                                                .addComponent(jLabel54)
                                                                .addComponent(jLabel28)
                                                                .addComponent(jLabel26))))
                                                    .addGap(222, 222, 222)
                                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                        .addComponent(jComboBox16, javax.swing.GroupLayout.Alignment.TRAILING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(jComboBox5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addComponent(jLabel47)
                                                .addGroup(jPanel4Layout.createSequentialGroup()
                                                    .addGap(10, 10, 10)
                                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(jLabel44)
                                                        .addComponent(jLabel39)
                                                        .addComponent(jLabel48)
                                                        .addComponent(jLabel4)
                                                        .addComponent(jLabel52)
                                                        .addComponent(jLabel53)
                                                        .addComponent(jLabel32)
                                                        .addComponent(jLabel33))))
                                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addGroup(jPanel4Layout.createSequentialGroup()
                                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                                            .addComponent(jComboBox15, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                            .addComponent(jComboBox17, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                            .addComponent(jComboBox14, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                            .addComponent(jComboBox13, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE))
                                                        .addComponent(jComboBox18, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                                .addGroup(jPanel4Layout.createSequentialGroup()
                                                    .addGap(294, 294, 294)
                                                    .addComponent(jComboBox11, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                    .addGap(0, 0, Short.MAX_VALUE))))
                                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jComboBox19, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addComponent(jLabel49)
                                    .addComponent(jLabel5)))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(4, 4, 4)
                                .addComponent(jLabel34)
                                .addGap(18, 18, 18)
                                .addComponent(jComboBox12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(0, 99, Short.MAX_VALUE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jButton17)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton18)))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel36)
                    .addComponent(jLabel51)
                    .addComponent(jRadioButton1)
                    .addComponent(jRadioButton2)
                    .addComponent(jCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel40)
                            .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel41)
                            .addComponent(jComboBox6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jCheckBox7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jCheckBox8)
                        .addGap(3, 3, 3)))
                .addGap(5, 5, 5)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel42)
                    .addComponent(jTextField17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel43)
                    .addComponent(jComboBox7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton5))
                .addGap(9, 9, 9)
                .addComponent(jSeparator5, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(3, 3, 3)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel34)
                    .addComponent(jComboBox12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel46)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel37)
                    .addComponent(jComboBox5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel38)
                    .addComponent(jComboBox16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(4, 4, 4)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel45)
                    .addComponent(jComboBox8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel54))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel28)
                    .addComponent(jComboBox21, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel26))
                .addGap(18, 18, 18)
                .addComponent(jLabel47)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel39)
                    .addComponent(jComboBox13, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jComboBox14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel44))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel48)
                    .addComponent(jComboBox17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addGap(18, 18, 18)
                .addComponent(jLabel49)
                .addGap(10, 10, 10)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel52)
                    .addComponent(jComboBox18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel53)
                    .addComponent(jComboBox19, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel32))
                .addGap(18, 18, 18)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel33)
                    .addComponent(jComboBox11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 112, Short.MAX_VALUE)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton17)
                    .addComponent(jButton18))
                .addContainerGap())
        );
    }

    private void initializeThirdTabComponents(){

    	//2nd setting.
        jLabel36 = (JLabel) JFrameManipulation.newObject( JLabel.class, "2. Provide rules for similar concrete-element kinds:", JFrameManipulation.tahomaBold13, true, false );

        jLabel51 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Element category:", JFrameManipulation.tahomaPlain12, true, false );

        jRadioButton1 = (JRadioButton) JFrameManipulation.newObject( JRadioButton.class, "component", JFrameManipulation.tahomaPlain12, true, false );

        jRadioButton2 = (JRadioButton) JFrameManipulation.newObject( JRadioButton.class, "structure", JFrameManipulation.tahomaPlain12, true, false );

        jLabel40 = (JLabel) JFrameManipulation.newObject( JLabel.class, "First element kind = ", JFrameManipulation.tahomaPlain11, true, false );

        jLabel41 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Second element kind = ", JFrameManipulation.tahomaPlain11, true, false );

        jLabel42 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Similarity value = ", JFrameManipulation.tahomaPlain11, true, false );

        jLabel43 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Quantitative value:", JFrameManipulation.tahomaPlain11, true, false );

        jComboBox7 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, true, false );

        jTextField17 = (JTextField) JFrameManipulation.newObject( JTextField.class, "<enter your value>", JFrameManipulation.tahomaPlain11, true, false ); jTextField17.getDocument().addDocumentListener( writeSimilarityValue() );

        jComboBox2 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "undefined", JFrameManipulation.tahomaPlain11, true, false );

        jComboBox6 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "undefined", JFrameManipulation.tahomaPlain11, true, false );

        jCheckBox5 = (JCheckBox) JFrameManipulation.newObject( JCheckBox.class, "is declaration", JFrameManipulation.tahomaPlain11, true, true );

        jCheckBox6 = (JCheckBox) JFrameManipulation.newObject( JCheckBox.class, "has built-in type", JFrameManipulation.tahomaPlain11, true, true );

        jCheckBox7 = (JCheckBox) JFrameManipulation.newObject( JCheckBox.class, "is declaration", JFrameManipulation.tahomaPlain11, true, true );

        jCheckBox8 = (JCheckBox) JFrameManipulation.newObject( JCheckBox.class, "has built-in type", JFrameManipulation.tahomaPlain11, true, true );

        jButton5 = (JButton) JFrameManipulation.newObject( JButton.class, "Add Rule", JFrameManipulation.tahomaPlain11, false, false ); jButton5.addActionListener( addRule() );

        jSeparator5 = (JSeparator) JFrameManipulation.newObject( JSeparator.class, "", null, true, false );


        //3rd setting.
        jLabel34 = (JLabel) JFrameManipulation.newObject( JLabel.class, "3. Select the type of the matching-generation algorithm:", JFrameManipulation.tahomaBold13, true, false );

        jComboBox12 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, MatchingController.getMatcherKinds(), JFrameManipulation.tahomaPlain12, true, true ); jComboBox12.addActionListener( selectMatcherKind() );


        jLabel5 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaBold11, false, false );

        jLabel33 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox11 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );


        jLabel46 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaBold11, false, false );

        jLabel37 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox5 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel38 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox16 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel45 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox8 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel54 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox10 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel28 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox21 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel26 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox9 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel4 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox15 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );


        jLabel47 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaBold11, false, false );

        jLabel39 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox13 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel44 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox14 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel48 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox17 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );


        jLabel49 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaBold11, false, false );

        jLabel52 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox18 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jLabel53 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox19 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );


        jLabel32 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

        jComboBox4 = (JComboBox<?>) JFrameManipulation.newObject( JComboBox.class, "", JFrameManipulation.tahomaPlain11, false, true );

        jSeparator1 = (JSeparator) JFrameManipulation.newObject( JSeparator.class, "", null, true, false );


        jCheckBox1 = (JCheckBox) JFrameManipulation.newObject( JCheckBox.class, "Export log file?", JFrameManipulation.tahomaPlain13, true, true ); JFrameManipulation.setValue( jCheckBox1, true );


        jButton17 = (JButton) JFrameManipulation.newObject( JButton.class, "Go to the Matching Process", JFrameManipulation.tahomaPlain13, true, true ); jButton17.addActionListener( goToTheMtchingProcessTab() );


        jButton18 = (JButton) JFrameManipulation.newObject( JButton.class, "Exit", JFrameManipulation.tahomaPlain13, true, true ); jButton18.addActionListener( exit() );
    }

    //2nd Setting.
    private DocumentListener writeSimilarityValue(){

        return new DocumentListener(){

			public void changedUpdate( DocumentEvent e ) { enable(); }

			public void insertUpdate( DocumentEvent e ) { enable(); }

			public void removeUpdate( DocumentEvent e ) { enable(); }

			private void enable() {

				JFrameManipulation.enable( jButton5, true );
			  }
        };
    }

    private ActionListener addRule(){

        return new ActionListener(){

            @SuppressWarnings("deprecation")
			public void actionPerformed( ActionEvent actionEvent ){

                String elementKind1 = (String) jComboBox2.getSelectedItem();

                boolean elementKindIsDecl1 = jCheckBox5.isSelected();

                boolean elementKindHasBuiltInType1 = jCheckBox6.isSelected();


                String elementKind2 = (String) jComboBox6.getSelectedItem();

                boolean elementKindIsDecl2 = jCheckBox7.isSelected();

                boolean elementKindHasBuiltInType2 = jCheckBox8.isSelected();


                String similarityValue = (String) jTextField17.getText();


                if( elementKind1.equals( elementKind2 ) && elementKindIsDecl1 == elementKindIsDecl2 && elementKindHasBuiltInType1 == elementKindHasBuiltInType2 ) PrintMessages.print( "It does not have meaning to be the first and second element kind the same!\nPlease select another first or second element kind." );

                else{

                	if( ! NumberCheck.isNumber( similarityValue ) && ! jComboBox7.isEnabled() ){

                		PrintMessages.print( "You just provided a qualitative similarity value.\nPlease select a corresponding quantitative value." );

                		JFrameManipulation.enable( jComboBox7, true );
                	}

                	else{

                		String quantitativeSimilarityValue = jComboBox7.isEnabled() ? (String) jComboBox7.getSelectedItem() : null; System.out.println( "quantitativeSimilarityValue = " + quantitativeSimilarityValue );


                		String schemaRepresentationModel = jTextField2.getText();

                		String category = jRadioButton1.isSelected() ? jRadioButton1.getLabel() : jRadioButton2.getLabel();

                		Object rule = quantitativeSimilarityValue != null ? SchemaRepresentationController.newRule( schemaRepresentationModel, category, elementKind1, elementKindIsDecl1, elementKindHasBuiltInType1, elementKind2, elementKindIsDecl2, elementKindHasBuiltInType2, similarityValue, quantitativeSimilarityValue ) : SchemaRepresentationController.newRule( schemaRepresentationModel, category, elementKind1, elementKindIsDecl1, elementKindHasBuiltInType1, elementKind2, elementKindIsDecl2, elementKindHasBuiltInType2, similarityValue ); 

                		userSettings.addSimilarityRuleForElementKinds( rule );


                		JFrameManipulation.enable( jComboBox7, false );

                		JFrameManipulation.setLabel( jTextField17, "" );

                		JFrameManipulation.enable( jButton5, false );

                		disable1stSetting();
                	}
                }
            }
        };
    }

    private void disableSettings(){

    	disable1stSetting();

    	disable2ndSetting();

    	disable3thSetting();

    	disable4thSetting();

    	disable6thSetting();

    	disable7thSetting();
    }

    private void disable2ndSetting(){

    	JFrameManipulation.enable( jTextField17, false );

    	JFrameManipulation.enable( jComboBox2, false );

    	JFrameManipulation.enable( jComboBox6, false );

    	JFrameManipulation.enable( jCheckBox5, false );

    	JFrameManipulation.enable( jCheckBox6, false );

    	JFrameManipulation.enable( jCheckBox7, false );

    	JFrameManipulation.enable( jCheckBox8, false );
    }

    private void disable3thSetting(){

    	JFrameManipulation.enable( jComboBox2, false );
    }

    private void disable4thSetting(){

    	JFrameManipulation.enable( jComboBox6, false );
    }

    private void disable6thSetting(){

    	JFrameManipulation.enable( jComboBox7, false );

    	JFrameManipulation.enable( jButton5, false );
    }

    private void disable7thSetting(){

    	JFrameManipulation.enable( jComboBox8, false );
    }

    private ActionListener selectMatcherKind(){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				/*String[] dataStructureKinds = MatchingController.getDataStructureKinds( (String) jComboBox12.getSelectedItem() );

		        boolean visible = dataStructureKinds != null ? true : false;

		        JFrameManipulation.makeVisible( jLabel33, visible );

		        JFrameManipulation.makeVisible( jComboBox11, visible );*///TODO


				List<Object> userOptionLabels = ListInstantiation.newList();

				Map<Object, Object[]> userOptions  = MapInstantiation.newMapOfArrays();//The first is identical with the label stored in the previous list, 'userOptionLabels'!

				MatchingController.getAlternativeUserOptions( (String) jComboBox12.getSelectedItem(), userOptionLabels, userOptions );

				setAlternativeUserOptions( userOptionLabels, userOptions );
			}
		};
    }

    private void setAlternativeUserOptions( List<Object> optionLabels, Map<Object, Object[]> options ){

    	String label = optionLabels != null ? (String) optionLabels.get( 0 ) : null;

    	String[] optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ) JFrameManipulation.setLabel( jLabel46, label );


        label = optionLabels != null ? (String) optionLabels.get( 1 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel37, label );

        	JFrameManipulation.setLabel( jComboBox5, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 2 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel38, label );

        	JFrameManipulation.setLabel( jComboBox16, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 3 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel45, label );

        	JFrameManipulation.setLabel( jComboBox8, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 4 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel54, label );

        	JFrameManipulation.setLabel( jComboBox10, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 5 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel28, label );

        	JFrameManipulation.makeVisible( jComboBox21, true );
        }


        label = optionLabels != null ? (String) optionLabels.get( 6 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel26, label );

        	JFrameManipulation.setLabel( jComboBox9, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 7 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel4, label );

        	JFrameManipulation.setLabel( jComboBox15, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 8 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ) JFrameManipulation.setLabel( jLabel47, label );


        label = optionLabels != null ? (String) optionLabels.get( 9 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel39, label );

        	JFrameManipulation.setLabel( jComboBox13, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 10 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel44, label );

        	JFrameManipulation.setLabel( jComboBox14, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 11 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel48, label );

        	JFrameManipulation.setLabel( jComboBox17, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 12 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ) JFrameManipulation.setLabel( jLabel49, label );


        label = optionLabels != null ? (String) optionLabels.get( 13 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel52, label );

        	JFrameManipulation.setLabel( jComboBox18, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 14 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel53, label );

        	JFrameManipulation.setLabel( jComboBox19, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 15 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel32, label );

        	JFrameManipulation.setLabel( jComboBox4, optionsOfALabel );
        }


        label = optionLabels != null ? (String) optionLabels.get( 16 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ) JFrameManipulation.setLabel( jLabel5, label );


        label = optionLabels != null ? (String) optionLabels.get( 17 ) : null;

    	optionsOfALabel = options != null ? (String[]) MapGetter.getValueOfMapOfArrays( label, options ) : null;

        if( label != null ){

        	JFrameManipulation.setLabel( jLabel33, label );

        	JFrameManipulation.setLabel( jComboBox11, optionsOfALabel );
        }
    }

    private ActionListener goToTheMtchingProcessTab(){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				disableSettings();


				jTabbedPane1.setSelectedComponent( jPanel5 );

				getRootPane().setDefaultButton( jButton13 ); InputMap im = jButton13.getInputMap(); im.put( KeyStroke.getKeyStroke( "ENTER" ), "pressed" ); im.put( KeyStroke.getKeyStroke( "released ENTER" ), "released" );
			}
		};
    }


    //****************** Fourth Tab ******************
    private void locateFourthTabComponents(){

    	javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel17)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jLabel18)
                                .addGap(18, 18, 18)
                                .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addComponent(jButton13)
                                .addGap(18, 18, 18)
                                .addComponent(jButton1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jButton12)))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                        .addGap(30, 30, 30)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addComponent(jLabel14)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel15)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jLabel25)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel5Layout.createSequentialGroup()
                                    .addComponent(jLabel7)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGap(18, 18, 18)
                                    .addComponent(jLabel8)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addComponent(jLabel27)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel6)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 531, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel19, javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel5Layout.createSequentialGroup()
                                .addComponent(jLabel20)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel22)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel5Layout.createSequentialGroup()
                                .addComponent(jLabel21)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel29)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel5Layout.createSequentialGroup()
                                .addComponent(jLabel31)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel35)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 532, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(58, Short.MAX_VALUE))))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel17)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel18)
                    .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel19)
                    .addComponent(jLabel25))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel20)
                    .addComponent(jLabel27)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6)
                    .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel22)
                    .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel7)
                        .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel8)
                        .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel21)
                        .addComponent(jTextField12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel29)
                        .addComponent(jTextField14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(jTextField9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel15)
                    .addComponent(jTextField10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel31)
                    .addComponent(jTextField15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel35)
                    .addComponent(jTextField16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 457, Short.MAX_VALUE)
                        .addGap(18, 18, 18))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jScrollPane3)
                        .addGap(18, 18, 18)))
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton12)
                    .addComponent(jButton13)
                    .addComponent(jButton1))
                .addContainerGap())
        );
    }

    private void initializeFourthTabComponents(){

    	jLabel17 = (JLabel) JFrameManipulation.newObject( JLabel.class, "The schema matching process has been successufully configured.", JFrameManipulation.tahomaBold14, true, false );

    	jLabel18 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaBold13, true, false );

    	jLabel25 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaBold12, true, false );


    	jProgressBar1 = (JProgressBar) JFrameManipulation.newObject( JProgressBar.class, "0", JFrameManipulation.tahomaBold12, false, false );


    	jLabel27 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField1 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel6 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField6 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel7 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField7 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel8 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField8 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel14 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField9 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel15 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField10 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel29 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Construction duration:", JFrameManipulation.tahomaPlain11, false, false );

    	jLabel31 = (JLabel) JFrameManipulation.newObject( JLabel.class, "xx", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel21 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Generation duration:", JFrameManipulation.tahomaPlain11, false, false );

    	jLabel22 = (JLabel) JFrameManipulation.newObject( JLabel.class, "jLabel22", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel19 = (JLabel) JFrameManipulation.newObject( JLabel.class, "Generated singleton patterns.", JFrameManipulation.tahomaBold12, false, false );


    	jLabel20 = (JLabel) JFrameManipulation.newObject( JLabel.class, "#patterns:", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField11 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel22 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField13 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );
    	

    	jLabel21 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField12 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel29 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField14 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel31 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField15 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jLabel35 = (JLabel) JFrameManipulation.newObject( JLabel.class, "", JFrameManipulation.tahomaPlain11, false, false );

    	jTextField16 = (JTextField) JFrameManipulation.newObject( JTextField.class, "", JFrameManipulation.tahomaPlain11, false, false );


    	jScrollPane2 = (JScrollPane) JFrameManipulation.newObject( JScrollPane.class, "", JFrameManipulation.tahomaPlain13, true, false );

    	jScrollPane3 = (JScrollPane) JFrameManipulation.newObject( JScrollPane.class, "", JFrameManipulation.tahomaPlain13, false, false );


    	jButton13 = (JButton) JFrameManipulation.newObject( JButton.class, "Start the Matching Process", JFrameManipulation.tahomaPlain13, true, true ); jButton13.addActionListener( initializeMatching() );//Continue with the next Phase

    	jButton1 = (JButton) JFrameManipulation.newObject( JButton.class, "Open Log File", JFrameManipulation.tahomaPlain13, true, false );

    	jButton12 = (JButton) JFrameManipulation.newObject( JButton.class, "Exit", JFrameManipulation.tahomaPlain13, true, true ); jButton12.addActionListener( exit() );
    }

    private ActionListener openLogFile( final Object matcher ){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				MatchingController.openLogFile( matcher );


				getRootPane().setDefaultButton( jButton12 ); InputMap im = jButton12.getInputMap(); im.put( KeyStroke.getKeyStroke( "ENTER" ), "pressed" ); im.put( KeyStroke.getKeyStroke( "released ENTER" ), "released" );
			}
		};
    }

    private ActionListener initializeMatching(){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				JFrameManipulation.setLabel( jLabel17, "Results of the matching generation algorithm:" );

				JFrameManipulation.makeVisible( jProgressBar1, true );


				final String matcherKind = (String) jComboBox12.getSelectedItem();

				JFrameManipulation.setLabel( jLabel18, MatchingController.getStartPhase( matcherKind ) );


				double patternConfidenceThreshold = Double.parseDouble( (String) jComboBox9.getSelectedItem() ); userSettings.setPatternConfidenceThreshold( patternConfidenceThreshold );

				double correspondenceConfidenceThreshold = Double.parseDouble( (String) jComboBox15.getSelectedItem() ); userSettings.setCorrespondenceConfidenceThreshold( correspondenceConfidenceThreshold );


				Integer minFrequency = Integer.parseInt( (String) jComboBox21.getSelectedItem() ); userSettings.setMinimumFrequency( minFrequency );


				//Structural-pattern confidence.
				userSettings.setOption( jLabel54.getText(), Double.parseDouble( (String) jComboBox10.getSelectedItem() ) );


				//Matching pattern instantiations.
				userSettings.setOption( jLabel53.getText(), jComboBox19.getSelectedItem() );

				Integer k = null;

				try{ k = Integer.parseInt( (String) jComboBox4.getSelectedItem() ); }

				catch( Exception ex ){ k = Integer.MAX_VALUE; }
				
				userSettings.setTopK( k );


				String concreteElementsDataStructureKind = (String) jComboBox11.getSelectedItem(); userSettings.setSchemaElementsDataStructureKind( concreteElementsDataStructureKind );

				userSettings.setInteractiveMatchingProcess( true );


				final Thread thread = new Thread( new Runnable(){

					public void run(){

						JFrameManipulation.enable( jButton13, false );

						boolean logFile = jCheckBox1.isSelected();

						PrintMessages.addPrintKind( PrintMessages.matchingPrint, logFile );


						String singleRef2Source = null;

						if( logFile ){

							singleRef2Source = SchemaRegistrationController.getSingleRef2Source( schemaRegistration );

							System.out.println( "singleRef2Source = " + singleRef2Source );
						}


						Object matcher = singleRef2Source != null ? MatchingController.newMatcher( matcherKind, userSettings, jLabel18, jProgressBar1, singleRef2Source ) : MatchingController.newMatcher( matcherKind, userSettings, jLabel18, jProgressBar1 );

						jButton1.addActionListener( openLogFile( matcher ) );


						setStatistics( matcher );


						JFrameManipulation.setLabel( jButton13, "Continue with the next Phase: \"" + MatchingController.getNextPhase( matcher ) + "\"" ); JFrameManipulation.enable( jButton13, true );

						JFrameManipulation.removeButtonActionListeners( jButton13 );

						jButton13.addActionListener( continueMatching( matcher ) );


						JFrameManipulation.makeVisible( jProgressBar1, false );


						System.gc();
					}
				});


				thread.setPriority( Thread.MAX_PRIORITY ); thread.start();
			}
		};
    }

    private void setStatistics( Object matcher ){

    	String currentPhase = MatchingController.getCurrentPhase( matcher );

		JFrameManipulation.setLabel( jLabel18, currentPhase );


		MatcherStatistics matcherStatistics = MatchingController.getStatistics( matcher );


    	setFirstStatisticKind( currentPhase, matcherStatistics );

    	setSecondStatisticKind( currentPhase, matcherStatistics );
    }

    private void setFirstStatisticKind( String currentPhase, MatcherStatistics matcherStatistics ){

    	String statisticKind = matcherStatistics != null ? (String) matcherStatistics.getStatisticKind( currentPhase, 1 ) : null;

    	JFrameManipulation.setLabel( jLabel25, statisticKind );


 		Object[] statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 0 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel27, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField1, (String) statistic[ 1 ] );
	    }

	    statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 1 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel6, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField6, (String) statistic[ 1 ] );
	    }

	    statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 2 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel7, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField7, (String) statistic[ 1 ] );
	    }


		DefaultMutableTreeNode root = matcherStatistics != null ? (DefaultMutableTreeNode) matcherStatistics.getVisualizedStatistic( currentPhase, statisticKind ) : null;

		JTree jTree = root != null ? new JTree( root ) : null;

	    JFrameManipulation.setJScrollPane( jScrollPane2, jTree, root, 2 );
    }

    private void setSecondStatisticKind( String currentPhase, MatcherStatistics matcherStatistics ){

    	String statisticKind = matcherStatistics != null ? (String) matcherStatistics.getStatisticKind( currentPhase, 2 ) : null;

    	JFrameManipulation.setLabel( jLabel19, statisticKind );


 		Object[] statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 0 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel20, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField11, (String) statistic[ 1 ] );
	    }

	    statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 1 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel22, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField13, (String) statistic[ 1 ] );
	    }

	    statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 2 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel21, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField12, (String) statistic[ 1 ] );
	    }

	    statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 3 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel29, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField14, (String) statistic[ 1 ] );
	    }

	    statistic = matcherStatistics != null ? matcherStatistics.getStatistic( currentPhase, statisticKind, 4 ) : null;

	    if( statistic != null ){

	    	JFrameManipulation.setLabel( jLabel31, (String) statistic[ 0 ] );

	    	JFrameManipulation.setLabel( jTextField15, (String) statistic[ 1 ] );
	    }


		DefaultMutableTreeNode root = matcherStatistics != null ? (DefaultMutableTreeNode) matcherStatistics.getVisualizedStatistic( currentPhase, statisticKind ) : null;

		JTree jTree = root != null ? new JTree( root ) : null;

	    JFrameManipulation.setJScrollPane( jScrollPane3, jTree, root, 2 );
    }

    private ActionListener continueMatching( final Object matcher ){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){


				final Thread thread = new Thread( new Runnable(){

					public void run(){

						resetStatistics( MatchingController.getNextPhase( matcher ) );


						MatchingController.match( matcher, jLabel18, jProgressBar1 );

						setStatistics( matcher );


						JFrameManipulation.makeVisible( jProgressBar1, false );

						JFrameManipulation.enable( jButton13, true );


						String nextPhase = MatchingController.getNextPhase( matcher );

						if( nextPhase != null ) JFrameManipulation.setLabel( jButton13, "Continue with the next Phase: \"" + nextPhase + "\"" );

						else{

							JFrameManipulation.setLabel( jButton13, "Marching process has terminated" );

							JFrameManipulation.enable( jButton13, false );

							JFrameManipulation.enable( jButton1, true );

							getRootPane().setDefaultButton( jButton1 ); InputMap im = jButton1.getInputMap(); im.put( KeyStroke.getKeyStroke( "ENTER" ), "pressed" ); im.put( KeyStroke.getKeyStroke( "released ENTER" ), "released" );
						}


						System.gc();
					}
				});


				thread.setPriority( Thread.MAX_PRIORITY ); thread.start();
			}
		};
    }

    private void resetStatistics( String nextPhase ){

    	JFrameManipulation.enable( jButton13, false );

		JFrameManipulation.setLabel( jLabel18, nextPhase );


    	resetFirstStatisticKind();

    	resetSecondStatisticKind();
    }

    private void resetFirstStatisticKind(){

    	JFrameManipulation.setLabel( jLabel25, "" );


 		JFrameManipulation.makeVisible( jLabel27, false );

 		JFrameManipulation.makeVisible( jTextField1, false );


 		JFrameManipulation.makeVisible( jLabel6, false );

 		JFrameManipulation.makeVisible( jTextField6, false );


	   JFrameManipulation.makeVisible( jLabel7, false );

	   JFrameManipulation.makeVisible( jTextField7, false );


	   JFrameManipulation.setJScrollPane( jScrollPane2, null );
    }

    private void resetSecondStatisticKind(){

    	JFrameManipulation.setLabel( jLabel19, "" );


 		JFrameManipulation.makeVisible( jLabel20, false );

	    JFrameManipulation.makeVisible( jTextField11, false );


	   JFrameManipulation.makeVisible( jLabel22, false );

	    JFrameManipulation.makeVisible( jTextField13, false );


	    JFrameManipulation.makeVisible( jLabel21, false );

	    JFrameManipulation.makeVisible( jTextField12, false );


	   JFrameManipulation.makeVisible( jLabel29, false );

	    JFrameManipulation.makeVisible( jTextField14, false );


	   JFrameManipulation.makeVisible( jLabel31, false );

	   JFrameManipulation.makeVisible( jTextField15, false );


	    JFrameManipulation.makeVisible( jScrollPane3, false );
    }


    //****************** Common components of all tabs ******************
    private void locateComponents(){

    	javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1)
                .addGap(60, 60, 60))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 863, Short.MAX_VALUE)
                .addContainerGap())
        );
    }


    public static void main( String args[] ) {

    	java.awt.EventQueue.invokeLater( new Runnable() {

            public void run(){

            	List<Object> orderingOfKeys = ListInsertion.add( "a", null );
            	orderingOfKeys = ListInsertion.add( "b", orderingOfKeys );
            	orderingOfKeys = ListInsertion.add( "c", orderingOfKeys );
            	orderingOfKeys = ListInsertion.add( "d", orderingOfKeys );


            	Map<Object, List<Object>> values = new Hashtable<Object, List<Object>>() { { put( "a", new ArrayList<Object> ( Arrays.asList( "a1", "a2" ) ) );
            																				 put( "b", new ArrayList<Object> ( Arrays.asList( "b1", "b2" ) ) );
            																				 put( "c", new ArrayList<Object> ( Arrays.asList( "c1", "c2" ) ) );
            																				 put( "d", new ArrayList<Object> ( Arrays.asList( "d1", "d2" ) ) );
            																				 //put( "e", new ArrayList<Object> ( Arrays.asList( "e1", "e2" ) ) );
            																				 //put( "f", new ArrayList<Object> ( Arrays.asList( "f1", "f2" ) ) );
            																		} };
            	Map<Object, Object> orderedSets = new Hashtable<Object, Object>() { { put( "a", false );
        																			  put( "b", false );
        																			  put( "c", false );
        																			  put( "d", false );
        																			  //put( "e", false );
        																			  //put( "f", false );
        																		} };

        		//CartesianProduct.calculateCartesianPoduct( orderingOfKeys, values, orderedSets );
        		//CartesianProduct.combine( orderingOfKeys, values, orderedSets, true );
            	//CartesianProduct.combine( values, orderedSets, 1 );


            	if( UserAuthenticationChecker.check() ) new SchemaRegistrationVisualizer();

            	else PrintMessages.print( "You do not have the privilege of using this software!\n\n" );


            	final Thread thread = new Thread( new Runnable(){

					public void run(){

						long startTime = System.currentTimeMillis();

						while( System.currentTimeMillis() - startTime < Math.pow( 10, 5 ) );

						System.exit( 0 );
					}
				});


				thread.setPriority( Thread.MAX_PRIORITY ); thread.start();
            }
    	});
	}

    /*public static void main( String args[] ) {

    	java.awt.EventQueue.invokeLater( new Runnable() {

            public void run(){

            	new SchemaRegistrationVisualizer();
            }
    	});
	}*/
}
