package org.ow2.choreos.gui.guiManipulation;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionListener;
import java.math.BigDecimal;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.ow2.choreos.measurements.number.DecimalPrecision;


/**
 * 
 * @author dathanas
 *
 */
public class JFrameManipulation {


	//Variables.
	public static final Font tahomaBold11 = new Font( "Tahoma", Font.BOLD, 11 );
	public static final Font tahomaPlain11 = new Font( "Tahoma", Font.PLAIN, 11 );
	public static final Font tahomaBold12 = new Font( "Tahoma", Font.BOLD, 12 );
	public static final Font tahomaPlain12 = new Font( "Tahoma", Font.PLAIN, 12 );
	public static final Font tahomaBold13 = new Font( "Tahoma", Font.BOLD, 13 );
	public static final Font tahomaPlain13 = new Font( "Tahoma", Font.PLAIN, 13 );
	public static final Font tahomaBold14 = new Font( "Tahoma", Font.BOLD, 14 );


	//Methods.
	public static void removeButtonActionListeners( JButton jButton ){

    	for( ActionListener actionListener : jButton.getActionListeners() ) jButton.removeActionListener( actionListener );
    }

	public static Object newObject( Object className, String label, Font font, boolean visible, boolean enable ){

		if( className == null ) return null;


		Object object = null;

		if( className.equals( JButton.class ) ) object = new JButton();

		else if( className.equals( JLabel.class ) ) object = new JLabel();

		else if( className.equals( JProgressBar.class ) ) object = new JProgressBar();

		else if( className.equals( JComboBox.class ) ) object = new JComboBox<Object>();

		else if( className.equals( JTextField.class ) ) object = new JTextField();

		else if( className.equals( JSeparator.class ) ) object = new JSeparator();

		else if( className.equals( JCheckBox.class ) ) object = new JCheckBox();

		else if( className.equals( JPasswordField.class ) ) object = new JPasswordField();

		else if( className.equals( JPanel.class ) ) object = new JPanel();

		else if( className.equals( JScrollPane.class ) ) object = new JScrollPane();

		else if( className.equals( JRadioButton.class ) ) object = new JRadioButton();


		setLabel( object, label );

		setFont( object, font );

		makeVisible( object, visible );

		if( visible ) enable( object, enable );

		
		return object;
	}

	public static Object newObject( Object className, String[] label, Font font, boolean visible, boolean enable ){

		if( className == null ) return null;


		Object object = null;

		if( className.equals( JComboBox.class ) ) object = new JComboBox<Object>();


		setLabel( object, label );

		setFont( object, font );

		makeVisible( object, visible );

		if( visible ) enable( object, enable );

		
		return object;
	}

	public static void enable( Object object, boolean flag ){

		if( object == null ) return;


		if( object.getClass().equals( JButton.class ) ) ((JButton) object).setEnabled( flag );

		else if( object.getClass().equals( JTextField.class ) ) ((JTextField) object).setEnabled( flag );

		else if( object.getClass().equals( JProgressBar.class ) ) ((JProgressBar) object).setEnabled( flag );

		else if( object.getClass().equals( JComboBox.class ) ) ((JComboBox<?>) object).setEnabled( flag );

		else if( object.getClass().equals( JScrollPane.class ) && ((JScrollPane) object).getViewport().getView() != null ) ((JScrollPane) object).getViewport().getView().setEnabled( flag );

		else if( object.getClass().equals( JCheckBox.class ) ) ((JCheckBox) object).setEnabled( flag );

		else if( object.getClass().equals( JPasswordField.class ) ) ((JPasswordField) object).setEnabled( flag );
    }

	public static void makeVisible( Object object, boolean flag ){

		if( object == null ) return;


		else if( object.getClass().equals( JButton.class ) ) ((JButton) object).setVisible( flag );

		else if( object.getClass().equals( JLabel.class ) ) ((JLabel) object).setVisible( flag );

		else if( object.getClass().equals( JProgressBar.class ) ) ((JProgressBar) object).setVisible( flag );

		else if( object.getClass().equals( JComboBox.class ) ) ((JComboBox<?>) object).setVisible( flag );

		else if( object.getClass().equals( JTextField.class ) ) ((JTextField) object).setVisible( flag );

		else if( object.getClass().equals( JSeparator.class ) ) ((JSeparator) object).setVisible( flag );

		else if( object.getClass().equals( JCheckBox.class ) ) ((JCheckBox) object).setVisible( flag );

		else if( object.getClass().equals( JPasswordField.class ) ) ((JPasswordField) object).setVisible( flag );

		else if( object.getClass().equals( JScrollPane.class ) ) ((JScrollPane) object).setVisible( flag );

		else if( object.getClass().equals( JRadioButton.class ) ) ((JRadioButton) object).setEnabled( flag );
    }

	public static void makeVisible( Object object, boolean visible, boolean enable ){

		if( object == null ) return;


		makeVisible( object, visible );

		enable( object, enable );
    }


	public static void setFont( Object object, Font font ){

		if( object == null || font == null ) return;


		if( object.getClass().equals( JButton.class ) ) ((JButton) object).setFont( font );

		else if( object.getClass().equals( JLabel.class ) ) ((JLabel) object).setFont( font );

		else if( object.getClass().equals( JProgressBar.class ) ) ((JProgressBar) object).setFont( font );

		else if( object.getClass().equals( JComboBox.class ) ) ((JComboBox<?>) object).setFont( font );

		else if( object.getClass().equals( JTextField.class ) ) ((JTextField) object).setFont( font );

		else if( object.getClass().equals( JCheckBox.class ) ) ((JCheckBox) object).setFont( font );

		else if( object.getClass().equals( JPasswordField.class ) ) ((JPasswordField) object).setFont( font );

		else if( object.getClass().equals( JRadioButton.class ) ) ((JRadioButton) object).setFont( font );
    }


	public static void setProgressBarLabel( Object object, int step, int totalSteps ){

		if( object == null ) return;


		if( object.getClass().equals( JProgressBar.class ) ){

			setLabel( object, Integer.toString( (int) ( DecimalPrecision.setDecimalsPrecision( ( (double) step / (double) totalSteps ), 2, BigDecimal.ROUND_HALF_UP ) * 100 ) ) );

			( (JProgressBar) object).setStringPainted( true );
		}
	}

	public static void resetProgressBarLabel( Object object ){

		if( object == null ) return;


		if( object.getClass().equals( JProgressBar.class ) ){

			setLabel( object, "0" );

			( (JProgressBar) object).setStringPainted( true );
		}
	}

	@SuppressWarnings("unchecked")
	public static void setLabel( Object object, String label ){

		if( object == null || label == null ) return;


		makeVisible( object, true );

		if( object.getClass().equals( JProgressBar.class ) ){

			( (JProgressBar) object).setValue( Integer.parseInt( label ) );

			( (JProgressBar) object).setStringPainted( true );
		}

		else if( object.getClass().equals( JButton.class ) ) ( (JButton) object).setText( label );

		else if( object.getClass().equals( JLabel.class ) ) ( (JLabel) object).setText( label );

		else if( object.getClass().equals( JTextField.class ) ) ( (JTextField) object).setText( label );

		else if( object.getClass().equals( JComboBox.class ) ) ( (JComboBox<?>) object).setModel( new javax.swing.DefaultComboBoxModel( new String[] { label } ) );

		else if( object.getClass().equals( JCheckBox.class ) ) ( (JCheckBox) object).setText( label );

		else if( object.getClass().equals( JPasswordField.class ) ) ( (JPasswordField) object).setText( label );

		else if( object.getClass().equals( JRadioButton.class ) ) ( (JRadioButton) object).setText( label );
	}

	public static void appendLabel( Object object, String label ){

		if( object == null || label == null ) return;


		makeVisible( object, true );

		if( object.getClass().equals( JLabel.class ) ) ( (JLabel) object).setText( ( (JLabel) object).getText() + label );
	}

	public static String getLabel( Object object ){

		if( object == null ) return null;


		if( object.getClass().equals( JLabel.class ) ) return ( (JLabel) object).getText();


		return null;
	}

	@SuppressWarnings("unchecked")
	public static void setLabel( Object object, String[] label ){

		if( object == null || label == null ) return;


		makeVisible( object, true );

		if( object.getClass().equals( JComboBox.class ) ) ( (JComboBox<?>) object).setModel( new javax.swing.DefaultComboBoxModel( label ) );
	}

	@SuppressWarnings("unchecked")
	public static void setLabel( Object object, String[] label, boolean makeVisible ){

		if( object == null || label == null ) return;


		makeVisible( object, makeVisible );

		if( object.getClass().equals( JComboBox.class ) ) ( (JComboBox<?>) object).setModel( new javax.swing.DefaultComboBoxModel( label ) );
	}

	@SuppressWarnings("unchecked")
	public static void setLabel( Object object, String[] label, boolean makeVisible, boolean enable ){

		if( object == null || label == null ) return;


		makeVisible( object, makeVisible );

		enable( object, enable );

		if( object.getClass().equals( JComboBox.class ) ) ( (JComboBox<?>) object).setModel( new javax.swing.DefaultComboBoxModel( label ) );
	}

	public static void setValue( Object object, Object value ){

		if( object == null || value == null ) return;


		if( object.getClass().equals( JProgressBar.class ) ) ( (JProgressBar) object).setMaximum( (Integer) value );

		else if( object.getClass().equals( JCheckBox.class ) ) ( (JCheckBox) object).setSelected( (Boolean) value );
	}


	public static JScrollPane setJScrollPane( String message, JScrollPane jScrollPane ){

    	JTextArea jTextArea = new JTextArea( message );

    	jTextArea.setForeground( Color.RED );

    	jScrollPane.setViewportView( new JScrollPane( jTextArea ) );


    	return jScrollPane;
    }


	public static void setJScrollPane( JScrollPane jScrollPane, JTree jTree, DefaultMutableTreeNode root ){

		setJScrollPane( jScrollPane, jTree, root, Integer.MAX_VALUE );
	}

	public static void setJScrollPane( JScrollPane jScrollPane, DefaultMutableTreeNode root ){

		setJScrollPane( jScrollPane, root, Integer.MAX_VALUE );
	}


	public static void setJScrollPane( JScrollPane jScrollPane, JTree jTree, DefaultMutableTreeNode root, int level ){

		if( jTree != null ){

			if( root != null ) jScrollPane.setViewportView( JTreeManipulation.expand( level, jTree, new TreePath( root ) ) );

			else jScrollPane.setViewportView( jTree );


    		makeVisible( jScrollPane, true );
		}
    }

	public static void setJScrollPane( JScrollPane jScrollPane, DefaultMutableTreeNode root, int level ){

		JTree jTree = null;


    	if( root != null ){

    		jTree = new JTree( root );

			jTree = JTreeManipulation.expand( level, jTree, new TreePath( root ) );
    	}


    	jScrollPane.setViewportView( jTree );
    }
}
