/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MappingsLineColorChooser.java
 *
 * Created on 1 Ιουλ 2012, 4:20:49 πμ
 */
package org.ow2.choreos.gui.interfaceMappingsVisualizer.components;
import java.awt.Color;
import java.awt.Rectangle;



/**
 *
 * @author user
 */
public class MappingsLineColorChooser extends javax.swing.JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7762637114368177768L;
	public static final int EXISTING_COLOR = 0;
    public static final int ADDED_COLOR = 1;
    public static final int DELETED_COLOR = 2;


    private Color existingColor, addedColor, deletedColor;
    private Rectangle[] rects;
    private Rectangle[] fillRects;
    int colorBoxGap = 10;
    int colorBoxWidth = 20;
    int colorBoxHeight = 20;

    /** Creates new form MappingsLineColorChooser */
    public MappingsLineColorChooser() {
        initComponents();
        this.addMouseListener(new MyMouseAdapter(this));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {

        existingLabel = new javax.swing.JLabel();
        addedLabel = new javax.swing.JLabel();
        deletedLabel = new javax.swing.JLabel();

        existingLabel.setFont(new java.awt.Font("Tahoma", 0, 9)); // NOI18N
        existingLabel.setText("Existing Mappings:");
        existingLabel.setName("existingLabel"); // NOI18N

        addedLabel.setFont(new java.awt.Font("Tahoma", 0, 9)); // NOI18N
        addedLabel.setText("Added Mappings:");
        addedLabel.setName("addedLabel"); // NOI18N

        deletedLabel.setFont(new java.awt.Font("Tahoma", 0, 9)); // NOI18N
        deletedLabel.setText("Deleted Mappings:");
        deletedLabel.setName("deletedLabel"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(existingLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(addedLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(deletedLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 161, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(existingLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(addedLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(deletedLabel)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    private void initRects(){
        rects = new Rectangle[3];
        fillRects = new Rectangle[3];
        rects[0] = new Rectangle(getWidth() - (colorBoxWidth + colorBoxGap), existingLabel.getY(),
                     colorBoxWidth, existingLabel.getHeight());
        fillRects[0] = new Rectangle(getWidth() - (colorBoxWidth + colorBoxGap)+1, existingLabel.getY()+1,
                     colorBoxWidth-1, existingLabel.getHeight()-1);
        rects[1] = new Rectangle(getWidth() - (colorBoxWidth + colorBoxGap), addedLabel.getY(),
                     colorBoxWidth, addedLabel.getHeight());
        fillRects[1] = new Rectangle(getWidth() - (colorBoxWidth + colorBoxGap)+1, addedLabel.getY()+1,
                     colorBoxWidth-1, addedLabel.getHeight()-1);
        rects[2] = new Rectangle(getWidth() - (colorBoxWidth + colorBoxGap), deletedLabel.getY(),
                     colorBoxWidth, deletedLabel.getHeight());
        fillRects[2] = new Rectangle(getWidth() - (colorBoxWidth + colorBoxGap)+1, deletedLabel.getY()+1,
                     colorBoxWidth-1, deletedLabel.getHeight()-1);
    }

    public Color getColorForLocation(int x, int y) {
        if(fillRects[0].contains(x, y)) return existingColor;
        else if (fillRects[1].contains(x, y)) return addedColor;
        else if(fillRects[2].contains(x,y)) return deletedColor;
        else return null;
    }

    public int getColorIdForLocation(int x, int y){
        if(fillRects[0].contains(x, y)) return EXISTING_COLOR;
        else if (fillRects[1].contains(x, y)) return ADDED_COLOR;
        else if(fillRects[2].contains(x,y)) return DELETED_COLOR;
        else return -1;
    }

    public void setColor(int colorId, Color color){
        if(colorId == EXISTING_COLOR) existingColor = color;
        else if(colorId == ADDED_COLOR) addedColor = color;
        else if(colorId == DELETED_COLOR) deletedColor = color;
        repaint();
    }

    public Color getColor(int colorId){
        if(colorId == EXISTING_COLOR) return existingColor;
        else if(colorId == ADDED_COLOR) return addedColor;
        else if(colorId == DELETED_COLOR) return deletedColor;
        else return null;
    }

    public Color getAddedColor() {
        return addedColor;
    }

    public void setAddedColor(Color addedColor) {
        this.addedColor = addedColor;
        repaint();
    }

    public Color getDeletedColor() {
        return deletedColor;
    }

    public void setDeletedColor(Color deletedColor) {
        this.deletedColor = deletedColor;
        repaint();
    }

    public Color getExistingColor() {
        return existingColor;
    }

    public void setExistingColor(Color existingColor) {
        this.existingColor = existingColor;
        repaint();
    }
    @Override
    public void paint(java.awt.Graphics g) {
        initRects();
        super.paint(g);
        java.awt.Graphics2D g2d = (java.awt.Graphics2D) g;

        g2d.setColor(Color.black);
        g2d.drawRect(rects[0].x, rects[0].y, rects[0].width, rects[0].height);
        g2d.setColor(existingColor);
        g2d.fillRect(fillRects[0].x,fillRects[0].y,fillRects[0].width,fillRects[0].height);

        g2d.setColor(Color.black);
        g2d.drawRect(rects[1].x, rects[1].y, rects[1].width, rects[1].height);
        g2d.setColor(addedColor);
        g2d.fillRect(fillRects[1].x,fillRects[1].y,fillRects[1].width,fillRects[1].height);

        g2d.setColor(Color.black);
        g2d.drawRect(rects[2].x, rects[2].y, rects[2].width, rects[2].height);

        g2d.setColor(deletedColor);
        g2d.fillRect(fillRects[2].x,fillRects[2].y,fillRects[2].width,fillRects[2].height);
    }

    public void updateParentsColors(int colorId, Color newColor){
        MappingsPanel parent = (MappingsPanel) getParent();
        switch(colorId){
            case EXISTING_COLOR:
                parent.setLineColor(newColor);
                break;
            case ADDED_COLOR:
                parent.setAddedLineColor(newColor);
                break;
            case DELETED_COLOR:
                parent.setDeletedLineColor(newColor);
                break;
            default: break;
        }
        parent.repaint();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel addedLabel;
    private javax.swing.JLabel deletedLabel;
    private javax.swing.JLabel existingLabel;
    // End of variables declaration//GEN-END:variables

}
class MyMouseAdapter extends java.awt.event.MouseAdapter {

    MappingsLineColorChooser panel;

    public MyMouseAdapter(MappingsLineColorChooser panel) {
        this.panel = panel;
    }

    @Override
    public void mousePressed(java.awt.event.MouseEvent evt) {
        int colorId = panel.getColorIdForLocation(evt.getX(), evt.getY());
        if(colorId != -1){
            String title;
            if(colorId == MappingsLineColorChooser.EXISTING_COLOR) title = "Choose existing connections' color";
            else if(colorId == MappingsLineColorChooser.ADDED_COLOR) title = "Choose added connections' color";
            else title = "Choose deleted connections' color";
            Color newColor = javax.swing.JColorChooser.showDialog(panel, title, panel.getColorForLocation(evt.getX(), evt.getY()));
            panel.updateParentsColors(colorId, newColor);
            panel.setColor(colorId, newColor);
            
        }
    }
}
