/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.ow2.choreos.gui.interfaceMappingsVisualizer.listeners;

import java.awt.Point;
import java.awt.event.ComponentAdapter;
import java.util.ArrayList;

import org.ow2.choreos.gui.interfaceMappingsVisualizer.components.MappingsPanel;
import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnection;

/**
 *
 * @author user
 */
public class ScrollPaneComponentAdapter extends ComponentAdapter{
    MappingsPanel container;

    public ScrollPaneComponentAdapter(MappingsPanel container) {
        this.container = container;
    }

    @Override
    public void componentResized(java.awt.event.ComponentEvent evt) {
        if(evt.getSource().equals(container.getSourceTreeScrollPane()))
            this.sourceScrollPaneResized();
        else if(evt.getSource().equals(container.getDestTreeScrollPane()))
            this.destScrollPaneResized();
    }

    private void destScrollPaneResized() {
        Point newPoint = container.getDestTreeScrollPane().getLocation();
        Point destScrollPaneLocation = container.getDestScrollPaneLocation();


        Point diff = new Point();
        if (destScrollPaneLocation.x != 0) {
            diff.x = newPoint.x - destScrollPaneLocation.x;
        }
        else diff.x = newPoint.x;
        if (destScrollPaneLocation.y != 0) {
            diff.y = newPoint.y - destScrollPaneLocation.y;
        }
        else diff.y = newPoint.y;
        container.setDestScrollPaneLocation(newPoint);

        ArrayList<VisualComponentConnection> connections = new ArrayList<VisualComponentConnection>(container.getExistingMappings());
        connections.addAll(container.getAddedMappings());
        connections.addAll(container.getDeletedMappings());
        for (int i = 0; i < connections.size(); i++) {
                connections.get(i).moveDestBy(diff);
        }
        container.repaint();
    }

    private void sourceScrollPaneResized() {
        Point newPoint = container.getSourceTreeScrollPane().getLocation();
        Point sourceScrollPaneLocation = container.getSourceScrollPaneLocation();


        Point diff = new Point();
        if (sourceScrollPaneLocation.x != 0) {
            diff.x = newPoint.x - sourceScrollPaneLocation.x;
        }
        else {
            diff.x = newPoint.x;
        }
        if (sourceScrollPaneLocation.y != 0) {
            diff.y = newPoint.y - sourceScrollPaneLocation.y;
        }
        else{
            diff.y = newPoint.y;
        }

        container.setSourceScrollPaneLocation(newPoint);

        ArrayList<VisualComponentConnection> connections = new ArrayList<VisualComponentConnection>(container.getExistingMappings());
        connections.addAll(container.getAddedMappings());
        connections.addAll(container.getDeletedMappings());
        
        for (int i = 0; i < connections.size(); i++) {
                connections.get(i).moveSourceBy(diff);
        }
        
        container.repaint();
    }
}
