/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.ow2.choreos.gui.interfaceMappingsVisualizer.listeners;

import javax.swing.JTree;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeWillExpandListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.ExpandVetoException;
import javax.swing.tree.TreePath;

import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.interfaceMappingsToJTrees.TreeUtils;
import org.ow2.choreos.gui.interfaceMappingsVisualizer.components.MappingsPanel;
import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnectionUtils;

/**
 *
 * @author user
 */
public class TreeExpandOrWillExpandListener implements TreeExpansionListener, TreeWillExpandListener {

    private MappingsPanel container;

    public TreeExpandOrWillExpandListener(MappingsPanel container) {
        this.container = container;
    }

    public void treeExpanded(TreeExpansionEvent evt) {
        this.TreeExpandCollapse((JTree) evt.getSource(), (TreePath) evt.getPath(), false);
    }

    public void treeCollapsed(TreeExpansionEvent evt) {
    }

    public void treeWillExpand(TreeExpansionEvent evt) throws ExpandVetoException {
    }

    public void treeWillCollapse(TreeExpansionEvent evt) throws ExpandVetoException {
        this.TreeExpandCollapse((JTree) evt.getSource(), (TreePath) evt.getPath(), true);
    }
    
    private void TreeExpandCollapse(JTree tree, TreePath path, boolean state) {
        int endPointId = -1;
        int yDiff;

        if (tree.equals(container.getSourceTree())) {
            endPointId = VisualComponentConnectionUtils.SOURCE;
        } else if (tree.equals(container.getDestTree())){
            endPointId = VisualComponentConnectionUtils.DESTINATION;
        }
        else return;

        DefaultMutableTreeNode aNode = (DefaultMutableTreeNode) path.getLastPathComponent();
        if (!container.getExistingMappings().isEmpty() ||
                !container.getAddedMappings().isEmpty() ||
                !container.getDeletedMappings().isEmpty() ||
                !container.getMappingsFromHistory().isEmpty()) {
            if (state) {
                yDiff = -TreeUtils.getTotalDescendantsHeight(tree, aNode);
            } else {
                yDiff = TreeUtils.getTotalDescendantsHeight(tree, aNode);
            }
            VisualComponentConnectionUtils.moveBelowConnectionsBy(container, endPointId, yDiff, aNode);
            VisualComponentConnectionUtils.setDescendantsConnectionCollapsion(container, endPointId, state, aNode);
            VisualComponentConnectionUtils.updateConnectionsVisibility(container, endPointId);
        }

        container.repaint();
    }
}
