package org.ow2.choreos.matchingProcess.schemaRepresentation;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.matchingProcess.Matcher;
import org.ow2.choreos.matchingProcess.MatchingController;
import org.ow2.choreos.matchingProcess.schemaRepresentation.concreteElementIndexing.ConcreteElementsDataStructureController;
import org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.PatternBasedSchemaMatchingController;


/**
 * 
 * @author dathanas
 *
 */
public class SchemaMatchingController {


	//Variables.
	public final static String thresholdOfCorrespondenceConfidenceUserOptionLabel = "Select threshold for correspondence-confidence metric:";

	public final static String[] thresholdOfCorrespondenceConfidenceUserOptions = MatchingController.normalizedValues;


	//Verifiers.
	public static boolean isSchemaMatcherKind( String matcherKind ){

		if( PatternBasedSchemaMatchingController.isPatternBasedSchemaMatcherKind( matcherKind ) ) return true;


		return false;
	}


	//Getters.
	public static String[] getMatcherKinds(){

		return PatternBasedSchemaMatchingController.getMatcherKinds();
	}

	public static void getAlternativeUserOptions( String matcherKind, List<Object> userOptionLabels, Map<Object, Object[]> userOptions ){

		if( PatternBasedSchemaMatchingController.isPatternBasedSchemaMatcherKind( matcherKind ) ) PatternBasedSchemaMatchingController.getAlternativeUserOptions( matcherKind, userOptionLabels, userOptions );

		ConcreteElementsDataStructureController.getAlternativeUserOptions( userOptionLabels, userOptions );
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings ){

		if( PatternBasedSchemaMatchingController.isPatternBasedSchemaMatcherKind( matcherKind ) ) return PatternBasedSchemaMatchingController.newMatcher( matcherKind, userSettings );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent ){

		if( PatternBasedSchemaMatchingController.isPatternBasedSchemaMatcherKind( matcherKind ) ) return PatternBasedSchemaMatchingController.newMatcher( matcherKind, userSettings, guiLabel, guiComponent );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent, String printFilePath ){

		if( PatternBasedSchemaMatchingController.isPatternBasedSchemaMatcherKind( matcherKind ) ) return PatternBasedSchemaMatchingController.newMatcher( matcherKind, userSettings, guiLabel, guiComponent, printFilePath );


		return null;
	}

	public static String getStartPhase( String matcherKind ){

		if( PatternBasedSchemaMatchingController.isPatternBasedSchemaMatcherKind( matcherKind ) ) return PatternBasedSchemaMatchingController.getStartPhase( matcherKind );


		return null;
	}
}
