package org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.PatternBasedSchemaElementIndexing;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapInsertion.MapInsertion;
import org.ow2.choreos.dataStructures.map.mapInstantiation.MapInstantiation;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.matchingProcess.schemaRepresentation.concreteElementIndexing.AbstractElement;
import org.ow2.choreos.matchingProcess.schemaRepresentation.concreteElementIndexing.ConcreteElementsIndex;


/**
 * 
 * @author dathanas
 * 
 */
public class PatternBasedConcreteElementsIndex extends ConcreteElementsIndex {


	//Constructor.
	public PatternBasedConcreteElementsIndex( UserSettings userSettings, Object guiLabel, Object guiComponent ){

		super( userSettings, guiLabel, guiComponent );
	}


	//Getters.
	@SuppressWarnings("unchecked")
	public Map<Object, Object> lookUpPatternGrowthAbstractElements( AbstractElement queryingAbstractElement ){//3rd lookUp functionality, where the first 'Object' is label of the pattern-growth abstract element and the second one corresponds to the pattern-growth concrete elements.
																									  		  //The input abstract element is a querying abstract element having organized its concrete elements in a map of element, scope of its rightmost element.

		Map<Object, Object> patternGrowthAbstractElements = MapInstantiation.newMap();


		Map<Object, Object> currentSchemaElementsInAllSchemas = queryingAbstractElement != null ? queryingAbstractElement.getConcreteElements() : null;

		Iterator<Object> i = currentSchemaElementsInAllSchemas != null && currentSchemaElementsInAllSchemas.keySet() != null ? currentSchemaElementsInAllSchemas.keySet().iterator() : null;

		while( i != null && i.hasNext() ){

			String ref2DocOfSchema = (String) i.next();

			Object existingDataStructure = MapGetter.getValue( ref2DocOfSchema, currentSchemaElementsInAllSchemas );


			boolean found = false;

			Map<Object, Object> totalPairOfSchemaElementAndRightmostChildScopeRightEndpoints = (Map<Object, Object>) existingDataStructure;//These are the concrete elements of the abstract one for this schema document.

			Iterator<Object> j = totalPairOfSchemaElementAndRightmostChildScopeRightEndpoints != null && totalPairOfSchemaElementAndRightmostChildScopeRightEndpoints.keySet() != null ? totalPairOfSchemaElementAndRightmostChildScopeRightEndpoints.keySet().iterator() : null;

			while( j != null && j.hasNext() ){

				int rightmostChildScopeRightEndpoint = (Integer) j.next();


				Map<Object, Object> pairOfSchemaElementAndRightmostChildScopeRightEndpoints = (Map<Object, Object>) MapGetter.getValue( rightmostChildScopeRightEndpoint, totalPairOfSchemaElementAndRightmostChildScopeRightEndpoints );

				Iterator<Object> k = pairOfSchemaElementAndRightmostChildScopeRightEndpoints != null && pairOfSchemaElementAndRightmostChildScopeRightEndpoints.keySet() != null ? pairOfSchemaElementAndRightmostChildScopeRightEndpoints.keySet().iterator() : null;

				while( k != null && k.hasNext() ){

					Object concreteElement = k.next();

					Map<Object, Object> pairOfSchemaElementAndRightmostChildScopeRightEndpoint = (Map<Object, Object>) MapGetter.getValue( concreteElement, pairOfSchemaElementAndRightmostChildScopeRightEndpoints );


					boolean iterativeFound = lookUpPatternGrowthAbstractElements( ref2DocOfSchema, pairOfSchemaElementAndRightmostChildScopeRightEndpoint, patternGrowthAbstractElements );

					if( iterativeFound ) found = iterativeFound;
				}
			}

			if( ! found ) return null;
		}


		return patternGrowthAbstractElements;
	}

	private boolean lookUpPatternGrowthAbstractElements( String ref2DocOfSchema, Map<Object, Object> pairOfSchemaElementAndRightmostChildScopeRightEndpoint, Map<Object, Object> patternGrowthAbstractElements ){//'currentSchemaElementInASchema' is a map with only one tuple which has values equal to: SchemaElement concreteElement, Interval1D rightmostChildScope.

		boolean found = false;


		Iterator<Object> i = abstractElements != null && abstractElements.keySet() != null ? abstractElements.keySet().iterator() : null;

		while( i != null && i.hasNext() ){

			int abstractElementID = (Integer) i.next();

			AbstractElement abstractElement = (AbstractElement) abstractElements.get( abstractElementID );


			List<Object> patternGrowthSchemaElementsForAnAbstractElement = lookUpPatternGrowthConcreteElements( abstractElementID, ref2DocOfSchema, pairOfSchemaElementAndRightmostChildScopeRightEndpoint, abstractElement.getSchemaElementsDataStructureKind() );


			patternGrowthAbstractElements = addPatternGrowthSchemaElements( patternGrowthAbstractElements, abstractElementID, ref2DocOfSchema, pairOfSchemaElementAndRightmostChildScopeRightEndpoint, patternGrowthSchemaElementsForAnAbstractElement );


			if( patternGrowthSchemaElementsForAnAbstractElement != null && ! patternGrowthSchemaElementsForAnAbstractElement.isEmpty() ) found = true;
		}


		return found;
	}

	public List<Object> lookUpPatternGrowthConcreteElements( int abstractElementID, String ref2DocOfSchema, Map<Object, Object> pairOfSchemaElementAndRightmostChildScopeRightEndpoint, String concreteElementsDataStructureKind ){//2nd lookUp functionality.

		AbstractElement abstractElement = (AbstractElement) abstractElements.get( abstractElementID );


		Map<Object, Object> concreteElementsOfAllSchemas = abstractElement != null ? abstractElement.getConcreteElements() : null;


		Object existingDataStructure = MapGetter.getValue( ref2DocOfSchema, concreteElementsOfAllSchemas );


		return PatternBasedConcreteElementsDataStructureController.lookUpPatternGrowthSchemaElements( concreteElementsDataStructureKind, existingDataStructure, pairOfSchemaElementAndRightmostChildScopeRightEndpoint );
	}

	@SuppressWarnings("unchecked")
	private Map<Object, Object> addPatternGrowthSchemaElements( Map<Object, Object> patternGrowthAbstractElements, int abstractElementID, String ref2DocOfSchema, Map<Object, Object> pairOfSchemaElementAndRightmostChildScopeRightEndpoint, List<Object> patternGrowthConcreteElementsForAnAbstractElement ){

		Map<Object, Object> patternGrowthSchemaElementsOfAllSchemas = MapGetter.exists( abstractElementID, patternGrowthAbstractElements ) ? (Map<Object, Object>) MapGetter.getValue( abstractElementID, patternGrowthAbstractElements ) : null;

		Map<Object, Object> patternGrowthSchemaElementsOfOneSchema = patternGrowthSchemaElementsOfAllSchemas != null && MapGetter.exists( ref2DocOfSchema, patternGrowthSchemaElementsOfAllSchemas ) ? (Map<Object, Object>) MapGetter.getValue( ref2DocOfSchema, patternGrowthSchemaElementsOfAllSchemas ) : null;


		patternGrowthSchemaElementsOfOneSchema = MapInsertion.put( pairOfSchemaElementAndRightmostChildScopeRightEndpoint, patternGrowthConcreteElementsForAnAbstractElement, patternGrowthSchemaElementsOfOneSchema, true );


		patternGrowthSchemaElementsOfAllSchemas = MapInsertion.put( ref2DocOfSchema, patternGrowthSchemaElementsOfOneSchema, patternGrowthSchemaElementsOfAllSchemas, true );

		return MapInsertion.put( abstractElementID, patternGrowthSchemaElementsOfAllSchemas, patternGrowthAbstractElements, true );
	}


	@SuppressWarnings("unchecked")
	static public List<Object> getPatternGrowthSchemaElements( String ref2DocOfSchema, Map<Object, Object> pairOfSchemaElementAndRightmostChildScopeRightEndpoint, Object patternGrowthSchemaElementsOfAllSchemas ){//where 'patternGrowthSchemaElementsOfAllSchemas' hides the auxiliary data structure of the pattern-growth schema elements.

		Map<Object, Object> patternGrowthSchemaElementsOfASchema = patternGrowthSchemaElementsOfAllSchemas != null && MapGetter.exists( ref2DocOfSchema, (Map<Object, Object>) patternGrowthSchemaElementsOfAllSchemas ) ? (Map<Object, Object>) MapGetter.getValue( ref2DocOfSchema, (Map<Object, Object>) patternGrowthSchemaElementsOfAllSchemas ) : null;


		return MapGetter.exists( pairOfSchemaElementAndRightmostChildScopeRightEndpoint, patternGrowthSchemaElementsOfASchema ) ? (List<Object>) MapGetter.getValue( pairOfSchemaElementAndRightmostChildScopeRightEndpoint, patternGrowthSchemaElementsOfASchema ) : null;
	}
}