package org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.holisticMatching;

import java.util.Map;

import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.matchingProcess.schemaRepresentation.concreteElementIndexing.ConcreteElementsIndex;
import org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.PatternBasedSchemaMatcher;


/**
 * 
 * @author dathanas
 *
 */
public abstract class HolisticPatternBasedSchemaMatcher extends PatternBasedSchemaMatcher {


	//Variables.
	protected int minFrequency;//user-provided.


	//Constructors.
	public HolisticPatternBasedSchemaMatcher( UserSettings userSettings, String currentPhase ){

		super( userSettings, currentPhase );


		initVariables( userSettings );
	}

	public HolisticPatternBasedSchemaMatcher( UserSettings userSettings, String currentPhase, Object guiLabel, Object guiComponent ){

		super( userSettings, currentPhase, guiLabel, guiComponent );


		initVariables( userSettings );
	}

	public HolisticPatternBasedSchemaMatcher( UserSettings userSettings, String currentPhase, Object guiLabel, Object guiComponent, String cLogFilePath ){

		super( userSettings, currentPhase, guiLabel, guiComponent, cLogFilePath );


		initVariables( userSettings );
	}

	private void initVariables( UserSettings userSettings ){

		minFrequency = userSettings.getMinimumFrequency();

		PrintMessages.stdPrintLn( PrintMessages.matchingPrint, "minFrequency = " + minFrequency );
	}


	//Setters.
	protected void initialize(){

		initialize( null, null );
	}

	protected void initialize( Object guiLabel, Object guiProgressBar ){

		long startTime = System.currentTimeMillis();


		Map<Object, Object> abstractElements = index.lookUpFrequentAbstractElements( minFrequency, true, guiLabel, guiProgressBar );

		addIndexStatistics( guiLabel, guiProgressBar, ConcreteElementsIndex.getVisualizationRootLabelForFrequentElements(), ConcreteElementsIndex.getLabelOfIdentifyingFrequentElementsDuration() );

		if( PrintMessages.toPrint( PrintMessages.matchingPrint ) ) index.visualize( ConcreteElementsIndex.getVisualizationRootLabelForFrequentElements(), logFilePath );


		initializeSingletonPatterns( abstractElements, guiLabel, guiProgressBar );


		currentPhaseDuration = System.currentTimeMillis() - startTime;

		totalDuration += currentPhaseDuration;


		addPatternStatistics( guiLabel, guiProgressBar );
	}
}
