package org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.holisticMatching;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.map.mapInsertion.MapInsertion;
import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.matchingProcess.Matcher;
import org.ow2.choreos.matchingProcess.MatchingController;
import org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.holisticMatching.matchingGrowthMatching.MatchingGrowthMatcher;
import org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.holisticMatching.patternGrowthMatching.PatternGrowthMatcher;


/**
 * 
 * @author dathanas
 *
 */
public class HolisticPatternBasedSchemaMatcherController {


	//Variables.
	public final static String minimumFrequencyValueUserOptionLabel = "Select minimum frequency value:";


	private final static String confidenceOfBipartiteCorrespondencesUserOptionLabel = "Select the function for aggregating the confidence of bipartite correspondences:";

	private final static String[] confidenceOfBipartiteCorrespondencesUserOptions = new String[] { "Product", "Average" };


	private final static String confidenceOfCompleteCorrespondencesUserOptionLabel = "Select the function for aggregating the confidence of complete correspondences:";

	private final static String[] confidenceOfCompleteCorrespondencesUserOptions = new String[] { "Average", "Product" };


	private final static String aggregatingCorrespondenceAndStructuralPatternConfidenceUserOptionLabel = "Select the function for aggregating the correspondences confidence and structural-pattern confidence:";

	private final static String[] aggregatingCorrespondenceAndStructuralPatternConfidenceUserOptions = new String[] { "Product", "Average" };


	//Verifiers.
	public static boolean isHolisticSchemaMatcherKind( String matcherKind ){

		if( PatternGrowthMatcher.isPatternGrowthMatcher( matcherKind ) || MatchingGrowthMatcher.isMatchingGrowthMatcher( matcherKind ) ) return true;


		return false;
	}


	//Getters.
	public static String[] getMatcherKinds(){

		return new String[] { "<Select the preferred matcher>", PatternGrowthMatcher.getMatcherKind(), MatchingGrowthMatcher.getMatcherKind() };
	}

	public static void getAlternativeUserOptions( String matcherKind, List<Object> userOptionLabels, Map<Object, Object[]> userOptions ){

		userOptionLabels = ListInsertion.add( MatchingController.matchingConfidenceUserOptionLabel, userOptionLabels );


		userOptionLabels = ListInsertion.add( confidenceOfBipartiteCorrespondencesUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( confidenceOfBipartiteCorrespondencesUserOptionLabel, confidenceOfBipartiteCorrespondencesUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( confidenceOfCompleteCorrespondencesUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( confidenceOfCompleteCorrespondencesUserOptionLabel, confidenceOfCompleteCorrespondencesUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( aggregatingCorrespondenceAndStructuralPatternConfidenceUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( aggregatingCorrespondenceAndStructuralPatternConfidenceUserOptionLabel, aggregatingCorrespondenceAndStructuralPatternConfidenceUserOptions, userOptions, false );
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings ){

		if( PatternGrowthMatcher.isPatternGrowthMatcher( matcherKind ) ) return new PatternGrowthMatcher( userSettings );

		if( MatchingGrowthMatcher.isMatchingGrowthMatcher( matcherKind ) ) return new MatchingGrowthMatcher( userSettings );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent ){

		if( PatternGrowthMatcher.isPatternGrowthMatcher( matcherKind ) ) return new PatternGrowthMatcher( userSettings, guiLabel, guiComponent );

		if( MatchingGrowthMatcher.isMatchingGrowthMatcher( matcherKind ) ) return new MatchingGrowthMatcher( userSettings );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent, String printFilePath ){

		if( PatternGrowthMatcher.isPatternGrowthMatcher( matcherKind ) ) return new PatternGrowthMatcher( userSettings, guiLabel, guiComponent, printFilePath );

		if( MatchingGrowthMatcher.isMatchingGrowthMatcher( matcherKind ) ) return new MatchingGrowthMatcher( userSettings );


		return null;
	}

	public static String getStartPhase( String matcherKind ){

		if( PatternGrowthMatcher.isPatternGrowthMatcher( matcherKind ) ) return PatternGrowthMatcher.getStartPhase();

		if( MatchingGrowthMatcher.isMatchingGrowthMatcher( matcherKind ) ) return MatchingGrowthMatcher.getStartPhase();


		return null;
	}
}
