package org.ow2.choreos.measurements.memory;

import org.ow2.choreos.measurements.number.DecimalPrecision;


/**
 * 
 * @author dathanas
 *
 */
public class MemoryConsumption {


	//Variables.
	private static final int mb = 1024 * 1024;


	//Methods.
	public static long getUsedMemory(){

		Runtime runtime = Runtime.getRuntime();

		//for( int i = 0; i < 10; ++i ) runtime.gc();


	    long memory = runtime.totalMemory() - runtime.freeMemory();


		return memory;
	}


	public static double measure( long previouslyUsedMemory ){    

		Runtime runtime = Runtime.getRuntime();

		//for( int i = 0; i < 10; ++i ) runtime.gc();


	    long memory = runtime.totalMemory() - runtime.freeMemory();


		long diff = memory - previouslyUsedMemory;

		if( diff < 0 ) diff = 0;


		return (double) diff / (double) mb;
	}

	public static String print( double memory ){

		return DecimalPrecision.setFourDecimalsPrecisionHalfDown( memory ) + " MB";
	}
}
