package org.ow2.choreos.measurements.time;

import java.util.concurrent.TimeUnit;


/**
 * 
 * @author dathanas
 *
 */
public class ElapsedTimeCalculator {


	public static String getTime( double millis ){

		return getTime( (long) millis );
	}


	public static String getTime( long millis ){

		long days = TimeUnit.MILLISECONDS.toDays( millis );

        millis -= TimeUnit.DAYS.toMillis( days );


        long hours = TimeUnit.MILLISECONDS.toHours( millis );

        millis -= TimeUnit.HOURS.toMillis( hours );


        long minutes = TimeUnit.MILLISECONDS.toMinutes( millis );

        millis -= TimeUnit.MINUTES.toMillis( minutes );


        long seconds = TimeUnit.MILLISECONDS.toSeconds( millis );

        millis -= TimeUnit.SECONDS.toMillis( seconds );


        StringBuilder sb = new StringBuilder( 64 );

        if( days == 0 && hours == 0 && minutes == 0 && seconds == 0 && millis == 0 ) sb.append( "0 msec" );

        else{

	        if( days > 0 ) sb.append( days + " d " );
	
	        if( hours > 0 ) sb.append( hours + " h " );
	
	        if( minutes > 0 ) sb.append( minutes + " min " );
	
	        if( seconds > 0 ) sb.append( seconds + " sec " );
	
	        if( millis > 0 ) sb.append( millis + " msec" );
        }

        return( sb.toString() );
	}
}