package org.ow2.choreos.parser.functionalDocuments.service.wsdl.v2.apacheWooden;

import java.net.MalformedURLException;

import org.apache.woden.WSDLException;
import org.apache.woden.WSDLFactory;
import org.apache.woden.WSDLReader;
import org.apache.woden.wsdl20.Binding;
import org.apache.woden.wsdl20.Description;
import org.apache.woden.wsdl20.Endpoint;
import org.apache.woden.wsdl20.Interface;
import org.apache.woden.wsdl20.InterfaceMessageReference;
import org.apache.woden.wsdl20.InterfaceOperation;
import org.apache.woden.wsdl20.xml.DescriptionElement;
import org.ow2.choreos.parser.functionalDocuments.service.wsdl.WSDLParser;
import org.ow2.choreos.serviceRepresentation.functional.DocOfFuncProperties;
import org.ow2.choreos.serviceRepresentation.functional.FunctionalServiceRepresentationController;
import org.ow2.choreos.serviceRepresentation.functional.Message;
import org.ow2.choreos.serviceRepresentation.functional.MessageType;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInstance;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;
import org.ow2.choreos.serviceRepresentation.functional.ServiceType;


public class ApacheWoodenWSDLv2Parser extends WSDLParser {


	//Overridden functions.
	public DocOfFuncProperties parse( DocOfFuncProperties docOfFuncProperties ){

		try {
			WSDLFactory wFactory = WSDLFactory.newInstance();
	        WSDLReader wReader = wFactory.newWSDLReader();
	        wReader.setFeature(WSDLReader.FEATURE_VALIDATION, true);
	        DescriptionElement descElem = (DescriptionElement) wReader.readWSDL(docOfFuncProperties.getRef2DocOfFuncProperties());
	        Description des = descElem.toComponent();	        

	        org.apache.woden.wsdl20.Service[] serviceList = des.getServices();
	         //System.out.println("First service name: "+getSuffix(serviceList[0].getName().toString()));

	         for( int k = 0; serviceList != null && k < serviceList.length; k++ ){

	        	 ServiceType serviceType = new ServiceType( getSuffix(serviceList[k].getName().toString()), "WS", "WSDLv2" );//TODO: What about the prefix?

	        	 Endpoint[] endpointList = serviceList[k].getEndpoints();

	        	 for( int j=0; endpointList != null && j < endpointList.length; j++ ){

	        		 Endpoint endpoint=endpointList[j];
	        		 //System.out.println("\t endpoint = " + endpoint.getName());
	        		 
	        		 String uri = endpoint.getAddress().toString();
	        		 //System.out.println("\t uri = " + uri);
	        				 
	        		 Binding binding = endpoint.getBinding();
	        		 //System.out.println("\t binding = " + getSuffix(binding.getName().toString()));
	        		 
	        		 String protocol = binding.getType().toURL().getProtocol();
	        		 //System.out.println("\t protocol = " + protocol);
	        		 
	        		 Interface interf = binding.getInterface();
	        		 //System.out.println("\t interface = " + getSuffix(interf.getName().toString()));
	        		 
	        		 ServiceInterface i = serviceType.exist( getSuffix( interf.getName().toString() ) );//TODO: What about the prefix?
	        		 
	        		if( i != null ){//Exist!

	        			ServiceInstance interfaceInstance = new ServiceInstance(getSuffix(endpoint.getName().toString()), protocol, uri);//TODO: What about the prefix?
						i.addServiceInstance(interfaceInstance);
					}

	        		else{//Does not exist!

	        			i = new ServiceInterface( getSuffix(interf.getName().toString()) );//TODO: What about the prefix?

						InterfaceOperation[] operations = interf.getInterfaceOperations();

						for( int m = 0; operations != null && m < operations.length; m++ ){

							InterfaceOperation operation = operations[m];
							//System.out.println("\t\t operation = " + getSuffix(operation.getName().toString()));

							InterfaceMessageReference[] imr = operation.getInterfaceMessageReferences();
								
							String In=imr[0].getMessageLabel().toString();
								
							Message InMessage = null;

							if( In != null ){
								//System.out.println("\t\t\t input message = " + imr[0].getMessageLabel());

								InMessage = new Message(getSuffix(In));

								String element = getSuffix(imr[0].getElementDeclaration().getName().toString());
								//System.out.println("\t\t\t\t element: (Name = " + element + ")");
												
								//DEN EINAI SWSTO AKOMA!
								MessageType msgTypeIn = new MessageType(In, element, "element");
								InMessage.add( msgTypeIn );
							}
								
							String Out = imr[1].getMessageLabel().toString();

							Message OutMessage = null;

							if( Out != null ){
								//System.out.println("\t\t\t input message = " + imr[1].getMessageLabel());

								OutMessage = new Message(getSuffix(Out));

								String element = getSuffix(imr[1].getElementDeclaration().getName().toString());
								//System.out.println("\t\t\t\t element: (Name = " + element + ")");
									
								//DEN EINAI SWSTO AKOMA!
								MessageType msgTypeOut =new MessageType(Out, element, "element");
								OutMessage.add(msgTypeOut);
																	    
							}

							i.add( new org.ow2.choreos.serviceRepresentation.functional.Operation(getSuffix(operation.getName().toString()), InMessage, OutMessage));
					}//for
						
					ServiceInstance interfaceInstance = new ServiceInstance(getSuffix(endpoint.getName().toString()), protocol, uri);
					i.addServiceInstance(interfaceInstance);
					serviceType.add(i);

	        	}//else
	        }//for

	        docOfFuncProperties.add(serviceType);
	    }//for
	    }//try		
		catch( WSDLException e ){ docOfFuncProperties = (DocOfFuncProperties) FunctionalServiceRepresentationController.getErrorDocOfFuncProperties( docOfFuncProperties.getRef2DocOfFuncProperties(), "The document '" + ( (DocOfFuncProperties) docOfFuncProperties).getRef2DocOfFuncProperties() + "' is NOT specified in the WSDLv2.0 language" + "\n(" + e.getMessage() + ")" );}
		catch( MalformedURLException e ){ docOfFuncProperties = (DocOfFuncProperties) FunctionalServiceRepresentationController.getErrorDocOfFuncProperties( docOfFuncProperties.getRef2DocOfFuncProperties(), "The document '" + ( (DocOfFuncProperties) docOfFuncProperties).getRef2DocOfFuncProperties() + "' is NOT specified in the WSDLv2.0 language" + "\n(" + e.getMessage() + ")" );}
		
		return docOfFuncProperties;
	}
}
