package org.ow2.choreos.pluginManager;


import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.gui.PrintMessages;


@SuppressWarnings("serial")
public class PluginManager {


	//Variables.
	private static LocalFileSystemPlugin plugin;

	private static Map<String, String> pluginKinds = new Hashtable<String, String>() { { put( "Local File System", "Local File System" ); } };


	//Getters.
	public static Objects retrieve( String ref2Source ){//Default type of source: "Local File System".

		if( plugin == null ) plugin = new LocalFileSystemPluginImpl();

		return plugin.retrieve( ref2Source );
	}

	public static Objects retrieve( String type, String ref2Source ){

		if( MapGetter.keyBelongsToMapStrings( type, pluginKinds ) ){

			if( plugin == null ) plugin = new LocalFileSystemPluginImpl();

			return plugin.retrieve( ref2Source );
		}

		else{

			PrintMessages.print( PrintMessages.pluginPrint, "Plugin Manager: Unknown kind of source.");

			return null;
		}
	}

	public static int getNumOfDocuments( String type, String ref2Source ){

		if( MapGetter.keyBelongsToMapStrings( type, pluginKinds ) ){

			if( plugin == null ) plugin = new LocalFileSystemPluginImpl();

			return plugin.getNumOfDocuments( ref2Source );
		}

		else{

			PrintMessages.print( PrintMessages.pluginPrint, "Plugin Manager: Unknown kind of source.");

			return 0;
		}
	}
}
