package org.ow2.choreos.queryEngineServiceDeployment;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.*;
import java.util.*;

import javax.swing.*;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.ow2.choreos.abstractionBase.FunctionalAbstraction;
import org.ow2.choreos.abstractionBase.NonFunctionalAbstraction;
import org.ow2.choreos.serviceRepresentation.functional.Operation;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInstance;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;
import org.ow2.choreos.serviceRepresentation.nonFunctional.NonFuncDescription;
import org.ow2.choreos.serviceRepresentation.nonFunctional.QualityProperties;
import org.ow2.choreos.queryEngineFacade.ConcreteService;
import org.ow2.choreos.queryEngineFacade.SimpleQuery;
import org.ow2.choreos.queryEngineFacade.AdvancedQuery;
import org.ow2.choreos.queryEngineFacade.OperationConstraints;
import org.ow2.choreos.queryEngineFacade.QualityPropertyConstraints;
import org.ow2.choreos.queryEngineFacade.QueryEngineFacadeException;

/**
 * A GUI for the RESTful query engine service client.
 * 
 * @author pilios
 */

public class QueryEngineServiceClientGUI extends javax.swing.JFrame {

	private QueryEngineServiceClient client;
	
	private String lastBrowsedSBQLQueryDirectory = ".";
	private String lastBrowsedSimpleQueryDirectory = ".";
	private String lastBrowsedAdvancedQueryDirectory = ".";
	
	private SimpleQuery simpleQuery = null;
	private AdvancedQuery advancedQuery = null;
	
    public QueryEngineServiceClientGUI(QueryEngineServiceClient client) {
    	
    	this.client = client;
    	
    	try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    	} catch (UnsupportedLookAndFeelException e) {}
          catch (ClassNotFoundException e) {}
          catch (InstantiationException e) {}
          catch (IllegalAccessException e) {}
    	
    	initComponents();
    	
    	Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
    	int jframe_width = getWidth();
    	int jframe_height = getHeight();
    	int jframe_left = (screen.width - jframe_width) / 2;
    	int jframe_top = (screen.height - jframe_height) / 2;
    	setBounds(jframe_left, jframe_top, jframe_width, jframe_height);
    	
    	setVisible(true);
    }

    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jButton2 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jLabel4 = new javax.swing.JLabel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextArea5 = new javax.swing.JTextArea();
        jLabel5 = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jButton4 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextArea6 = new javax.swing.JTextArea();
        jLabel8 = new javax.swing.JLabel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTextArea7 = new javax.swing.JTextArea();
        jRadioButton5 = new javax.swing.JRadioButton();
        jRadioButton6 = new javax.swing.JRadioButton();
        jLabel7 = new javax.swing.JLabel();

        buttonGroup1.add(jRadioButton1);
        buttonGroup1.add(jRadioButton2);

        buttonGroup3.add(jRadioButton5);
        buttonGroup3.add(jRadioButton6);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Query Engine Service Client");

        jPanel1.setBackground(new java.awt.Color(255, 255, 204));

        jButton1.setText("Execute");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));

        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jButton2.setText("Browse");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jTextArea2.setEditable(false);
        jTextArea2.setColumns(20);
        jTextArea2.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jTextArea2.setRows(5);
        jScrollPane2.setViewportView(jTextArea2);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel1.setText("Results");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton2)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 344, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(0, 436, Short.MAX_VALUE))
                    .addComponent(jScrollPane2))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(13, 13, 13)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 358, Short.MAX_VALUE))
                .addContainerGap())
        );

        jTabbedPane1.addTab("SBQL Query", jPanel2);

        jPanel3.setBackground(new java.awt.Color(255, 255, 255));

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel2.setText("Operation names & Requirements");

        jTextArea3.setEditable(false);
        jTextArea3.setColumns(20);
        jTextArea3.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jTextArea3.setRows(5);
        jScrollPane3.setViewportView(jTextArea3);

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel4.setText("Query to be executed over:");

        jRadioButton1.setBackground(new java.awt.Color(255, 255, 255));
        jRadioButton1.setText("abstractions");

        jRadioButton2.setBackground(new java.awt.Color(255, 255, 255));
        jRadioButton2.setSelected(true);
        jRadioButton2.setText("instances");

        jTextArea5.setEditable(false);
        jTextArea5.setColumns(20);
        jTextArea5.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jTextArea5.setRows(5);
        jScrollPane5.setViewportView(jTextArea5);

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel5.setText("Result");

        jButton3.setText("Browse");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 314, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jRadioButton2)
                            .addComponent(jLabel4)
                            .addComponent(jRadioButton1))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 508, Short.MAX_VALUE)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jLabel5)
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jButton3)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton3)
                .addGap(15, 15, 15)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jScrollPane3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton2))
                    .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 331, Short.MAX_VALUE))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Simple Query", jPanel3);

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));

        jButton4.setText("Browse");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel6.setText("Functional & Non Functional Constraints & Requirements");

        jTextArea6.setEditable(false);
        jTextArea6.setColumns(20);
        jTextArea6.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jTextArea6.setRows(5);
        jScrollPane6.setViewportView(jTextArea6);

        jLabel8.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel8.setText("Query to be executed over:");

        jTextArea7.setEditable(false);
        jTextArea7.setColumns(20);
        jTextArea7.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jTextArea7.setRows(5);
        jScrollPane7.setViewportView(jTextArea7);

        jRadioButton5.setBackground(new java.awt.Color(255, 255, 255));
        jRadioButton5.setSelected(true);
        jRadioButton5.setText("instances");

        jRadioButton6.setBackground(new java.awt.Color(255, 255, 255));
        jRadioButton6.setText("abstractions");

        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel7.setText("Results");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel8)
                            .addComponent(jRadioButton5)
                            .addComponent(jRadioButton6)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jScrollPane6))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 504, Short.MAX_VALUE)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(jLabel7)
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addComponent(jButton4))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 267, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton5))
                    .addComponent(jScrollPane7))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Advanced Query", jPanel4);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton1)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }
    
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
        // Browse SBQL
    	
    	JFileChooser chooser = new JFileChooser();
        chooser.setCurrentDirectory(new File(lastBrowsedSBQLQueryDirectory));
        chooser.setDialogTitle("Open");
        
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
        	lastBrowsedSBQLQueryDirectory = chooser.getSelectedFile().toString();
            String sbqlFile = chooser.getSelectedFile().toString();
            
            String line;
            String query = "";
            
            try{
	            FileReader fr = new FileReader(sbqlFile);
				BufferedReader br = new BufferedReader(fr);
	            while ((line = br.readLine()) != null) {
	            	query += line + "\n";
	            }
	            
            } catch(FileNotFoundException e){
            	e.printStackTrace();
            } catch(IOException e){
            	e.printStackTrace();
            } 
            
            jTextArea1.setText(query);
        }
    }

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
        // Execute
    	//
    	//SBQL
    	//jTextArea1: sbql query
    	//jTextArea2: Result
    	//
    	//Simple:
    	//jRadioButton1 : abstractions
    	//jRadioButton2 : instances
    	//jTextArea3: query
    	//jTextArea5: result
    	//
    	//Advanced:
    	//jRadioButton6 : abstractions
    	//jRadioButton5 : instances
    	//jTextArea6: query
    	//jTextArea7: Result
    	
    	int selectedTabIndex = jTabbedPane1.getSelectedIndex();
    	
    	if(selectedTabIndex == 0){
    		
    		String sbqlQuery = jTextArea1.getText();
    		
    		Response response = client.executeSBQLQuery(sbqlQuery);
        	
        	QueryEngineServiceResponse qeResponse = null;
        	
        	try {
        		qeResponse = unMarshal(response);
    			
    		} catch (WebApplicationException e) {
    			JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
    		    return;
    		} catch (JAXBException e) {
    			JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
    		    return;
    		}
        	
        	Status status = qeResponse.getHttpStatus();
        	if(status != Status.OK) {
        		JOptionPane.showMessageDialog(null, status, "error", JOptionPane.ERROR_MESSAGE);
        		return;
        	}
        	
        	List<FunctionalAbstraction> functionalAbstractions = qeResponse.getFunctionalAbstractions();
        	List<NonFunctionalAbstraction> nonFunctionalAbstractions = qeResponse.getNonFunctionalAbstractions();
        	
        	String result = "";
        	
        	if(functionalAbstractions != null) {
        		
            	int faListSize = functionalAbstractions.size();
            	
            	if(faListSize != 0) {
            		result = "\n---------------------------------- Functional Abstractions ---------------------------------\n\n";
        	    	for(int i = 0; i < faListSize; i++) {
        	    		FunctionalAbstraction fa = functionalAbstractions.get(i);
        	    		result += (i + 1) + "\tinterface name: " + fa.getInterface().getName() + "\n";
        	    	}
            	}
            	
        	}
        	
        	if(nonFunctionalAbstractions != null) {
            	
        		int nfaListSize = nonFunctionalAbstractions.size();
        		
            	if(nfaListSize != 0) {
            		result += "\n\n---------------------------------- Non Functional Abstractions ----------------------------------\n\n";
        	    	for(int i = 0; i < nfaListSize; i++) {
        	    		NonFunctionalAbstraction nfa = nonFunctionalAbstractions.get(i);
        	    		result += (i + 1) + "\tid: " + nfa.getNonFunctionalAbstractionID() + "\n";
        	    	}
            	}
            	
            	result += "\n\n";
        	}
        	
        	jTextArea2.setText(result);
    	}
    	
    	else if(selectedTabIndex == 1){
    		
    		if(jRadioButton1.isSelected()){
            	
            	Response response = client.executeSimpleQueryOverAbstractions(simpleQuery);
        		
            	jTextArea5.setText(getConcreteServicesInfo(response, simpleQuery, null));
            	
            }
            else if(jRadioButton2.isSelected()){
            	
            	Response response = client.executeSimpleQueryOverInstances(simpleQuery);
            	
            	jTextArea5.setText(getConcreteServicesInfo(response, simpleQuery, null));
            		
            }
    	}
    	
    	else if(selectedTabIndex == 2){
    		
    		if(jRadioButton6.isSelected()){
    			
    			Response response = client.executeAdvancedQueryOverAbstractions(advancedQuery);
    			
    			jTextArea7.setText(getConcreteServicesInfo(response, null, advancedQuery));
        			
    		}
    		
    		else if(jRadioButton5.isSelected()){
    			
    			Response response = client.executeAdvancedQueryOverInstances(advancedQuery);
            	
    			jTextArea7.setText(getConcreteServicesInfo(response, null, advancedQuery));
     	
    		}
    		
    	}
    }

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {
        // Browse simple
    	
    	JFileChooser chooser = new JFileChooser();
        chooser.setCurrentDirectory(new File(lastBrowsedSimpleQueryDirectory));
        chooser.setDialogTitle("Open");
        
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
        	lastBrowsedSimpleQueryDirectory = chooser.getSelectedFile().toString();
            String simpleQueryFile = chooser.getSelectedFile().toString();
            
            try {
                FileInputStream fileIn = new FileInputStream(simpleQueryFile);
                ObjectInputStream in = new ObjectInputStream(fileIn);
                simpleQuery = (SimpleQuery) in.readObject();
                
                if(simpleQuery == null){
                	jTextArea3.setText("simpleQuery == null");
                	return;
                }
                
                try {
                	simpleQuery.checkWellFormedNess();
                } catch (QueryEngineFacadeException qefEx) {
                	JOptionPane.showMessageDialog(this, qefEx.getMessage(), "error", JOptionPane.ERROR_MESSAGE);  
                	return;
                }
                
                String query = "Operation names:\n\n";
                
                List<String> opNames = simpleQuery.getOperationNames();
                int opNamesSize = opNames.size();
                String RQs = simpleQuery.getRQs();
                
                for(int i = 0; i < opNamesSize; i++){
                	query += "\t" + opNames.get(i) + "\n";
                }
                
                query += "\nRequirements:\n\n";
                query += "\t" + RQs;
                
                jTextArea3.setText(query);
                
                in.close();
                fileIn.close();
            } 
            catch(IOException e) {
                JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
            } 
            catch(ClassNotFoundException e) {
            	JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
            }
        } 
    }

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {
        // Browse advanced
    	
    	JFileChooser chooser = new JFileChooser();
        chooser.setCurrentDirectory(new File(lastBrowsedAdvancedQueryDirectory));
        chooser.setDialogTitle("Open");
        
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
        	lastBrowsedAdvancedQueryDirectory = chooser.getSelectedFile().toString();
            String advancedQueryFile = chooser.getSelectedFile().toString();
            
            try {
                FileInputStream fileIn = new FileInputStream(advancedQueryFile);
                ObjectInputStream in = new ObjectInputStream(fileIn);
                advancedQuery = (AdvancedQuery) in.readObject();
                
                if(advancedQuery == null){
                	jTextArea6.setText("advancedQuery == null");
                	return;
                }
                
                try {
                	advancedQuery.checkWellFormedNess();
                } catch (QueryEngineFacadeException qefEx) {
                	JOptionPane.showMessageDialog(this, qefEx.getMessage(), "error", JOptionPane.ERROR_MESSAGE);  
                	return;
                }
        		
                String query = "Operations constraints:\n\n";
                
                List<OperationConstraints> operationsConstraints = advancedQuery.getOperationsConstraints();
                int operationsConstraintsSize = operationsConstraints.size();
                
                for(int i = 0; i < operationsConstraintsSize; i++){
                	
                	OperationConstraints opConstr = operationsConstraints.get(i);
                	
                	query += "name: " + opConstr.getName() + "\n";
                	query += "input parameters:\n";
                	
                	List<String> inParamNames = opConstr.getInParamNames();
                	List<String> inParamTypes = opConstr.getInParamTypes();
                	
                	if(inParamNames == null)
                		query += "\tnull";
                	else{
                		
                		int inParamNamesSize = inParamNames.size();
                		
                		for(int j = 0; j < inParamNamesSize; j++){
                			
                			String name = inParamNames.get(j);
        					String type = inParamTypes.get(j);
        					
                			query += "\t" + name + " : ";
                    	    query += type + "\n";
                		}
                		
                	}
                	
                	query += "output parameters:\n";
                	
                	List<String> outParamNames = opConstr.getOutParamNames();
                	List<String> outParamTypes = opConstr.getOutParamTypes();
                	
                	if(outParamNames == null)
                		query += "\tnull";
                	else{
             
                		int outParamNamesSize = outParamNames.size();
                		
                		for(int j = 0; j < outParamNamesSize; j++){
                			
                			String name = outParamNames.get(j);
        					String type = outParamTypes.get(j);
        					
                			query += "\t" + name + " : ";
                    	    query += type + "\n";
                		}
                		
                	}
                	
                	query += "\n";
                }
                	
                query += "\nQuality properties constraints:\n\n";
                	
                List<QualityPropertyConstraints> qualityPropertiesConstraints = advancedQuery.getQualityPropertiesConstraints();
                
                if(qualityPropertiesConstraints == null){
                	query += "\tnull";
                }
                else{
                	
	                int qualityPropertiesConstraintsSize = qualityPropertiesConstraints.size();
	                	
	                for(int i = 0; i < qualityPropertiesConstraintsSize; i++){
	                	
	                	QualityPropertyConstraints qpConstr = qualityPropertiesConstraints.get(i);
	                	
	                	query += "name: " + qpConstr.getName() + "\n";
	                	query += "value description: " + qpConstr.getValueDescription() + "\n";
	                	query += "low value: " + qpConstr.getValueFrom() + "\n";
	                	query += "high value: " + qpConstr.getValueTo() + "\n";	
	                	query += "\n";
	                }
                }
                
                String RQs = advancedQuery.getRQs();
                
                query += "\nRequirements:\n\n";
                query += RQs;
                
                jTextArea6.setText(query);
                
                in.close();
                fileIn.close();
            } 
            catch(IOException e) {
            	e.printStackTrace();
                JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
            } 
            catch(ClassNotFoundException e) {
            	e.printStackTrace();
            	JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
            }
        } 
    }
    
    private QueryEngineServiceResponse unMarshal(Response response) throws WebApplicationException, JAXBException{
    	
    	QueryEngineServiceResponse qeResponse;
    	
    	try {
			InputStream in = (InputStream) response.getEntity();
			
			JAXBContext context = JAXBContext.newInstance(QueryEngineServiceResponse.class);
			Unmarshaller unmarshaller = context.createUnmarshaller();    
			qeResponse = (QueryEngineServiceResponse) unmarshaller.unmarshal(in);
			
		} catch (WebApplicationException e) {
		    throw(e);
		} catch (JAXBException e) {
			throw(e);
		}
    	
    	return qeResponse;
    }
    
    private String getConcreteServicesInfo(Response response, SimpleQuery simpleQuery, AdvancedQuery advancedQuery) {
    	
    	QueryEngineServiceResponse qeResponse = null;
    	
    	try {
    		qeResponse = unMarshal(response);
			
		} catch (WebApplicationException e) {
			JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
		    return "No results";
		} catch (JAXBException e) {
			JOptionPane.showMessageDialog(null, e.getMessage(), "error", JOptionPane.ERROR_MESSAGE);
		    return "No results";
		}
    	
    	Status status = qeResponse.getHttpStatus();
    	
    	if(status != Status.OK) {
    		JOptionPane.showMessageDialog(null, status, "error", JOptionPane.ERROR_MESSAGE);
    		return "No results";
    	}
    	
    	String errorMessage = qeResponse.getErrorMessage();
    	
    	if(errorMessage != null) {
    		JOptionPane.showMessageDialog(null, errorMessage, "error", JOptionPane.ERROR_MESSAGE);
    		return "No results";
    	}
    	
    	List<ConcreteService> queryResults = qeResponse.getConcreteServices();
    	
    	if(queryResults == null)
    		return "Number of concrete services found : 0";
    	
    	String result = "";
    	result += "Number of concrete services found : " + queryResults.size() + "\n\n";
    	
		for(int i = 0; i < queryResults.size(); i++){
			ConcreteService concreteService = queryResults.get(i);
			
			result += "\nConcrete Service: " + (i + 1) + "\n\n";
			result += "LTS URI: " + concreteService.getBehavioralSpecificationURI() + "\n";
			result += "ENC URI: " + concreteService.getEnactementURI() + "\n";
			result += "Mappings:" + "\n";
			
			List<String> queryOperations = null;
			
			if(simpleQuery != null)
				queryOperations = simpleQuery.getOperationNames();
			else
				queryOperations = advancedQuery.getOperationNames();
			
			for(int j = 0; j < queryOperations.size(); j++){
				result += "\tQuery operation: " + queryOperations.get(j) + "\n";
				List<Operation> retrievedOperations = concreteService.getRetrievedOperations(queryOperations.get(j));
				
				if(retrievedOperations != null){
					for(int k = 0; k < retrievedOperations.size(); k++){
						result += "\t\t" + retrievedOperations.get(k).getName() + "\n";
					}
				}
			}
			
			List<String> retrievedURIs = concreteService.getServiceInstancesURIs();
			result += "\nService Instances URIs:" + "\n";
			for(int j = 0; j < retrievedURIs.size(); j++)
				result += "\t" + retrievedURIs.get(j) + "\n";
			
			result += "\n";
		}
		
		return result;
    }
    
    
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton5;
    private javax.swing.JRadioButton jRadioButton6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JTextArea jTextArea5;
    private javax.swing.JTextArea jTextArea6;
    private javax.swing.JTextArea jTextArea7;
    private javax.swing.JTextArea jTextArea8;
   
}

