package org.ow2.choreos.queryEngineServiceDeployment;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import javax.swing.JOptionPane;

import org.ow2.choreos.queryEngineFacade.OperationConstraints;
import org.ow2.choreos.queryEngineFacade.QualityPropertyConstraints;
import org.ow2.choreos.queryEngineFacade.SimpleQuery;
import org.ow2.choreos.queryEngineFacade.AdvancedQuery;

public class QueryExampleSerFilesProducer {

	public static void main(String [] args){
		
		produceSimpleQuery();
		produceAdvancedQuery();
		produceAdvancedQuery2();
		produceAdvancedQuery3();
		produceAdvancedQuery4();
		
	}
	
	public static void produceSimpleQuery(){
		
		List<String> operations = new ArrayList<String>();
		
		operations.add("request");
		operations.add("get");
		operations.add("Ol");
		
		String RQs = null;
		
		SimpleQuery simpleQuery = new SimpleQuery(operations, RQs);
		
		exportAsSerFile(simpleQuery, "C:/Users/Dimitris/Desktop/WeatherSimpleQuery.ser");
		
	}
	
	public static void produceAdvancedQuery(){
		
		String opName1 = "gettype";
		
		List<String> inParamNames1 = new ArrayList<String>();
		inParamNames1.add("area");
		
		List<String> inParamTypes1 = new ArrayList<String>();
		inParamTypes1.add("String");
		
		List<String> outParamNames1 = new ArrayList<String>();
		outParamNames1.add("area");
		
		List<String> outParamTypes1 = new ArrayList<String>();
		outParamTypes1.add("string");
		
		String opName2 = "settype";
		
		List<String> inParamNames2 = new ArrayList<String>();
		inParamNames2.add("area");
		
		List<String> inParamTypes2 = new ArrayList<String>();
		inParamTypes2.add("string");
		
		List<String> outParamNames2 = new ArrayList<String>();
		outParamNames2.add("area");
		
		List<String> outParamTypes2 = new ArrayList<String>();
		outParamTypes2.add("string");

		OperationConstraints opConstr1 = new OperationConstraints(opName1, inParamNames1, inParamTypes1, outParamNames1, outParamTypes1);
		OperationConstraints opConstr2 = new OperationConstraints(opName2, inParamNames2, inParamTypes2, outParamNames2, outParamTypes2);
		
		List<OperationConstraints> operationsConstraints = new ArrayList<OperationConstraints>();
		operationsConstraints.add(opConstr1);
		operationsConstraints.add(opConstr2);
		
		QualityPropertyConstraints qpConstr1 = new QualityPropertyConstraints("ResponseTime", "Fast");
		QualityPropertyConstraints qpConstr2 = new QualityPropertyConstraints("Availability", "Medium");
		
		List<QualityPropertyConstraints> qualityPropertyConstraints = new ArrayList<QualityPropertyConstraints>();
		qualityPropertyConstraints.add(qpConstr1);
		qualityPropertyConstraints.add(qpConstr2);
		
		AdvancedQuery advancedQuery = new AdvancedQuery(operationsConstraints, qualityPropertyConstraints, null);
		//AdvancedQuery advancedQuery = new AdvancedQuery(operationsConstraints, null, null);
		
		exportAsSerFile(advancedQuery, "C:/Users/Dimitris/Desktop/WeatherAdvancedQuery.ser");
	
	}
	
	public static void produceAdvancedQuery3(){
		
		String opName1 = "request";
		
		List<String> inParamNames1 = new ArrayList<String>();
		inParamNames1.add("parameters");
		
		List<String> inParamTypes1 = new ArrayList<String>();
		inParamTypes1.add("string");
		
		List<String> outParamNames1 = new ArrayList<String>();
		outParamNames1.add("parameters");
		
		List<String> outParamTypes1 = new ArrayList<String>();
		outParamTypes1.add("string");
		
		String opName2 = "get";
		
		List<String> inParamNames2 = new ArrayList<String>();
		inParamNames2.add("parameters");
		
		List<String> inParamTypes2 = new ArrayList<String>();
		inParamTypes2.add("string");
		
		List<String> outParamNames2 = new ArrayList<String>();
		outParamNames2.add("parameters");
		
		List<String> outParamTypes2 = new ArrayList<String>();
		outParamTypes2.add("string");

		OperationConstraints opConstr1 = new OperationConstraints(opName1, inParamNames1, inParamTypes1, outParamNames1, outParamTypes1);
		OperationConstraints opConstr2 = new OperationConstraints(opName2, inParamNames2, inParamTypes2, outParamNames2, outParamTypes2);
		
		List<OperationConstraints> operationsConstraints = new ArrayList<OperationConstraints>();
		operationsConstraints.add(opConstr1);
		operationsConstraints.add(opConstr2);
		
		QualityPropertyConstraints qpConstr1 = new QualityPropertyConstraints("ResponseTime", 700, 800);
		QualityPropertyConstraints qpConstr2 = new QualityPropertyConstraints("Availability", 40, 50);
		
		List<QualityPropertyConstraints> qualityPropertyConstraints = new ArrayList<QualityPropertyConstraints>();
		qualityPropertyConstraints.add(qpConstr1);
		qualityPropertyConstraints.add(qpConstr2);
		
		AdvancedQuery advancedQuery = new AdvancedQuery(operationsConstraints, qualityPropertyConstraints, null);
		
		
		exportAsSerFile(advancedQuery, "C:/Users/Dimitris/Desktop/AirportAdvancedQuery3.ser");
	
	}
	
	public static void produceAdvancedQuery4(){
		
		String opName1 = "set";
		
		List<String> inParamNames1 = new ArrayList<String>();
		inParamNames1.add("parameters");
		inParamNames1.add("parametersB");
		inParamNames1.add("parametersC");
		
		List<String> inParamTypes1 = new ArrayList<String>();
		inParamTypes1.add("string");
		inParamTypes1.add("int");
		inParamTypes1.add("double");
		
		List<String> outParamNames1 = new ArrayList<String>();
		outParamNames1.add("parameters");
		
		List<String> outParamTypes1 = new ArrayList<String>();
		outParamTypes1.add("string");
		
		String opName2 = "request";
		
		List<String> inParamNames2 = new ArrayList<String>();
		inParamNames2.add("parameters");
		
		List<String> inParamTypes2 = new ArrayList<String>();
		inParamTypes2.add("string");
		
		List<String> outParamNames2 = new ArrayList<String>();
		outParamNames2.add("parameters");
		
		List<String> outParamTypes2 = new ArrayList<String>();
		outParamTypes2.add("string");
		
		String opName3 = "get";
		
		List<String> inParamNames3 = new ArrayList<String>();
		inParamNames3.add("parameters");
		
		List<String> inParamTypes3 = new ArrayList<String>();
		inParamTypes3.add("string");
		
		List<String> outParamNames3 = new ArrayList<String>();
		outParamNames3.add("parameters");
		
		List<String> outParamTypes3 = new ArrayList<String>();
		outParamTypes3.add("string");

		OperationConstraints opConstr1 = new OperationConstraints(opName1, inParamNames1, inParamTypes1, outParamNames1, outParamTypes1);
		OperationConstraints opConstr2 = new OperationConstraints(opName2, inParamNames2, inParamTypes2, outParamNames2, outParamTypes2);
		OperationConstraints opConstr3 = new OperationConstraints(opName3, inParamNames3, inParamTypes3, outParamNames3, outParamTypes3);
		
		List<OperationConstraints> operationsConstraints = new ArrayList<OperationConstraints>();
		operationsConstraints.add(opConstr1);
		operationsConstraints.add(opConstr2);
		operationsConstraints.add(opConstr3);
		
		QualityPropertyConstraints qpConstr1 = new QualityPropertyConstraints("ResponseTime", 700, 800);
		QualityPropertyConstraints qpConstr2 = new QualityPropertyConstraints("Availability", 40, 50);
		
		List<QualityPropertyConstraints> qualityPropertyConstraints = new ArrayList<QualityPropertyConstraints>();
		qualityPropertyConstraints.add(qpConstr1);
		qualityPropertyConstraints.add(qpConstr2);
		
		//AdvancedQuery advancedQuery = new AdvancedQuery(operationsConstraints, qualityPropertyConstraints, null);
		AdvancedQuery advancedQuery = new AdvancedQuery(operationsConstraints, null, null);
		
		exportAsSerFile(advancedQuery, "C:/Users/Dimitris/Desktop/AirportAdvancedQuery4.ser");
	
	}
	
	public static void produceAdvancedQuery2(){
		
		List<OperationConstraints> oc = new ArrayList<OperationConstraints>();

        List<String> outNames = new ArrayList<String>();
        outNames.add("area");
        List<String> outTypes = new ArrayList<String>();
        outTypes.add("String");

        OperationConstraints o1 = new OperationConstraints("isLanding",
        				null, null,
                        outNames, outTypes);
        oc.add(o1);

        AdvancedQuery sq = new AdvancedQuery(oc, null, null);

        exportAsSerFile(sq, "C:/Users/Dimitris/Desktop/AirportAdvancedQuery.ser");
       
	}
	
	private static void exportAsSerFile(Object object, String filePath){
		
		try{
			FileOutputStream fileOut = new FileOutputStream(filePath);
            ObjectOutputStream out = new ObjectOutputStream(fileOut);
            out.writeObject(object);
            out.close();
            fileOut.close();

        } catch (IOException e) {
            System.err.print(e.getMessage());
        }
		
	}
}
