package org.ow2.choreos.schemaRegistration;

import java.util.List;

import javax.swing.tree.DefaultMutableTreeNode;


/**
 * 
 * @author dathanas
 *
 */
public class SchemaRegistrationController {


	//Variables.
	private static final String unknownObject = "UnknownObject";


	//Verifiers.
	public static boolean isSchemaRegistrationKinds( Object object ){

		return isSchemaSourceKind( object ) || isSchemaCollectionKind( object ) || isSchemaRegistrationKind( object );
	}

	public static boolean isSchemaSourceKind( Object object ){

		return object != null ? object.getClass().equals( SchemaSource.class ) : false;
	}

	private static boolean isSchemaCollectionKind( Object object ){

		return object != null ? object.getClass().equals( SchemaCollection.class ) : false;
	}

	private static boolean isSchemaRegistrationKind( Object object ){

		return object != null ? object.getClass().equals( SchemaRegistration.class ) : false;
	}


	//Getters.
	public static String getTag( Object object ){

		if( isSchemaSourceKind( object ) ) return ( (SchemaSource) object).getTag();

		if( isSchemaCollectionKind( object ) ) return ( (SchemaCollection) object).getTag();

		if( isSchemaRegistrationKind( object ) ) return ( (SchemaRegistration) object).getTag();


		return unknownObject;
	}

	public static String getConstraintViolation( Object object ){

		if( isSchemaSourceKind( object ) ) return ( (SchemaSource) object).getConstraintViolation();

		if( isSchemaCollectionKind( object ) ) return ( (SchemaCollection) object).getConstraintViolation();

		if( isSchemaRegistrationKind( object ) ) return ( (SchemaRegistration) object).getConstraintViolation();


		return unknownObject;
	}

	public static boolean hasCollections( Object object ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).hasCollections() : false;
	}

	public static DefaultMutableTreeNode visualize( Object object, boolean withContents ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).visualize( withContents ) : null;
	}

	public static DefaultMutableTreeNode visualize( Object object, Integer collectionID ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).visualize( collectionID ) : null;
	}

	public static List<String> getNamesOfDocOfSchemas( Object object, Integer collectionID ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getNamesOfDocOfSchemas( collectionID ) : null;
	}

	public static List<String> getRefs2DocsOfSchemas( Object object, Integer collectionID ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getRefs2DocsOfSchemas( collectionID ) : null;
	}

	public static String getSchemaRepresentationModel( Object object, Integer collectionID ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getSchemaRepresentationModel( collectionID ) : null;
	}

	public static int getNumOfParsedSchemaDocs( Object object ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getNumOfParsedSchemaDocs() : 0;
	}

	public static int getNumOfParsedSchemaDocsOfCollection( Object object, Integer collectionID ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getNumOfParsedSchemaDocsOfCollection( collectionID ) : 0;
	}

	public static Object lookUp( Object object, Integer collectionID, String ref2Source, String ref2DocOfSchemas ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).lookUp( collectionID, ref2DocOfSchemas ) : null;
	}

	public static Object lookUp( Object object, Integer collectionID, String ref2DocOfSchemas ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).lookUp( collectionID, ref2DocOfSchemas ) : null;
	}

	public static double getDuration( Object object ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getDuration() : 0.0;
	}

	public static double getSize( Object object ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getSize() : 0.0;
	}

	public static double getDuration( Object object, Integer collectionID, String ref2Source, String ref2DocOfSchemas ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getDuration( collectionID, ref2Source, ref2DocOfSchemas ) : 0.0;
	}

	public static double getDuration( Object object, Integer collectionID ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getDuration( collectionID ) : 0.0;
	}

	public static Integer getCurrentCollectionID( Object object ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getCurrentCollectionID() : null;
	}

	public static String getSingleRef2Source( Object object ){

		return isSchemaRegistrationKind( object ) ? ( (SchemaRegistration) object).getSingleRef2Source() : null;
	}


	//Setters.
	public static String setConstraintViolation( Object object, String constraintViolation ){

		if( isSchemaSourceKind( object ) ) return ( (SchemaSource) object).setConstraintViolation( constraintViolation );

		if( isSchemaCollectionKind( object ) ) return ( (SchemaCollection) object).setConstraintViolation( constraintViolation );

		if( isSchemaRegistrationKind( object ) ) return ( (SchemaRegistration) object).setConstraintViolation( constraintViolation );


		return unknownObject;
	}

	public static Object register( String ref2Source, Object object ){

		if( object == null ) object = new SchemaRegistration();


		if( isSchemaRegistrationKind( object ) ) ( (SchemaRegistration) object).register( ref2Source );


		return object;
	}

	public static void increaseCurrentCollectionID( Object object ){

		if( isSchemaRegistrationKind( object ) ) ( (SchemaRegistration) object).increaseCurrentCollectionID();
	}
}

