package org.ow2.choreos.schemaRepresentation.xml;

import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class StructureContent {


	//Variables.
	private static Map<String, Boolean> validContent = new Hashtable<String, Boolean>() { {//In this Map, the 1st tagName can contain the 2nd tagName. The tagNames have been separated by the plus (+) symbol.

		put( StructureTagNames.simpleContentTagName + "+" + Annotation.annotationTagName, true );
		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.extensionTagName, true );
		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.restrictionTagName, true );

		put( StructureTagNames.restrictionTagName + "+" + Annotation.annotationTagName, true );

 		put( StructureTagNames.extensionTagName + "+" + Annotation.annotationTagName, true );

		put( StructureTagNames.complexContentTagName + "+" + Annotation.annotationTagName, true );
		put( StructureTagNames.complexContentCombinationTagName, true );

		put( StructureTagNames.allTagName + "+" + Annotation.annotationTagName, true );
		put( StructureTagNames.allTagName + "+" + ComponentTagNames.elementTagName, true );

		put( StructureTagNames.sequenceChoiceTagName + "+" + Annotation.annotationTagName, true );
		put( StructureTagNames.sequenceChoiceTagName + "+" + ComponentTagNames.elementTagName, true );
		put( StructureTagNames.sequenceChoiceTagName + "+" + ComponentTagNames.groupTagName, true );
		put( StructureTagNames.sequenceChoiceTagName + "+" + StructureTagNames.choiceTagName, true );
		put( StructureTagNames.sequenceChoiceTagName + "+" + StructureTagNames.sequenceTagName, true );
		put( StructureTagNames.sequenceChoiceTagName + "+" + ComponentTagNames.anyTagName, true );
	} };

	private static Map<String, Boolean> validContentBasedOnParentOfCurrentTagName = new Hashtable<String, Boolean>() { {//In this Map, the 1st tagName is the parent of the current tagName, the 2nd is the current tagName and the third is the next tagName.

 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.restrictionTagName + "+" + ComponentTagNames.simpleTypeTagName, true );
 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.restrictionTagName + "+" + StructureTagNames.restrictionFacetTagName, true );
 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.restrictionTagName + "+" + ComponentTagNames.attributeGroupTagName, true );
 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.restrictionTagName + "+" + ComponentTagNames.attributeTagName, true );
 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.restrictionTagName + "+" + ComponentTagNames.anyAttributeTagName, true );

 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.extensionTagName + "+" + ComponentTagNames.attributeGroupTagName, true );
 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.extensionTagName + "+" + ComponentTagNames.attributeTagName, true );
 		put( StructureTagNames.simpleContentTagName + "+" + StructureTagNames.extensionTagName + "+" + ComponentTagNames.anyAttributeTagName, true );

 		put( StructureTagNames.complexContentCombinationTagName + "+" + Annotation.annotationTagName, true );
		put( StructureTagNames.complexContentCombinationTagName + "+" + ComponentTagNames.groupTagName, true );
		put( StructureTagNames.complexContentCombinationTagName + "+" + StructureTagNames.allTagName, true );
		put( StructureTagNames.complexContentCombinationTagName + "+" + StructureTagNames.sequenceChoiceTagName, true );
		put( StructureTagNames.complexContentCombinationTagName + "+" + ComponentTagNames.attributeTagName, true );
		put( StructureTagNames.complexContentCombinationTagName + "+" + ComponentTagNames.attributeGroupTagName, true );
		put( StructureTagNames.complexContentCombinationTagName + "+" + ComponentTagNames.anyAttributeTagName, true );
	} };


	//Verifiers.
	static boolean isContent( String parentOfCurrentTagName, String currentTagName, String nextTagName, String parentOfNextTagName ){

		if( isInValidContents( currentTagName, nextTagName ) && parentOfNextTagName != null && parentOfNextTagName.equals( currentTagName ) ) return true;

		return isInValidContentBasedOnParentOfCurrentTagName( parentOfCurrentTagName, currentTagName, nextTagName );
	}

	static boolean isInValidContents( String currentTagName, String nextTagName ){

		currentTagName = StructureTagNames.getComplexContentCombinationTagName( currentTagName, nextTagName ) != null ? StructureTagNames.getComplexContentCombinationTagName( currentTagName, nextTagName ) : currentTagName;

		currentTagName = StructureTagNames.getSequenceChoiceTagName( currentTagName );


		return MapGetter.existsStringKey( currentTagName, validContent ) || MapGetter.existsStringKey( currentTagName + "+" + nextTagName, validContent );
	}

	static boolean isInValidContentBasedOnParentOfCurrentTagName( String parentOfCurrentTagName, String currentTagName, String nextTagName ){

		currentTagName = StructureTagNames.getComplexContentCombinationTagName( parentOfCurrentTagName, currentTagName ) != null ? StructureTagNames.getComplexContentCombinationTagName( parentOfCurrentTagName, currentTagName ) : currentTagName;

		nextTagName = StructureTagNames.getSequenceChoiceTagName( nextTagName );

		nextTagName = StructureTagNames.getRestrictionFacetTagName( nextTagName );


		return MapGetter.existsStringKey( currentTagName + "+" + nextTagName, validContentBasedOnParentOfCurrentTagName ) || MapGetter.existsStringKey( parentOfCurrentTagName + "+" + currentTagName + "+" + nextTagName, validContentBasedOnParentOfCurrentTagName );
	}
}
