package org.ow2.choreos.schemaRepresentation.xml;

import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class StructureTagNames {


	//Variables.
	public final static String simpleContentTagName = "simpleContent",
	   						   complexContentTagName = "complexContent",

	   						   extensionTagName = "extension",
	   						   restrictionTagName = "restriction",

	   						   complexContentCombinationTagName = "complexContentCombination",//Artificial overall tag name!

	   						   allTagName = "all",
	   						   sequenceChoiceTagName = "sequenceChoice",//Artificial overall tag name!
	   						   sequenceTagName = "sequence",
	   						   choiceTagName = "choice",

	   						   listUnionTagName = "listUnion",//Artificial overall tag name!
	   						   listTagName = "list",
	   						   unionTagName = "union",

	   						   restrictionFacetTagName = "restrictionFacet",//Artificial overall tag name!
	   						   minInclusiveTagName = "minInclusive",
	   						   minExclusiveTagName = "minExclusive",
	   						   maxExclusiveTagName = "maxExclusive",
	   						   maxInclusiveTagName = "maxInclusive",
	   						   totalDigitsTagName = "totalDigits",
	   						   fractionDigitsTagName = "fractionDigits",
	   						   minLengthTagName = "minLength",
	   						   maxLengthTagName = "maxLength",
	   						   whiteSpaceTagName = "whiteSpace",
	   						   patternTagName = "pattern",
	   						   enumerationTagName = "enumeration",
	   						   lengthTagName = "length";

	final static Map<String, String> complexContentCombinationTagNames = new Hashtable<String, String>() { {
		 							 put( complexContentTagName + "-" + extensionTagName, complexContentCombinationTagName );
		 							 put( complexContentTagName + "-" + restrictionTagName, complexContentCombinationTagName );
	} };

	final static Map<String, String> sequenceChoiceTagNames = new Hashtable<String, String>() { {
		 							 put( sequenceTagName, sequenceChoiceTagName );
		 							 put( choiceTagName, sequenceChoiceTagName );
	} };

	final static Map<String, String> listUnionTagNames = new Hashtable<String, String>() { {
		 							 put( listTagName, listUnionTagName );
		 							 put( unionTagName, listUnionTagName );
	} };

	final static Map<String, String> restrictionFacetTagNames = new Hashtable<String, String>() { {
									 put( minInclusiveTagName, restrictionFacetTagName );
									 put( minExclusiveTagName, restrictionFacetTagName );
									 put( maxExclusiveTagName, restrictionFacetTagName );
									 put( maxInclusiveTagName, restrictionFacetTagName );
									 put( totalDigitsTagName, restrictionFacetTagName );
									 put( fractionDigitsTagName, restrictionFacetTagName );
									 put( minLengthTagName, restrictionFacetTagName );
									 put( maxLengthTagName, restrictionFacetTagName );
									 put( whiteSpaceTagName, restrictionFacetTagName );
									 put( patternTagName, restrictionFacetTagName );
									 put( enumerationTagName, restrictionFacetTagName );
									 put( lengthTagName, restrictionFacetTagName );
	} };

	private final static String[] tagNames = new String[] { simpleContentTagName, 
															complexContentTagName,
															allTagName,
															sequenceTagName,
															choiceTagName,
															extensionTagName,
															restrictionTagName,
															allTagName,
															sequenceTagName,
															choiceTagName,
															minInclusiveTagName,
															minExclusiveTagName,
															maxExclusiveTagName,
															maxInclusiveTagName,
															totalDigitsTagName,
															fractionDigitsTagName,
															minLengthTagName,
															maxLengthTagName,
															whiteSpaceTagName,
															patternTagName,
															enumerationTagName,
									   						lengthTagName
	};

	final static Map<String, Boolean> hasOrderedChildren = new Hashtable<String, Boolean>() { {
		 put( sequenceTagName, true );
	} };


	//Getters.
	static String[] getTagNames(){

		return tagNames;
	}

	static String getComplexContentCombinationTagName( String parentTagName, String currentTagName ){

		return MapGetter.existsStringKey( parentTagName + "-" + currentTagName, complexContentCombinationTagNames ) ? (String) MapGetter.getValueByStringKey( parentTagName + "-" + currentTagName, complexContentCombinationTagNames ) : null;
	}

	static String getSequenceChoiceTagName( String tagName ){

		return MapGetter.existsStringKey( tagName, sequenceChoiceTagNames ) ? (String) MapGetter.getValueByStringKey( tagName, sequenceChoiceTagNames ) : tagName;
	}

	static String getListUnionTagName( String tagName ){

		return MapGetter.existsStringKey( tagName, listUnionTagNames ) ? (String) MapGetter.getValueByStringKey( tagName, listUnionTagNames ) : tagName;
	}

	static String getRestrictionFacetTagName( String tagName ){

		return MapGetter.existsStringKey( tagName, restrictionFacetTagNames ) ? (String) MapGetter.getValueByStringKey( tagName, restrictionFacetTagNames ) : tagName;
	}

	static boolean hasOrderedChildren( String tagName ){

		return MapGetter.existsStringKey( tagName, hasOrderedChildren );
	}
}
