package org.ow2.choreos.schemaRepresentation.xml;

import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class XMLSchemaContent {


	//Variables.
	private static Map<String, Boolean> validContent = new Hashtable<String, Boolean>() { {//In this Map, the 1st tagName can contain the 2nd tagName. The tagNames have been separated by the plus (+) symbol.

		put( XMLSchema.schemaTagName + "+" + Annotation.annotationTagName, true );

		put( XMLSchema.schemaTagName + "+" + ComponentTagNames.simpleTypeTagName, true );

		put( XMLSchema.schemaTagName + "+" + ComponentTagNames.complexTypeTagName, true );

		put( XMLSchema.schemaTagName + "+" + ComponentTagNames.groupTagName, true );

		put( XMLSchema.schemaTagName + "+" + ComponentTagNames.attributeGroupTagName, true );

		put( XMLSchema.schemaTagName + "+" + ComponentTagNames.elementTagName, true );

		put( XMLSchema.schemaTagName + "+" + ComponentTagNames.attributeTagName, true );

	} };


	//Verifiers.
	static boolean isContent( String currentTagName, String nextTagName ){//Is content the nextTagName of the currentTagName?

		return isInValidContents( currentTagName, nextTagName );
	}

	static boolean isInValidContents( String currentTagName, String nextTagName ){

		return MapGetter.existsStringKey( currentTagName + "+" + nextTagName, validContent );
	}
}
