package org.ow2.choreos.schemaRepresentation.xml.completelyStructured;


/**
 * 
 * @author dathanas
 *
 */
public class Occurrences implements java.io.Serializable{


	//Variables.
	private static final long serialVersionUID = 1628034130973664407L;

	private int minOccurs;
	private int maxOccurs;

	private String constraintViolation;
	private boolean hasConstraintViolation;


	//Constructor.
	public Occurrences( String cMinOccurs, String cMaxOccurs ){

		hasConstraintViolation = false;

		minOccurs = setValue( "minOccurs", cMinOccurs );

		maxOccurs = setValue( "maxOccurs", cMaxOccurs );

		checkConstraint2();
	}


	//Constraint checkers.
	private String checkConstraint1( String kind, int value ){

		if( value < 0 ) return setConstraintViolation( "'" + kind + "': Error value." );

		return null;
	}

	private String checkConstraint2(){

		if( maxOccurs != -1 && minOccurs > maxOccurs ) return setConstraintViolation( "'minOccurs' value > 'maxOccurs' value." );

		return null;
	}


	//Setters.
	private String setConstraintViolation( String cConstraintViolation ){

		if( ! hasConstraintViolation && cConstraintViolation != null ){

			constraintViolation = cConstraintViolation;

			hasConstraintViolation = true;
		}

		return constraintViolation;
	}

	private int setValue( String kind, String occurs ){

		int value = -1;//It means that the 'minOccurs' or 'maxOccurs' attributes are not present.  

		if( occurs != null && ! occurs.isEmpty() ){

			try{

				value = Integer.parseInt( occurs );

				checkConstraint1( kind, value );
			}

			catch( NumberFormatException ex ){

				if( occurs.toLowerCase().equals("unbounded") && kind.equals( "maxOccurs" ) ) value = Integer.MAX_VALUE;

				else setConstraintViolation( "'" + kind + "': Error value." );
			}
		}

		return value;
	}


	//Getters.
	public boolean hasConstraintViolation(){

		return hasConstraintViolation;
	}

	public String getConstraintViolation(){

		return constraintViolation;
	}

	public int getMinOccurs(){

		return minOccurs;
	}

	public int getMaxOccurs(){

		return maxOccurs;
	}


	//Visualization.
	public String visualize() {

		String label = "";

		if( ! hasConstraintViolation ){

			if( minOccurs != -1 ){

				if( minOccurs < Integer.MAX_VALUE ) label += " minOccurs= '" + minOccurs + "'";

				else if( minOccurs == Integer.MAX_VALUE ) label += " minOccurs= 'unbounded'";
			}

			if( maxOccurs != -1 ){

				if( maxOccurs < Integer.MAX_VALUE ) label += " maxOccurs= '" + maxOccurs + "'";

				else if( maxOccurs == Integer.MAX_VALUE ) label += " maxOccurs= 'unbounded'";
			}
		}

		return label;
	}
}
