package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.element;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.ReferencedComponent;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.identityConstraint.IdentityConstraintController;


/**
 * 
 * @author dathanas
 *
 */
class ElementDeclaration extends Element {


	//Variables.
	private static final long serialVersionUID = -4569833479849053329L;


	//Constructor.
	ElementDeclaration( List<Map<String, String>> path, String cType, String typeKind, boolean isGlobal ){

		super( path, isGlobal );


		setReferencedComponent( new ReferencedComponent( cType, typeKind ) );
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( IdentityConstraintController.isIdentityConstraintKind( object ) ) addComponent( (Component) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\n1. Identity constraints: " + IdentityConstraintController.getFlatIdentityConstaintsKinds() + "\n2. Annotation" );
		}


		return this;
	}
}
