package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.element;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.dataType.DataTypeController;


/**
 * 
 * @author dathanas
 *
 */
class ElementDefinition extends Element {


	//Variables.
	private static final long serialVersionUID = -7866095506006863422L;


	//Constructor.
	ElementDefinition( List<Map<String, String>> path, boolean isGlobal ){

		super( path, isGlobal );
	}


	//Constraint checkers.
	private String checkConstraint( Object object ){

		String[] attributeNames = { "fixed", "default" };

		return ( hasFixedValue || hasDefaultValue ) && DataTypeController.isSimpleTypeKind( object ) ? ObjectConstraintsManipulation.setErrorAttribute ( this, attributeNames, "The 'fixed' and/or 'default' attribute requires the definition of an inline 'simpleType'" ) : null;
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( DataTypeController.isDataTypeKind( object ) && checkConstraint( object ) == null ) addComponent( (Component) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\n1. The dataTypes: " + DataTypeController.getFlatDataTypeKinds() + "\n2. Annotation" );
		}


		return this;
	}
}
