package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.group;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.ComponentTagNames;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.Occurrences;


/**
 * 
 * @author dathanas
 *
 */
class ElementGroupDeclaration extends GroupDeclaration {


	//Variables.
	private static final long serialVersionUID = -7960870666252315966L;

	private Occurrences occurs;


	//Constructor.
	ElementGroupDeclaration( List<Map<String, String>> path, String referencedComponent, String typeKind, boolean isGlobal ){

		super( path, referencedComponent, typeKind, isGlobal );


		occurs = new Occurrences( MapGetter.getValueByKeyToLowerCase( "minOccurs", getTagAttributes() ), MapGetter.getValueByKeyToLowerCase( "maxOccurs", getTagAttributes() ) );

		if( occurs.hasConstraintViolation() ) ObjectConstraintsManipulation.setErrorAttribute( this, "minOccurs/maxOccurs", occurs.getConstraintViolation() );
	}


	//Getters.
	public String getTagName(){

		return ComponentTagNames.groupTagName;
	}

	@SuppressWarnings("serial")
	public String getTag(){

		Map<String, String> exceptedKeys = new Hashtable<String, String>() { { put( SchemaRepresentationController.getTagNameKey(), SchemaRepresentationController.getTagNameKey() );
																			   put( "minOccurs", "minOccurs" );
																			   put( "maxOccurs", "maxOccurs" ); } };


		return getTagName() + MapPrinting.printSpaceSeparated( exceptedKeys, getTagAttributes() ) + occurs.visualize() + printMyOrderID();
	}
}
