package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listManipulation.ListGetters;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.ComplexTypeStructureController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.restrictionFacet.RestrictionFacetController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.simpleType.SimpleTypeStructureController;
import org.ow2.choreos.unknownClasses.UnknownClassesController;


/**
 * 
 * @author dathanas
 *
 */
public class StructureController {


	//Verifiers.
	public static boolean isStructureTagName( List<Map<String, String>> path ){

		String tagName = ListGetters.getLastListElementValue( SchemaRepresentationController.getTagNameKey(), path );


		if( ComplexTypeStructureController.isComplexTypeStructureTagName( path ) ) return true;

		if( RestrictionFacetController.isRestrictionFacetTagName( tagName ) ) return true;

		if( SimpleTypeStructureController.isSimpleTypeStructureTagName( path, tagName ) ) return true;


		return false;
	}

	public static boolean isStructureTagName( String tagName ){

		if( ComplexTypeStructureController.isComplexTypeStructureTagName( tagName ) ) return true;

		if( SimpleTypeStructureController.isSimpleTypeStructureTagName( tagName ) ) return true;

		if( RestrictionFacetController.isRestrictionFacetTagName( tagName ) ) return true;


		return false;
	}

	public static boolean isStructureKind( Object object ){

		if( SimpleTypeStructureController.isSimpleTypeStructureKind( object ) ) return true;

		if( ComplexTypeStructureController.isComplexTypeStructureKind( object ) ) return true;

		if( RestrictionFacetController.isRestrictionFacetKind( object ) ) return true;


		return false;
	}


	//Getters.
	public static Object getTagObject( List<Map<String, String>> path ){

		String tagName = ListGetters.getLastListElementValue( SchemaRepresentationController.getTagNameKey(), path );


		if( ComplexTypeStructureController.isComplexTypeStructureTagName( path ) ) return ComplexTypeStructureController.getTagObject( path );

		if( RestrictionFacetController.isRestrictionFacetTagName( tagName ) ) return RestrictionFacetController.getTagObject( path );

		if( SimpleTypeStructureController.isSimpleTypeStructureTagName( path, tagName ) ) return SimpleTypeStructureController.getTagObject( path );


		return UnknownClassesController.getUnknownTag( tagName, XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel() );
	}
}
