package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listManipulation.ListGetters;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapTransfomation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.composition.ComplexTypeCompositionController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.specialization.SpecializationController;
import org.ow2.choreos.unknownClasses.UnknownClassesController;


public class ComplexTypeStructureController {


	//Verifiers.
	public static boolean isComplexTypeStructureKind( Object object ){

		if( SpecializationController.isSpecializationKind( object ) ) return true;

		if( ComplexTypeCompositionController.isCompositionKind( object ) ) return true;


		return false;
	}

	public static boolean isComplexTypeStructureTagName( List<Map<String, String>> path ){

		String tagName = ListGetters.getLastListElementValue( SchemaRepresentationController.getTagNameKey(), path );


		if( SpecializationController.isSpecializationTagName( path ) ) return true;

		if( ComplexTypeCompositionController.isCompositionTagName( tagName ) ) return true;


		return false;
	}

	public static boolean isComplexTypeStructureTagName( String tagName ){

		if( SpecializationController.isSpecializationTagName( tagName ) ) return true;

		if( ComplexTypeCompositionController.isCompositionTagName( tagName ) ) return true;


		return false;
	}


	//Getters.
	public static Object getTagObject( List<Map<String, String>> path ){

		String tagName = ListGetters.getLastListElementValue( SchemaRepresentationController.getTagNameKey(), path );


		if( SpecializationController.isSpecializationTagName( tagName ) ) return SpecializationController.getTagObject( path );

		if( ComplexTypeCompositionController.isCompositionTagName( tagName ) ) return ComplexTypeCompositionController.getTagObject( path );


		return UnknownClassesController.getUnknownTag( tagName, XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel() );
	}

	public static Map<String, String> getComplexTypeStructureKinds(){

		return MapTransfomation.concat( SpecializationController.getSpecializationKinds(), ComplexTypeCompositionController.getComplexTypeCompositionKinds() );
	}

	public static String getFlatComplexTypeStructureKinds(){

		return MapPrinting.printCommaSeparated( MapTransfomation.concat( SpecializationController.getSpecializationKinds(), ComplexTypeCompositionController.getComplexTypeCompositionKinds() ) );
	}
}
