package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.composition;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.element.ElementController;


/**
 * 
 * @author dathanas
 *
 */
class All extends Composition {


	//Variables.
	private static final long serialVersionUID = 8882279716921916909L;


	//Constructor.
	protected All( List<Map<String, String>> path ){

		super( path );


		checkConstraint();
	}


	//Constraint checkers.
	private String checkConstraint(){

		if( getOccurs().getMinOccurs() != -1 && getOccurs().getMinOccurs() != 0 && getOccurs().getMinOccurs() != 1 ) return ObjectConstraintsManipulation.setErrorAttribute( this, "minOccurs", "Permissible values of the 'minOccurs' attribute in an 'all' compositor are 0 or 1.");

		if( getOccurs().getMaxOccurs() != -1 && getOccurs().getMaxOccurs() != 1 ) return ObjectConstraintsManipulation.setErrorAttribute( this, "maxOccurs", "Permissible value of the 'maxOccurs' attribute in an 'all' compositor is 1.");


		return null;
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( ElementController.isElementKind( object ) ) addComponent( (Component) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\n1. elements: " + ElementController.getFlatElementKinds() + "\n\n2. Annotation" );
		}


		return this;
	}
}
