package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.composition;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.Occurrences;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.element.ElementController;


/**
 * 
 * @author dathanas
 *
 */
abstract class Composition extends Structure {


	//Variables.
	private static final long serialVersionUID = 1914277456757722391L;

	private Occurrences occurs;


	//Constructor.
	protected Composition( List<Map<String, String>> path ){

		super( path );


		occurs = new Occurrences( MapGetter.getValueByKeyToLowerCase( "minOccurs", getTagAttributes() ), MapGetter.getValueByKeyToLowerCase( "maxOccurs", getTagAttributes() ) );

		if( occurs.hasConstraintViolation() ) ObjectConstraintsManipulation.setErrorAttribute( this, "minOccurs/maxOccurs", occurs.getConstraintViolation() );
	}


	//Getters.
	protected Occurrences getOccurs(){

		return occurs;
	}

	protected boolean hasElementDeclarations(){

		for( int i = 0; hasComponents() && i < getComponents().size(); ++i ) if( ElementController.isElementDeclarationKind( getComponents().get( i ) ) ) return true;

		return false;
	}

	protected List<Component> getElementDeclarations(){

		List<Component> elementDeclarations = null;

		for( int i = 0; hasComponents() && i < getComponents().size(); ++i )

			if( ElementController.isElementDeclarationKind( getComponents().get( i ) ) ){

				if( elementDeclarations == null ) elementDeclarations = new ArrayList<Component>();

				elementDeclarations.add( getComponents().get( i ) );
			}

		return elementDeclarations;
	}

	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		return (String) MapGetter.getValueByStringKey( SchemaRepresentationController.getTagNameKey(), getTagAttributes() );
	}

	@SuppressWarnings("serial")
	public String getTag(){

		Map<String, String> exceptedKeys = new Hashtable<String, String>() { { put( SchemaRepresentationController.getTagNameKey(), SchemaRepresentationController.getTagNameKey() );
																			   put( "minOccurs", "minOccurs" );
																			   put( "maxOccurs", "maxOccurs" ); } };


		return getTagName() + MapPrinting.printSpaceSeparated( exceptedKeys, getTagAttributes() ) + occurs.visualize() + printMyOrderID();
	}
}
