package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.composition;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.element.ElementController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.group.GroupController;


/**
 * 
 * @author dathanas
 *
 */
class SequenceOrChoice extends Composition {


	//Variables.
	private static final long serialVersionUID = -2179625803501726445L;


	//Constructor.
	protected SequenceOrChoice( List<Map<String, String>> path ){

		super( path );
	}


	//Constraint checkers.
	private String checkConstraints(){//It accumulates all the constraint checkers that are not called neither by the constructor nor by a setter!

		String constraintViolation =  null;


		return constraintViolation =  checkConstraint() != null ? constraintViolation : null;
	}

	private String checkConstraint(){//Checking for duplication in 'ElementDeclaration' objects.

		List<Component> elementDeclarations = null;

		for( int i = 0; hasElementDeclarations() && i < ( elementDeclarations = getElementDeclarations()).size(); ++i ){

			Component duplicatedElement = null;

			String name1 = elementDeclarations.get( i ).getName();

			String type1 = elementDeclarations.get( i ).getReferencedComponent().getType();

			if( ( duplicatedElement = lookUpInNestedCompositions( name1, type1 ) ) != null ){

				String[] attributeNames = { "name", "type" };

				return ObjectConstraintsManipulation.setErrorAttribute( elementDeclarations.get( i ), attributeNames, "Illegal duplication (same name but different type) of the: '" + elementDeclarations.get( i ).getTag() + "' with the: '" + ( (Component) duplicatedElement).getTag() + "'" );
			}
		}


		return null;
	}

	private Component lookUpInNestedCompositions( String name, String type ){//This function returns illegal duplication: same name but different type.

		Component element = null;

		for( int i = 0; hasStructures() && i < getStructures().size(); ++i ) if( ( element = ( (SequenceOrChoice) getStructures().get( i ) ).lookUpInElementDecls( name, type ) ) != null ) return element;

		return element;
	}

	private Component lookUpInElementDecls( String name1, String type1 ){//This function returns illegal duplication: same name but different type.

		if( name1 == null || type1 == null ) return null;


		List<Component> elementDeclarations = null;

		for( int i = 0; hasElementDeclarations() && i < ( elementDeclarations = getElementDeclarations()).size(); ++i ){

			Component element = elementDeclarations.get( i );

			String name2 = element.getName();

			String type2 = element.getReferencedComponent().getType();//PopupMessages.xmlPrint( "name1= " + name1 + " - type1= " + type1 + " - name2= " + name2 + " - type2= " + type2 );

			if( name2 != null && name1.equals( name2 ) && type2 != null && ! type1.equals( type2 ) ) return element;
		}

		return null;
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( ElementController.isElementKind( object ) || GroupController.isElementGroupKind( object ) ) addComponent( (Component) object );

			else if( ComplexTypeCompositionController.isSequenceOrChoiceKind( object ) ) addStructure( (Structure) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else{

				String message1 = "Valid content:\n1. For components, the elements: " + ElementController.getFlatElementKinds() + " and the element groups: " + GroupController.getFlatElementGroupKinds();

				String message2 = "\n2. For structures, the compositions: " + ComplexTypeCompositionController.getFlatSequenceOrChoiceKinds();

				String message3 = "\n3. Annotation";

				ObjectConstraintsManipulation.setConnectionError ( this, object, message1 + message2 + message3 );
			}
		}

		return this;
	}


	//Getters.
	public String getFinalConstraintViolation(){//It accumulates the constraints that are not called by the constructor.

		if( hasConstraintViolation() ) return getConstraintViolation();


		checkConstraints();


		return super.getFinalConstraintViolation();
	}
}
