package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.specialization;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.StructureTagNames;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.restrictionFacet.RestrictionFacetController;


/**
 * 
 * @author dathanas
 * This class models the complexContent of a complexType.
 */
class ComplexContent extends Specialization {


	//Variables.
	private static final long serialVersionUID = 7264832180291729171L;

	private boolean mixed;


	//Constructor.
	protected ComplexContent( List<Map<String, String>> path ){

		super( path );


		mixed = Boolean.parseBoolean( (String) MapGetter.getValueByStringKey( "mixed", getTagAttributes() ) );
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( SpecializationController.isComplexContentSpecializationKind( object ) && checkConstraint( object ) == null ) addStructure( (Structure) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n1. For structures, extension or restriction: " + RestrictionFacetController.getFlatFestrictionFacetKinds() + "\n2. Annotation" );
		}


		return this;
	}


	//Getters.
	public boolean isMixed(){

		return mixed;
	}

	public String getTagName(){

		return StructureTagNames.complexContentTagName;
	}
}

