package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.specialization;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.attribute.AttributeController;


/**
 * 
 * @author dathanas
 *
 */
abstract class SimpleContentSpecializationKind extends SpecializationKind {


	//Variables.
	private static final long serialVersionUID = -5046883277964356392L;


	//Constructor.
	protected SimpleContentSpecializationKind( List<Map<String, String>> path ){

		super( path );
	}


	//Constraint checkers.
	protected String checkConstraint3( Object object ){

		return AttributeController.isAnyAttributeKind( object ) && hasAnyAttribute() ? ObjectConstraintsManipulation.setConnectionError( this, object, "The '" + getTag() + "' cannot contain more than one anyAttributes" ) : null;
	}

	protected String checkConstraint4( Object object ){

		return hasAnnotation() ? ObjectConstraintsManipulation.setConnectionError( this, object, "The '" + getTag() + "' cannot contain more than one annotations" ) : null;
	}


	//Getters.
	private boolean hasAnyAttribute(){

		for( int i = 0; hasComponents() && i < getComponents().size(); ++i ) if( AttributeController.isAnyAttributeKind( getComponents().get( i ) ) ) return true;


		return false;
	}
}
