package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.specialization;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 * This class models the 'simpleContent' or 'complexContent' structure of complexTypes.
 */
abstract class Specialization extends Structure {


	//Variables.
	private static final long serialVersionUID = 8438534103864767052L;


	//Constructor.
	protected Specialization( List<Map<String, String>> path ){

		super( path );
	}


	//Constraint checkers.
	protected String checkConstraint( Object object ){

		return hasStructures() ? ObjectConstraintsManipulation.setConnectionError( this, object, "The '" + getTag() + "' cannot contain more than one structures") : null;
	}


	//Getters.
	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() ) + printMyOrderID();
	}
}
