package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.specialization;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.ReferencedComponent;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 *
 */
abstract class SpecializationKind extends Structure {


	 //Variables.
	private static final long serialVersionUID = 7249527535081226038L;


	//Constructor.
	protected SpecializationKind( List<Map<String, String>> path ){

		super( path );


		String base = (String) MapGetter.getValueByStringKey( "base", getTagAttributes() );

		addReferencedComponent( new ReferencedComponent( base, "base" ) );
	}


	//Getters.
	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		return (String) MapGetter.getValueByStringKey( SchemaRepresentationController.getTagNameKey(), getTagAttributes() );
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() ) + printMyOrderID();
	}
}
