package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.restrictionFacet;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;


/**
 * 
 * @author dathanas
 *
 */
class EnumeratedValueFacet extends FixedFacet {


	//Variables.
	private static final long serialVersionUID = 355376003483164191L;

	private String value;


	//Constructor.
	protected EnumeratedValueFacet( List<Map<String, String>> path ){

		super( path );


		String cValue = (String) MapGetter.getValueByStringKey( "value", getTagAttributes() );

		if( checkConstraint( cValue ) == null ) value = cValue;
	}


	//Constraint checkers.
	private String checkConstraint( String cValue ){

		if( cValue == null || ( cValue != null && cValue.isEmpty() ) ) return ObjectConstraintsManipulation.setEmptyAttribute( this, "value" );

		return ! cValue.equals( "collapse" ) && ! cValue.equals( "preserve" ) && ! cValue.equals( "replace" ) ? ObjectConstraintsManipulation.setErrorAttribute( this, "value", "whiteSpace value= 'collapse' | 'preserve' | 'replace'" ) : null;
	}


	//Getters.
	protected String getValue(){

		return value;
	}
}
