package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.restrictionFacet;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.StructureTagNames;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 *
 */
abstract class RestrictionFacet extends Structure {


	//Variables.
	private static final long serialVersionUID = 5111498608910637857L;


	//Constructor.
	protected RestrictionFacet( List<Map<String, String>> path ){

		super( path );
	}


	//Setters.
	public Object add( Object object ) {

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\nAnnotation" );
		}


		return this;
	}


	//Getters.
	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		String tagName = (String) MapGetter.getValueByStringKey( SchemaRepresentationController.getTagNameKey(), getTagAttributes() );


		if( tagName.equals( "mininclusive") ) tagName = StructureTagNames.minInclusiveTagName;

		else if( tagName.equals( "minexclusive") ) tagName = StructureTagNames.minExclusiveTagName;

		else if( tagName.equals( "maxexclusive") ) tagName = StructureTagNames.maxExclusiveTagName;

		else if( tagName.equals( "maxinclusive") ) tagName = StructureTagNames.maxInclusiveTagName;

		else if( tagName.equals( "totaldigits") ) tagName = StructureTagNames.totalDigitsTagName;

		else if( tagName.equals( "fractiondigits") ) tagName = StructureTagNames.fractionDigitsTagName;

		else if( tagName.equals( "minlength") ) tagName = StructureTagNames.minLengthTagName;

		else if( tagName.equals( "maxlength") ) tagName = StructureTagNames.maxLengthTagName;

		else if( tagName.equals( "whitespace") ) tagName = StructureTagNames.whiteSpaceTagName;


		getTagAttributes().put( SchemaRepresentationController.getTagNameKey(), tagName );


		return tagName;
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() ) + printMyOrderID();
	}
}
