package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.simpleType;

import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.ReferencedComponent;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.dataType.DataTypeController;


/**
 * 
 * @author dathanas
 *
 */
class List extends Structure {


	//Variables.
	private static final long serialVersionUID = 6210316007119536185L;

	public final static String tagName = "list";


	//Constructor.
	protected List( java.util.List<Map<String, String>> path ){

		super( path );


		String itemType = MapGetter.getValueByKeyToLowerCase( "itemType", getTagAttributes() );

		if( itemType != null && ! itemType.isEmpty() ) addReferencedComponent( new ReferencedComponent( itemType, "itemType" ) );
	}


	//Constraint checkers.
	private String checkConstraints(){//It accumulates all the constraint checkers that are not called neither by the constructor nor by a setter!

		String constraintViolation =  null;

		return ( ( constraintViolation =  checkConstraint1() ) != null ) ? constraintViolation : null;
	}

	private String checkConstraint1(){

		return ( ! hasSimpleType() && ! hasReferencedComponents() ) ? ObjectConstraintsManipulation.setContainmentError( this, getComponents() ) : null;
	}

	private String checkConstraint2( Object object ){

		return ( hasSimpleType() ) ? ObjectConstraintsManipulation.setConnectionError( this, object, "The '" + getTag() + "' cannot contain more than one simpleTypes") : null;
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( DataTypeController.isSimpleTypeKind( object ) && checkConstraint2( object ) == null ) addComponent( (Component) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\n1. the simpleTypes: " + DataTypeController.getFlatSimpleTypeKinds() + "\n2. Annotation" );
		}

		return this;
	}


	//Getters.
	public String getFinalConstraintViolation(){

		if( hasConstraintViolation() ) return getConstraintViolation();


		checkConstraints();//I accumulates the constraint checkers of this class.


		super.getFinalConstraintViolation();


		return getConstraintViolation();
	}

	private boolean hasSimpleType(){

		for( int i = 0; hasComponents() && i < getComponents().size(); ++i ) if( DataTypeController.isSimpleTypeKind( getComponents().get( i ) ) ) return true;

		return false;
	}

	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		return tagName;
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() ) + printMyOrderID();
	}
}
