package org.ow2.choreos.schemaRepresentation.xml.completelyUnstructured;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.classInfo.ClassInfo;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyUnstructured.component.ComponentController;
import org.ow2.choreos.unknownClasses.UnknownClassesController;


/**
 * 
 * @author dathanas
 *
 */
public class XMLCompletelyUnstructuredSchemaRepresentationController {


	//Verifiers.
	public static boolean isComponentKind( String objectKind ){

		return ComponentController.isComponentKind( objectKind );
	}

	public static boolean isComponentKind( Object object ){

		return ComponentController.isComponentKind( object );
	}


	//Getters.
	public static Object getObject( List<Map<String, String>> path, String sourceObjectKind, String sourceSchemaRepresentationModel, String targetObjectKind, boolean isGlobal ){//This function is used during transformation.

		String sourceObjectKinds[] = { sourceObjectKind };

		if( isComponentKind( targetObjectKind ) ) return ComponentController.getObject( sourceObjectKinds, path, sourceSchemaRepresentationModel, targetObjectKind, isGlobal );


		String targetObjectKinds[] = { targetObjectKind };

		return UnknownClassesController.getUnknownObject( sourceObjectKinds, sourceSchemaRepresentationModel, targetObjectKinds, XMLSchemaRepresentationController.getCompletelyUnstructuredSchemaRepresentation() );
	}


	//Setters.
	public static Object add( Object internal, Object external ){

		PrintMessages.print( PrintMessages.controllerPrint, "UnstructuredSchemaRepresentationController: Set the internal= " + ClassInfo.getClass( internal ) + " to external= " + ClassInfo.getClass( external ));


		if( ComponentController.isComponentKind( external ) ) return ( (Component) external).add( internal );


		return external;
	}
}
