package org.ow2.choreos.schemaRepresentation.xml.completelyUnstructured.component.dataType;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.ReferencedComponent;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 *
 */
class BuiltInType extends Component {


	//Variables.
	private static final long serialVersionUID = -8320519217823651443L;

	public final static String tagName = "builtInType";


	//Constructor.
	protected BuiltInType( List<Map<String, String>> path, boolean isGlobal ){

		super( path, isGlobal );


		String type = MapGetter.getValueByKeyToLowerCase( "type", getTagAttributes() );

		String base = MapGetter.getValueByKeyToLowerCase( "base", getTagAttributes() );

		String itemType = MapGetter.getValueByKeyToLowerCase( "itemtype", getTagAttributes() ); PrintMessages.print( PrintMessages.transformationPrint, "type= " + type + " - base= " + base + " - itemType= " + itemType );


		if( type != null ) setReferencedComponent( new ReferencedComponent( type, "type", true ) );

		if( base != null ) setReferencedComponent( new ReferencedComponent( base, "base", true ) );

		if( itemType != null ) setReferencedComponent( new ReferencedComponent( itemType, "itemType", true ) );
	}


	//Setters.
	public Object add( Object object ){

		ObjectConstraintsManipulation.setConnectionError( this, object );


		return this;
	}


	//Getters.
	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getCompletelyUnstructuredSchemaRepresentation();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		return tagName;
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() );
	}
}
