package org.ow2.choreos.schemaRepresentation.xml.completelyUnstructured.component.dataType;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.classInfo.ClassInfo;
import org.ow2.choreos.dataStructures.list.listManipulation.ListGetters;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.unknownClasses.UnknownClassesController;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class DataTypeController {


	//Variables.
	private static Map<String, String> dataTypeKinds = new Hashtable<String, String>() { { put( "ComplexType", "ComplexType" ); put( "BuiltInType", "BuiltInType" ); } };


	//Verifiers.
	public static boolean isDataTypeKind( Object object ){

		return MapGetter.objectNameBelongsToMapStrings( object, dataTypeKinds );
	}

	public static boolean isComplexTypeKind( String objectKind ){

		return objectKind != null && objectKind.equals( "ComplexType" ) ? true : false;
	}

	public static boolean isBuiltInTypeKind( String objectKind ){

		return objectKind != null && objectKind.equals( "BuiltInType" ) ? true : false;
	}

	public static boolean isDataTypeKind( String objectKind ){

		return MapGetter.keyBelongsToMapStrings( objectKind, dataTypeKinds );
	}


	//Getters.
	public static Object getObject( List<Map<String, String>> path, String[] sourceObjectKinds, String sourceSchemaRepresentationModel, String targetObjectKind, boolean isGlobal ){

		Map<String, String> tagAttributes = ListGetters.getLastListElement( path );


		if( isComplexTypeKind( targetObjectKind ) ){

			tagAttributes.put( SchemaRepresentationController.getTagNameKey(), ComplexType.tagName );


			return new ComplexType( path, isGlobal );
		}

		if( isBuiltInTypeKind( targetObjectKind ) ){

			tagAttributes.put( SchemaRepresentationController.getTagNameKey(), BuiltInType.tagName );


			return new BuiltInType( path, isGlobal );
		}


		String[] targetObjectKinds = null;

		if( targetObjectKind != null ){

			String[] tmpTargetObjectKinds = { targetObjectKind };

			targetObjectKinds = tmpTargetObjectKinds;
		}

		return UnknownClassesController.getUnknownObject( sourceObjectKinds, sourceSchemaRepresentationModel, targetObjectKinds, XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel() );
	}

	public static String getFlatDataTypeKinds(){

		return MapPrinting.printCommaSeparated( dataTypeKinds );
	}

	public static String getTag( Object object ){

		if( isDataTypeKind( object ) ) return ( (ComplexType) object).getTag();


		return ClassInfo.getClass( object );
	}
}
