package org.ow2.choreos.serviceRepresentation.nonFunctional;

import java.util.ArrayList;
import java.util.List;
import javax.swing.tree.DefaultMutableTreeNode;


public class DocOfNonFuncProperties {


	//Variables.
	private String ref2DocOfNonFuncProperties;

	private QualityProperties qualityProperties;
	private List<NonFuncDescription> nonFuncDescriptions;

	private String constraintViolation;
	private boolean hasConstraintViolation;


	//Constructor.
	public DocOfNonFuncProperties( String cRef2DocOfNonFuncProperties ){

		ref2DocOfNonFuncProperties = cRef2DocOfNonFuncProperties;

		hasConstraintViolation = false;
	}


	//Setters.
	public String setConstraintViolation( String cConstraintViolation ){

		if( ! hasConstraintViolation && cConstraintViolation != null ){

			constraintViolation = cConstraintViolation;

			hasConstraintViolation = true;
		}

		return constraintViolation;
	}

	public void addProperty( String property, ArrayList<String> domains ){

		if( qualityProperties == null ) qualityProperties = new QualityProperties();

		qualityProperties.add(property, domains);
	}

	public void addNonFuncDescription( NonFuncDescription nonFuncDescription ){

		if(nonFuncDescriptions == null) nonFuncDescriptions = new ArrayList<NonFuncDescription>();

		nonFuncDescriptions.add(nonFuncDescription);
	}

	//Getters.
	public boolean hasConstraintViolation(){

		return hasConstraintViolation;
	}

	public String getConstraintViolation(){

		return constraintViolation;
	}

	public String getRef2DocOfNonFuncProperties(){

		return ref2DocOfNonFuncProperties;
	}

	void freeNonFuncDescriptions(){//TODO: When it is cleared?

		nonFuncDescriptions = null;
	}

	public List<NonFuncDescription> getNonFuncDescriptions(){

		return nonFuncDescriptions;
	}

	public int getNumOfProperties(){

		if( qualityProperties != null ) return qualityProperties.getNumOfProperties();

		return 0;
	}

	public String getProperty( int index ){

		if( qualityProperties != null ) return qualityProperties.getProperty( index );

		return null;
	}

	public QualityProperties getQualityProperties(){

		return qualityProperties;
	}


	//Visualization.
	public DefaultMutableTreeNode visualizeRefsToDocs(){

        DefaultMutableTreeNode node = new DefaultMutableTreeNode( ref2DocOfNonFuncProperties );

		/*for(int i = 0; nonFuncDescriptions != null && i < nonFuncDescriptions.size(); ++i){

			DefaultMutableTreeNode child = nonFuncDescriptions.get(i).visualize();
			node.add(child);
		}*/

		return node;
    }

	public DefaultMutableTreeNode visualize(){

        DefaultMutableTreeNode node = new DefaultMutableTreeNode( ref2DocOfNonFuncProperties );


        for( int i = 0; nonFuncDescriptions != null && i < nonFuncDescriptions.size(); ++i ) node = nonFuncDescriptions.get( i ).visualizeDetailedNonFuncDescr( node );


		return node;
    }
}
