package org.ow2.choreos.serviceRepresentation.nonFunctional;

import java.util.Enumeration;
import java.util.Hashtable;
import javax.swing.tree.DefaultMutableTreeNode;


public class NonFuncDescription implements java.io.Serializable {


	//Variables.
	private static final long serialVersionUID = 5187250324871860589L;

	private String ref2Source;
	private String ref2DocOfFuncProperties;
	private String serviceTypeName;
	private String serviceInstanceName;
	private Hashtable<String, Double> propertiesValues;//The values are indexed by the properties!


	//Constructor.
	public NonFuncDescription(String ref2Source, String ref2DocOfFuncProperties, String serviceTypeName, String serviceInstanceName){

		this.ref2Source = ref2Source;
		this.ref2DocOfFuncProperties = ref2DocOfFuncProperties;
		this.serviceTypeName = serviceTypeName;
		this.serviceInstanceName = serviceInstanceName;
	}
	
	
	//Empty constructor used for xml transformation
	public NonFuncDescription(){
			
	}


	//Getters.
	public String getRef2Source(){

		return ref2Source;
	}

	public String getRef2DocOfFuncProperties(){

		return ref2DocOfFuncProperties;
	}

	public String getServiceTypeName(){

		return serviceTypeName;
	}

	public String getServiceInstanceName(){

		return serviceInstanceName;
	}

	public Double getValue(String property){

		return propertiesValues != null ? propertiesValues.get(property) : null;
	}

	public Hashtable<String, Double> getPropertiesValues(){

		return propertiesValues;
	}

	//Setters.
	public void addPropertyAndValue( String property, Double value ){

		if( propertiesValues == null ) propertiesValues = new Hashtable<String, Double>();

		propertiesValues.put(property, value);
	}


	//Visualization.
	public DefaultMutableTreeNode visualize(){//This class is used by the 'Visualizer' class.

		DefaultMutableTreeNode node = new DefaultMutableTreeNode("Non-functional description");

		node = visualizeProperties( node );

    	return node;
	}

	public DefaultMutableTreeNode visualizeDetailedNonFuncDescr(DefaultMutableTreeNode node){
		DefaultMutableTreeNode node1 = new DefaultMutableTreeNode("Document: " + ref2DocOfFuncProperties);
		node.add(node1);

		DefaultMutableTreeNode node2;
		DefaultMutableTreeNode node3;

		if(serviceTypeName == null && serviceInstanceName == null) node1 = visualizeProperties(node1);

		else if(serviceTypeName != null && serviceInstanceName == null){
			node2 = new DefaultMutableTreeNode("Service type: " + serviceTypeName);
			node1.add(node2);

			node2 = visualizeProperties(node2);
		}

		else if( serviceTypeName != null && serviceInstanceName != null ){
			node2 = new DefaultMutableTreeNode("Service type: " + serviceTypeName);
			node1.add(node2);

			node3 = new DefaultMutableTreeNode("Service instance: " + serviceInstanceName);
			node2.add(node3);

			node3 = visualizeProperties(node3);
		}

    	return node;
	}

	private DefaultMutableTreeNode visualizeProperties( DefaultMutableTreeNode node ){

		if( propertiesValues == null ) return null;

    	for (Enumeration<String> e = propertiesValues.keys(); e.hasMoreElements();){

    		String i = e.nextElement();

            DefaultMutableTreeNode child = new DefaultMutableTreeNode(i + "= " + propertiesValues.get(i));
    		node.add(child);
    	}

    	return node;
	}
	
	//Setters used for xml transformation
	
	public void setxRef2Source( String cRef2Source ){
		ref2Source = cRef2Source;
	}
			
	public void setxRef2DocOfFuncProperties( String cRef2DocOfFuncProperties ){
		ref2DocOfFuncProperties = cRef2DocOfFuncProperties;
	}
			
	public void setxServiceTypeName( String cServiceTypeName ){
		serviceTypeName = cServiceTypeName;
	}
			
	public void setxServiceInstanceName( String cServiceInstanceName ){
		serviceInstanceName = cServiceInstanceName;
	}
			
	public void setxPropertiesValues( Hashtable<String, Double> cPropertiesValues ){
		propertiesValues = cPropertiesValues;
	}
			
	//Getters used for xml transformation
			
	public String getxRef2Source(){
		return ref2Source;
	}
			
	public String getxRef2DocOfFuncProperties(){
		return ref2DocOfFuncProperties;
	}
			
	public String getxServiceTypeName(){
		return serviceTypeName;
	}
			
	public String getxServiceInstanceName(){
		return serviceInstanceName;
	}
			
	public Hashtable<String, Double> getxPropertiesValues(){
		return propertiesValues;
	}
}
