package abstractionDrivenServiceOrganizationTesting;

import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.junit.Test;
import org.ow2.choreos.abstractionBase.AbstractionBaseController;
import org.ow2.choreos.abstractionBase.Hierarchy;
import org.ow2.choreos.abstractionBase.IndependentHierarchies;
import org.ow2.choreos.abstractionDrivenServiceOrganization.ServiceOrganizationController;
import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.gui.ServiceOrganizationVisualizer;
import org.ow2.choreos.serviceRegistration.ServiceRegistration;


/**
 * 
 * @author dathanas
 * TODO
 */
public class ServiceOrganizationTester {


	//Variables.
	@SuppressWarnings("serial")
	private static Map<String, ArrayList<String>> inputServiceSources = new Hashtable<String, ArrayList<String>>() { {

		put( "Local File System",  new ArrayList<String>() { { add( "src/test/resources/SMSServices" );
														   } } 
		   );
																													} };

																													
	//Methods.
	private static boolean checkHierarchyPostCondition( int totalNumberOfServiceInterfaces, int totalNumberOfServiceInstances, Hierarchy hierarchy ){

		if( hierarchy != null ){

			int mode = hierarchy.getMode();

			if( mode == 3 ){

				int numOfUnrepresentedInterfaces = ( (IndependentHierarchies) hierarchy).getTotalNumOfUnrepresentedInterfaces();//System.out.println( "numOfUnrepresentedInterfaces= " + numOfUnrepresentedInterfaces ); 

				int numOfRepresentedInterfaces = ( (IndependentHierarchies) hierarchy).getTotalNumOfRepresentedInterfaces();//System.out.println( "numOfRepresentedInterfaces= " + numOfRepresentedInterfaces );

				int numOfUnrepresentedInstances = ( (IndependentHierarchies) hierarchy).getTotalNumOfUnrepresentedInstances();//System.out.println( "numOfUnrepresentedInstances= " + numOfUnrepresentedInstances ); 

				int numOfRepresentedInstances = ( (IndependentHierarchies) hierarchy).getTotalNumOfRepresentedInstances();//System.out.println( "numOfRepresentedInstances= " + numOfRepresentedInstances );

				if( numOfUnrepresentedInterfaces + numOfRepresentedInterfaces == totalNumberOfServiceInterfaces /*&& numOfUnrepresentedInstances + numOfRepresentedInstances == totalNumberOfServiceInstances*/ ) return true;
			}
		}


		return false;
	}


	@Test
	public void organize() {

		ServiceRegistration serviceRegistration = null;


		for( Enumeration<String> i = ( (Hashtable<String, ArrayList<String>>) inputServiceSources ).keys(); i.hasMoreElements(); ){

			String pluginKind = i.nextElement();

			List<String> refs2Sources = inputServiceSources.get( pluginKind );


			if( serviceRegistration == null ) serviceRegistration = new ServiceRegistration();


			for( int j = 0; j < refs2Sources.size(); ++j ){

				int expectedNumOfDocsOfFuncProperties = serviceRegistration.getNumOfDocsOfFuncProperties( pluginKind, refs2Sources.get( j ) );

				int actualNumOfDocsOfFuncProperties = serviceRegistration.register( pluginKind, refs2Sources.get( j ) );


				//Successful parsing condition. 
				assertTrue( actualNumOfDocsOfFuncProperties == expectedNumOfDocsOfFuncProperties );//This is condition that should hold for having successfully parsing the documents.
			}


			int currentCollectionID = serviceRegistration.getCurrentCollectionID();

			UserSettings userSettings = new UserSettings( currentCollectionID );

			AbstractionBaseController abstractionBase = new AbstractionBaseController( serviceRegistration );

			ServiceOrganizationController serviceOrganization = new ServiceOrganizationController();


			for( int mode = 3; mode <= 3; mode++ ){

				userSettings.setMode( mode );

				ServiceOrganizationVisualizer serviceOrganizationVisualizer = new ServiceOrganizationVisualizer( serviceRegistration, abstractionBase, serviceOrganization, userSettings ); serviceOrganizationVisualizer.setVisible( true );

				int totalNumberOfServiceInterfaces = serviceRegistration.getNumOfInterfaces( currentCollectionID );

				int totalNumberOfServiceInstances = serviceRegistration.getNumOfInstances( currentCollectionID );


				Hierarchy hierarchy = serviceOrganizationVisualizer.produce( mode, true );

				assertTrue( checkHierarchyPostCondition( totalNumberOfServiceInterfaces, totalNumberOfServiceInstances, hierarchy ) );
			}
		 }
	 }
}
