package parserTesting;

import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.junit.Test;
import org.ow2.choreos.pluginManager.Objects;
import org.ow2.choreos.pluginManager.PluginManager;


/**
 * 
 * @author dathanas
 * TODO
 */
public class ParserTester {


	//Variables.
	@SuppressWarnings("serial")
	private static Map<String, ArrayList<String>> inputServiceSources = new Hashtable<String, ArrayList<String>>() { {

		put( "Local File System",  new ArrayList<String>() { { add( "src/test/resources/SMSServices" );
														   } } 
		   );
																													} };


	 @Test
	 public void parse() {

		 PluginManager pluginManager = null;


		 for( Enumeration<String> i = ( (Hashtable<String, ArrayList<String>>) inputServiceSources ).keys(); i.hasMoreElements(); ){

			 String pluginKind = i.nextElement();

			 List<String> refs2Sources = inputServiceSources.get( pluginKind );

			 if( pluginManager == null ) pluginManager = new PluginManager();


			 for( int j = 0; j < refs2Sources.size(); ++j ){

				 int expectedNumOfDocuments = pluginManager.getNumOfDocuments( pluginKind, refs2Sources.get( j ) );

				 Objects objects = pluginManager.retrieve( pluginKind, refs2Sources.get( j ) );


				 int actualNumOfDocuments = 0;

				 if( objects != null && objects.getDocsOfFuncProperties() != null ) actualNumOfDocuments = objects.getDocsOfFuncProperties().size();

				 assertTrue( expectedNumOfDocuments == actualNumOfDocuments );
			 }
		 }
	 }
}
