/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package org.ow2.choreos.executable_service_discovery.DummyActiveRegistry;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ConnectionAcceptThread extends Thread {
    private int PORT;
    ServerSocket serverSock;
    private Logger logger;
    
    public ConnectionAcceptThread(int port) {
    	logger = LoggerFactory.getLogger(ConnectionAcceptThread.class);
        PORT = port;
    }
    
    @Override
    public void run() {
        try {
            serverSock = new ServerSocket(PORT);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        while(!this.isInterrupted()) {
            try {
                Socket connectionSock = serverSock.accept();
                logger.info("New connection: " + 
                        connectionSock.getRemoteSocketAddress().toString());
                
                Registry.getInstance().getNewConnectionQ().offer(connectionSock);
            } catch (IOException ex) {
                logger.error("exception: "+ex.toString());
            }
        }
    }
    
    public void kill() {
        logger.info("Killing thread");
        if(this.isAlive()) {
            this.interrupt();
            try {
                serverSock.close();
            } catch(IOException ex) {
                /**/
            }
        }
    }
}
