/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package org.ow2.choreos.executable_service_discovery.DummyActiveRegistry;

public class Main {

    public static void main(String[] args) {
        if(args.length != 3)
            showHelp();
        
        String path = args[0];
        long millis = Integer.parseInt(args[1]);
        int port = Integer.parseInt(args[2]);
        
        Runtime.getRuntime().addShutdownHook(new ShutDownHook());
        Registry.getInstance().start(millis, path, port);

        try {
            Registry.getInstance().getConnectionAcceptThread().join();
        } catch(InterruptedException e) {
            System.out.println("AcceptThread interrupted");
        }
    }
    
    private static void showHelp() {
        System.out.println("Usage: registry <ServicesDirPath> <DirRefreshMillis> <ServerPort>");
        System.exit(0);
    }
}
