/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package org.ow2.choreos.executable_service_discovery.DummyActiveRegistry;

import java.io.StringWriter;


import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;


public class RegistryMessage {
    private char messageFlag;
    private String name;
    private String md5hash;
    private String wsdl;
    private static Logger logger;
    
    public RegistryMessage(char messageFlag, String name, String md5hash, String wsdl) {
        this.messageFlag = messageFlag;
        this.name = name;
        this.md5hash = md5hash;
        this.wsdl = wsdl;
    }
    
    public char getMessageFlag() {
        return messageFlag;
    }
    public String getWsdl() {
        return wsdl;
    }
    public String getMd5hash() {
        return md5hash;
    }
    public String getName() {
    	return name;
    }
    
    public static String getMsg(String msgtype, String name, String md5hash, String wsdl) {
    	logger = LoggerFactory.getLogger(RegistryMessage.class);
        try {
            DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
 
			// root elements
			Document doc = docBuilder.newDocument();
			Element rootElement = doc.createElement("registrymsg");
			doc.appendChild(rootElement);
 
			// type element
			Element type = doc.createElement("msgtype");
        	type.appendChild(doc.createTextNode(msgtype));
        	rootElement.appendChild(type);
                
            // servicename element
            Element servicename = doc.createElement("servicename");
            servicename.appendChild(doc.createTextNode(name));
            rootElement.appendChild(servicename);

            // hash element
            Element hash = doc.createElement("hash");
            hash.appendChild(doc.createTextNode(md5hash));
            rootElement.appendChild(hash);

            // servicedescription element
            Element servicedescription = doc.createElement("servicedescription");
            servicedescription.appendChild(doc.createCDATASection(wsdl));
            rootElement.appendChild(servicedescription);
                
			// write the content into xml file
			TransformerFactory transformerFactory = TransformerFactory.newInstance();
			Transformer transformer = transformerFactory.newTransformer();
			DOMSource source = new DOMSource(doc);
            StringWriter str = new StringWriter();
                
            StreamResult result = new StreamResult(str);

            transformer.transform(source, result);
            return str.toString();

        } catch (TransformerConfigurationException ex) {
        	logger.error("error with transformer: "+ex.toString());
        } catch (ParserConfigurationException ex) {
        	logger.error("error with parserconf: "+ex.toString());
        } catch (TransformerException ex) {
        	logger.error("error with transformer: "+ex.toString());
        }
            
            
        return "";
    }
}
