/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package org.ow2.choreos.executable_service_discovery.DummyPlugin;

import org.ow2.choreos.executable_service_discovery.plugin_manager.CommonServiceDescription;
import org.ow2.choreos.executable_service_discovery.plugin_manager.PluginManager;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.Socket;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RegistryListener implements Runnable {

    private Socket sock;
    private BufferedReader bin;
    private Logger logger;
    private DummyPlugin plugin;
    
    public RegistryListener(DummyPlugin plugin) {
        this.plugin = plugin;
        logger = LoggerFactory.getLogger(RegistryListener.class);
    }
    
    public RegistryListener(DummyPlugin plugin, Socket sock) {
        this.plugin = plugin;
        this.sock = sock;
        logger = LoggerFactory.getLogger(RegistryListener.class);
    }
    
    @Override
    public void run() {
        logger.info("Inside run() of RegistryListener");
        int ch;
        try {
            if(sock == null)
                sock = new Socket(plugin.getAddr(), plugin.getPort());
            
            bin = new BufferedReader(new InputStreamReader(sock.getInputStream()));
            ch = bin.read();
        } catch (IOException ex) {
            logger.error(ex.getMessage());
            // logger.info("spawning RegistryReconnect thread...");
            // plugin.getThreadPoolExecutor().execute(new RegistryReconnect(plugin));
            return;
        }
        StringBuffer buf = new StringBuffer();
        while(ch != -1) {
            buf.append((char)ch);
            if(buf.toString().contains("</registrymsg>")) { /* received one full msg */
                InputStream inn = new ByteArrayInputStream(buf.toString().getBytes());
                int res = XMLParser.parse(inn);
                
                if(res != 0) //new or update
                    PluginManager.getInstance().register(new CommonServiceDescription(), 
                        plugin.getRegistryURI());
                else //deleted
                    PluginManager.getInstance().unregisterByServiceURI("someserviceURI", 
                            plugin.getRegistryURI());
                
               
                buf.delete(0, buf.length());
            }
            try {
                ch = bin.read();
            } catch (IOException ex) {
                logger.error(ex.getMessage());
                // logger.info("spawning RegistryReconnect thread...");
                // plugin.getThreadPoolExecutor().execute(new RegistryReconnect(plugin));
                return;
            }
        }
    }

    public Socket getSocket() {
        return sock;
    }
}
