/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package org.ow2.choreos.executable_service_discovery.DummyPlugin;

import java.io.IOException;
import java.net.Socket;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RegistryReconnect implements Runnable {

    private Logger logger;
    private DummyPlugin plugin;
    
    public RegistryReconnect(DummyPlugin plugin) {
        logger = LoggerFactory.getLogger(RegistryReconnect.class);
        this.plugin = plugin;
        logger.info("Created RegistryReconnect thread");
    }
    
    @Override
    public void run() {
        while(true) {
            Socket sock = null;
            try {
                Thread.sleep(1000);
                sock = new Socket(plugin.getAddr(), plugin.getPort());
            } catch (InterruptedException ex) {
                logger.error(ex.getMessage());
                return;
            } catch (IOException ex) {
                    logger.error(ex.getMessage());
            }
            
            if(sock != null && sock.isConnected()) {
                logger.info("Connected! Respawning RegistryLister thread...");
                RegistryListener listener_thread = new RegistryListener(plugin, sock);
                plugin.getThreadPoolExecutor().execute(listener_thread);
                plugin.setListenerThread(listener_thread);
                return;
            }
        }
    }
}
