package org.ow2.choreos.executable_service_discovery.plugin_manager;

import java.util.HashMap;
import java.util.HashSet;

public class TargetEnvironment {
    private HashMap<String, HashSet<String>> targetPlugins;
    
    
    public TargetEnvironment() {
        targetPlugins = new HashMap<String, HashSet<String>>();
    }
    
    public void addPluginType(String pluginType) {
        if(!targetPlugins.containsKey(pluginType))
            targetPlugins.put(pluginType, new HashSet<String>());
    }
    public void addPluginInstance(String pluginType, String registryURI) {
        if(targetPlugins.containsKey(pluginType)) {
            HashSet<String> pluginInstances = targetPlugins.get(pluginType);
            pluginInstances.add(registryURI);
        }
    }
    
    public HashMap<String, HashSet<String>> getTargetEnvironment() {
        return targetPlugins;
    }
}
