package org.ow2.choreos.execution.interfaces;

import java.util.ArrayList;
import java.util.HashMap;

import org.ow2.chereos.iots.common.Location;
import org.ow2.chereos.iots.common.Service;
import org.ow2.choreos.iots.datatypes.SensorData;
import org.ow2.choreos.query.impl.SubQuery;
import org.ow2.choreos.sparqlfunctions.constants.Formula;




public interface ExecutionGenerator {
/**
 * This method is called by the expansion manager to request measurements provided by services based 
 * on expanded queries and their corresponding functions (if any)
 * @param servicesToAccess: the list of services to access
 * @param queriesAndFunctions: the substitute queries that can replace the initial query and their corresponding
 * mathematical functions that will be used to compute the concepts of interest
 * @return a HashMap containing the address of the service and its measurement. It should be noted that the method
 * returns one measurement per service, as for the moment we do not support historical data
 */
	public HashMap<String, HashMap<SensorData, Location>> getValues(ArrayList<Service> servicesToAccess) ;
}
